/*
 * (C) Copyright 2001-2006 Hewlett-Packard Development Company, L.P.
 */

/**
 * DHTML doesn't show/hide recursively; it must be done manually. For now,
 * we only support two levels (i.e., one level of showing/hiding).
 */

/////////////////////////////////////////////////////////////////////////
// public

/**
 * nShow = 0 means toggle
 * nShow = 1 means expand
 * nShow = 2 means collapse
 */
function MxMenuToggle(szFn, szIdRoot, szId, nShow)
{
    var oRoot = document.getElementById(szIdRoot);
    var oDiv = document.getElementById('MXMENU_' + szId);
    var oImg = document.getElementById('IMXMENU_' + szId);
    if (oRoot == null || oDiv == null || oImg == null) return;

    var bShow = (oDiv.className == 'mxmenu-hide');
    if (nShow == 1) bShow = true;
    if (nShow == 2) bShow = false;

    oDiv.className = bShow ? 'mxmenu-show' : 'mxmenu-hide';
    if (bShow)
        oImg.src = oImg.src.replace('menu_open.gif', 'menu_close.gif');
    else
        oImg.src = oImg.src.replace('menu_close.gif', 'menu_open.gif');

    // repaint problem workaround for IE (a problem only if the
    // menu item has an image in it)
    if (bShow)
        p_MxMenuRepaint(oDiv);

    p_MxMenuCallChangeHandler(szFn, szIdRoot);
}

function MxMenuExpandAll(szIdRoot)
{
    p_MxMenuDoAll(szIdRoot, true);
}

function MxMenuCollapseAll(szIdRoot)
{
    p_MxMenuDoAll(szIdRoot, false);
}

/**
 * Generates a string-based list of open menu IDs. The string can be
 * fed into MxMenuReOpen() to reopen them.
 */
function MxMenuGetState(szIdRoot)
{
    var szList = "";

    var oDiv = document.getElementById(szIdRoot);
    var oMenus = oDiv.getElementsByTagName("DIV");
    for (var i = 0; i < oMenus.length; i++)
    {
        var oMenu = oMenus.item(i);
        if (oMenu.className == "mxmenu-cascade")
        {
            var oInner = document.getElementById('MXMENU_' + oMenu.id);
            if (oInner != null && oInner.className == 'mxmenu-show')
            {
                if (szList != "")
                    szList += ",";

                szList += oMenu.id;
            }
        }
    }

    return szList;
}

/**
 * Opens all menu IDs specified in the provided list.
 */
function MxMenuReopen(szIdRoot, szList)
{
    var szMenu = szList.split(",");
    for (var i = 0; i < szMenu.length; i++)
        MxMenuToggle("", szIdRoot, szMenu[i], 1);
}

/////////////////////////////////////////////////////////////////////////
// private

function p_MxMenuRepaint(e)
{
    var w = e.offsetWidth;
    if (w > 0)
    {
        e.style.width = w - 1;
        e.style.width = w;
    }
}

function p_MxMenuDoAll(szIdRoot, bShow)
{
    var oDiv = document.getElementById(szIdRoot);
    var oMenus = oDiv.getElementsByTagName("DIV");
    for (var i = 0; i < oMenus.length; i++)
    {
        var oMenu = oMenus.item(i);
        if (oMenu.className == "mxmenu-cascade")
            MxMenuToggle("", szIdRoot, oMenu.id, bShow ? 1 : 2);
    }
}

function p_MxMenuCallChangeHandler(szFn, szIdRoot)
{
    if (szFn != "")
        eval(szFn + "('" + szIdRoot + "')");
}
