/*
 * (C) Copyright 2001-2006 Hewlett-Packard Development Company, L.P.
 */

////////////////////////////////////////////////////////////
// Private

function p_MxTableGetDiv(szIdTable)
{
    var oDiv = null;
    var oTable = document.getElementById(szIdTable);
    if (oTable != null)
        oDiv = oTable.parentNode;

    return oDiv;
}

function p_MxTableSetWidth(e, w)
{
    if (e != null)
    {
        e.style.overflow = "auto";

        // first, we set the width, which doesn't do what we want
        e.style.width = w;

        // second, we adjust the width to what we really want it to be
        var err = e.offsetWidth - w;
        if (w >= err)
            e.style.width = w - err;
    }
}

function p_MxTableSetHeight(e, h)
{
    if (e != null)
    {
        e.style.overflow = "auto";

        // first, we set the height, which doesn't do what we want
        e.style.height = h;

        // second, we adjust the height to what we really want it to be
        var err = e.offsetHeight - h;
        if (h >= err)
            e.style.height = h - err;
    }
}

////////////////////////////////////////////////////////////
// DOM-heavy selection stuff

function p_MxTableSelectFirstTag(e, szTag)
{
    e = e.getElementsByTagName(szTag);
    if (e != null && e.length > 0)
        return e.item(0);

    return null;
}

//
// returns all rows, including the header
//
function p_MxTableGetAllRows(szIdTable)
{
    var oTable = document.getElementById(szIdTable);
    var e = p_MxTableSelectFirstTag(oTable, "TBODY");
    if (e == null) return;

    return e.getElementsByTagName("TR");
}

//
// 0 is the header row
//
function p_MxTableSelectRow(oRow, i, bSelect)
{
    // toggle the row style
    if (i > 0)
    {
        var szClass = ((i % 2) == 0) ? "mxtable-sel-0-even" : "mxtable-sel-0-odd";
        oRow.className = bSelect ? "mxtable-sel-1" : szClass;
    }

    // toggle the checkbox image (if any)
    var oTd = p_MxTableSelectFirstTag(oRow, "TD");

    var oImg = null;
    if (oTd != null)
        oImg = p_MxTableSelectFirstTag(oTd, "IMG");

    if (oImg != null)
    {
        if (oImg.src.indexOf("/images/check_") > 0)
        {
            if (bSelect)
                oImg.src = "<%=request.getContextPath()%>/images/check_1.gif";
            else
                oImg.src = "<%=request.getContextPath()%>/images/check_0.gif";
        }
    }
}

//
// 0 is the header row
//
function p_MxTableIsRowSelected(oRow, i)
{
    var bSelected = false;

    if (i == 0)
    {
        // header row is a special case
        var oTd = p_MxTableSelectFirstTag(oRow, "TD");

        var oImg = null;
        if (oTd != null)
            oImg = p_MxTableSelectFirstTag(oTd, "IMG");

        if (oImg != null)
            bSelected = (oImg.src.indexOf("check_1") >= 0);
    }
    else
    {
        // handle the non-header-row case
        bSelected = (oRow.className == "mxtable-sel-1");
    }

    return bSelected;
}

function p_MxTableSelectSingle(szIdTable, szId)
{
    var oRows = p_MxTableGetAllRows(szIdTable);
    for (var i = 1; i < oRows.length; i++)
    {
        var oRow = oRows.item(i);
        p_MxTableSelectRow(oRow, i, (oRow.id == szId));
    }
}

function p_MxTableSelectMulti(szIdTable, szId)
{
    var bItemSelected = false;
    var bAllSelOn = false;

    var oRows = p_MxTableGetAllRows(szIdTable);
    for (var i = 1; i < oRows.length; i++)
    {
        var oRow = oRows.item(i);
        var bSelected = p_MxTableIsRowSelected(oRow, i);
        if (oRow.id == szId)
        {
            bSelected = !bSelected;
            bItemSelected = bSelected;
        }

        if (i == 1)
            bAllSelOn = bSelected;
        else
            bAllSelOn = bAllSelOn && bSelected;

        if (oRow.id == szId)
            p_MxTableSelectRow(oRow, i, bSelected);
    }

    p_MxTableSelectRow(oRows.item(0), 0, bAllSelOn);
    return bItemSelected;
}

function p_MxTableCallChangeHandler(szFn, szIdTable, szId, bSelected)
{
    if (szFn != "")
        eval(szFn + "('" + szIdTable + "', '" + szId + "', " + bSelected + ")");
}

////////////////////////////////////////////////////////////
// Selections (private)

function p_MxTableOnClickSingle(szFn, szIdTable, szId)
{
    p_MxTableSelectSingle(szIdTable, szId);
    p_MxTableCallChangeHandler(szFn, szIdTable, szId, true);
}

function p_MxTableOnClickMulti(szFn, szIdTable, szId)
{
    var bSelected = p_MxTableSelectMulti(szIdTable, szId);
    p_MxTableCallChangeHandler(szFn, szIdTable, szId, bSelected);
}

function p_MxTableClickAll(szFn, szIdTable)
{
    var oRow = p_MxTableGetAllRows(szIdTable).item(0);
    var bState = p_MxTableIsRowSelected(oRow, 0);

    MxTableSelectAll(szIdTable, !bState);
    p_MxTableCallChangeHandler(szFn, szIdTable, "_all_", !bState);
}

////////////////////////////////////////////////////////////
// Selections (public)

function MxTableSelectAll(szIdTable, bState)
{
    var oRows = p_MxTableGetAllRows(szIdTable);
    for (var i = 0; i < oRows.length; i++)
        p_MxTableSelectRow(oRows.item(i), i, bState);
}

function MxTableGetSelectionCount(szIdTable)
{
    var n = 0;
    var oRows = p_MxTableGetAllRows(szIdTable);
    for (var i = 1; i < oRows.length; i++)
    {
        var oRow = oRows.item(i);
        if (p_MxTableIsRowSelected(oRow, i))
            n++;
    }

    return n;
}

function MxTableGetSelections(szIdTable)
{
    var aSel = new Array();

    var n = 0;
    var oRows = p_MxTableGetAllRows(szIdTable);
    for (var i = 1; i < oRows.length; i++)
    {
        var oRow = oRows.item(i);
        if (p_MxTableIsRowSelected(oRow, i))
            aSel[n++] = oRow.id;
    }

    return aSel;
}

////////////////////////////////////////////////////////////
// Sizing

function MxTableIsPresent(szIdTable)
{
    var oDiv = p_MxTableGetDiv(szIdTable);
    return (oDiv != null);
}

function MxTableGetWidth(szIdTable)
{
    var w = -1;
    var oDiv = p_MxTableGetDiv(szIdTable);
    if (oDiv != null)
        w = oDiv.offsetWidth;

    return w;
}

function MxTableGetHeight(szIdTable)
{
    var h = -1;
    var oDiv = p_MxTableGetDiv(szIdTable);
    if (oDiv != null)
        h = oDiv.offsetHeight;

    return h;
}

function MxTableSetWidth(szIdTable, w)
{
    p_MxTableSetWidth(p_MxTableGetDiv(szIdTable), w);
}

function MxTableSetHeight(szIdTable, h)
{
    p_MxTableSetHeight(p_MxTableGetDiv(szIdTable), h);
}
