/*
 * (C) Copyright 2005-2006 Hewlett-Packard Development Company, L.P.
 */

//
//  Filename: $Source: /usr/local/vse/glib/src/web/js/glib.js,v $
//  Version:  $Revision: 1.78 $
//  Date:     $Date: 2008/09/04 17:18:40 $
//
//  Hewlett-Packard Company Confidential(C) Copyright 2005 Hewlett-Packard
//  Development Company, L.P.

var sURL = unescape(window.location.pathname);
var sURLWithParams = unescape(window.location.pathname) + unescape(window.location.search);

function doPageRefresh(discardParameters)
{
    vsValidateArgs(["boolean"]);

    // NOTE: the element ID must match BusyG.DIV_ID
    var busyDiv = document.getElementById("busydiv");
    // If the busy div is displayed the form has a submit in progress
    // so ignore the refresh and let it complete.
    if ((busyDiv != null) && (busyDiv.style.display == "block")) {
        return;
    }

    //  This version does NOT cause an entry in the browser's
    //  page view history.  Most browsers will always retrieve
    //  the document from the web-server whether it is already
    //  in the browsers page-cache or not.
    //
    if (discardParameters) {
        window.location.replace( sURL );
    } else {
        window.location.replace( sURLWithParams );
    }
}

// argument "command" is to be handled by Gadgets "gadgetName.Event=value"
// global commands can use this also  but the 'handleEvent' function must be coded to catch them.
function formSubmit(command) {
        displayBusy();
        var myInput   = document.getElementById('formCommand');
        myInput.value = command;

        getScrollValues();

        var myForm    = document.getElementById('mainForm');
        myForm.submit();
}

// Retrieves HP SIM help URL
function getHelpUrl(webApp, topicID) {
                var saveUrl = MxPortalWorkspaceGetHelpUrl();

                MxPortalWorkspaceSetHelpTopicEx(webApp, topicID);
                var helpUrl = MxPortalWorkspaceGetHelpUrl();

                MxPortalWorkspaceSetHelpUrl(saveUrl);

                return helpUrl;
}

function showHelp(location) {
        if ( typeof(MxPortalOpenHelpUrl) != "undefined" ) {
                MxPortalOpenHelpUrl(location);
        } else {
                createWindow(location, "helpWindow", "", "");
        }
}

// Displays help using HP SIM mechanism.
function showOnlineHelp(webApp, topicID) {
        MxPortalOpenHelpTopicEx(webApp, topicID);
}

// how to do a POST in another window?, easy to do a set_url...
function printDataTable(location) {
        var window_trim  = "toolbar=yes,location=no,directories=no,status=no,menubar=no,scrollbars=yes ,resizable=yes,width=550,height=400";
        var newWin       = window.open(location, "printDataTable", window_trim);
        newWin.focus();
}

// change button label to contain ">>" when visible or "<<" when hidden
// this could be made more general with 2 more parameters: replaceText, withText
function changeButtonLabel(byName)
{
        var theElement = document.getElementById(byName);
        if ( theElement != null ) {
                var replaceText = ">>";
                var withText    = "<<";
                if (theElement.value.indexOf(replaceText) != -1) {
                        theElement.value = theElement.value.substring(0,theElement.value.indexOf(replaceText))+withText;
                } else if (theElement.value.indexOf(withText) != -1) {
                        theElement.value = theElement.value.substring(0,theElement.value.indexOf(withText))+ replaceText;
                }

        }
}

// toggle show or hide of a named element
function show_or_hide(byName)
{
        var divElement = document.getElementById(byName);
        var hasStyle;
        if ( divElement != null ) {
                if ( hasStyle = divElement.style ) {
                        if ( hasStyle.display == "" ) {
                                divElement.style.display = "none";
                        } else {
                                divElement.style.display = "";
                        }
                }
        }
}

// show using display style set to empty
function showElement(byName)
{
        var theElement;

        if (theElement = document.getElementById(byName))
                theElement.style.display = "";
}

// show using display style set to none
function hideElement(byName)
{
        var theElement;

        if (theElement= document.getElementById(byName))
                theElement.style.display = "none";
}


function doSelect(name, str)
{
        var arg1 = name + ".sel=";
        var arg2 = str  + ",";
        var arg3 = 0;
        var ele = document.getElementById(name);
        if (ele != null) {
                arg3 = ele.scrollTop;
        }
        var submitCommand = arg1+arg2+arg3;
        formSubmit(submitCommand);
}

function doDelete(name, str)
{
        var arg1 = name + ".del=";
        var arg2 = str  + ",";
        var arg3 = 0;
        // var arg3 = document.getElementById(name).scrollTop;
        var ele = document.getElementById(name);
        if (ele != null) {
                arg3 = ele.scrollTop;
        }
        var submitCommand = arg1+arg2+arg3;
        formSubmit(submitCommand);
}

function doScroll(name, newValue)
{
        var ele = document.getElementById(name);
        if (ele != null) {
                ele.scrollTop=newValue;
        }
}



function getScrollValues()
{
        var ele = document.getElementById('getScroll');
        if (ele != null) {
                var getList   = ele.value;
                if ( getList.length >= 0 ) {
                        var tableList = getList.split(";");
                        for (i=0; i<tableList.length; i++) {
                                getScrollTop(tableList[i]);
                        }
                }
        }
}

function getScrollTop(name)
{
        var ele = document.getElementById(name);
        var arg3 = 0;
        if (ele != null) {
                arg3 = ele.scrollTop;
                var myInput   = document.getElementById('setScroll');
                myInput.value = myInput.value + name + "," + arg3 + ";" ;
        }
}

function dep(o, a) {
        var label;

        for (var i=0; i<a.length; i+=2) {
                var color = "";

                if (document.getElementById(a[i]).disabled = a[i+1] ? !o.checked:o.checked)
                        color = "#999999";

                if (label = document.getElementById(a[i]+"_l1"))
                        label.style.color = color;
                if (label = document.getElementById(a[i]+"_l2"))
                        label.style.color = color;
        }
}

// *******************************************************************
// BEGIN DEBUG FUNCTIONS
// *******************************************************************
var DEBUG_ON = true;

function vsAlert(msg){
        if (DEBUG_ON) {
                alert("Error - an internal error has occurred. Please contact HP:\n"+msg); // Emit message
        }
}
function vsConfirm(msg){
        if(DEBUG_ON){
                return confirm ("Error - an internal error has occurred. Please contact HP:\n\n"+msg)
        }else{
                return true;
        }
}

function vsAbort() {
        throw "Execution aborted"; // Stop execution
}

function vsAssert(test,msg){
        if (DEBUG_ON) {
                if (!test) {
                                                var funcID = getFuncNameFromBody( arguments.callee.caller.toString());
                                                var newMsg = "The error happened in: "+funcID+"().\n"+msg;
                        if(vsConfirm(newMsg/*+funcID*/+"\n\nShould JavaScript continue?")) return;
                        vsAbort(); // End program
                }
        }
}

function vsAssertType(typeName,item){
        vsAssert(item.type==typeName,"Type check failed. Required("+typeName+") Received("+item.type+")!");
}

function vsAssertTypes(typeNames,item){
    for (var i=0;i<typeNames.length;i++) {
                if(item.type==typeNames[i])
                        return;
        }
    vsAssert(false,"Type check failed. Required("+typeNames+") Received("+item.type+")!");
}

function vsAssertTagName(tagName,item){
    vsAssert(item.tagName==tagName, "Tag name check failed. Required("+tagName+") Received("+item.tagName+")!");
}


/**
 * vsValidateArgs([typeNames])
 * Pass in an array with the expected types.
 * This will validate that the function was called with the correct number and
 * types of arguments. This function was written to emulate compile time function argument
 * validation at runtime.
 *
 * Call fucntion similarly to this. vsValidateArgs([number,string]);
 * Valid types are ['any','string','number','boolean','function','object','Array','Date','Error','Object',RegExp'].
 * This should also correctly Identify types for User defined classes.
 *
 * EXAMPLE:
 * function toTest(name,age,childNames){
 *                 vsValidateArgs(['string','number','Array']);
 *
 *                 // Function body happens here.
 * }
 *
 * This will validate that toTest is called with the correct number of arguments (3), and that
 * each has the type specified. Each of these is validated with vsAssert. If the conditions
 * aren't met
 */

function vsValidateArgs(types){
        // todo: aor disabled because if enabled then addon list remove button doesn't work
        return;
        vsAssert(arguments.callee.caller!=null,"Couldn't determine function.")
        if (DEBUG_ON) {
                // Discover relevent data
                var func = arguments.callee.caller;
                var funcID = getFuncNameFromBody(func.toString());
                var args = func.arguments;
                var numArg =  args.length;
                var numReq = types.length;
                var proto = makeProto(funcID,types);
                var actual = makeActualCall(funcID,args);

                // Define types
                var baseTypes=['any','string','number','object','boolean','function'];
                var objectTypes=['Array','Date','Error','Object','RegExp'];
                var allowedTypes=baseTypes.concat(objectTypes);

                // Validate input to vsValidateArgs
                // @TODO should this section be removed, w/o this user defined types could be specified.
                for (var i=0;i<types.length;i++) {
                        var found = false;
                        for (var j=0;j<allowedTypes.length;j++) {
                                if (types[i]==allowedTypes[j]) {
                                        found=true;
                                        break;
                                }
                        }
                        vsAssert(found,proto+" arg "+i+" wasn't one of the allowed types("+allowedTypes+").");
                }

                // Validate function arguments
                vsAssert(numArg == numReq,proto+" called as "+actual+". The number of arguments didn't match.");
                for (var i=0;i<  numArg; i++) {
                        if ('any'==types[i]) {
                                // Accept anything, do nothing
                        } else if (args[i] == null) {
                                // Can't verify nulls
                        } else if ('object'==types[i]) {
                                // This allows object to work for all things derived from object.
                                vsAssert(types[i]== typeof(args[i]),proto+" called as "+actual+" didn't match at index "+i+".");
                        } else {
                                // This works only for strictly specified types.
                                vsAssert(types[i]== fineTypeof(args[i]),proto+" called as "+actual+" didn't match at index "+i+".");
                        }
                }
        }
}
/**
 * Given the string body of a function. This will return the name of the function.
 * The name of a function can be aquired by calling the functions toString() method.
 */
function getFuncNameFromBody(body){

    var matches = body.toString().match(/function\s+(\w+)/);

    if (null == matches || 1 >= matches.length) {
        return "";
    } else {
        return matches[1];
    }
}


/**
 * Similar to JavaScripts typeof operator, but gives more information.
 * typeof returns 'object' for Arrays, Dates, RegExps, Errors, ....
 * For objects, this will return the more specific type, it will return the same as
 * typeof for the primative types string,number,boolean,function.
 */
function fineTypeof(item){
        var baseType = typeof(item);
        if(baseType!='object' || item == null){ return baseType; }
        var funcName = getFuncNameFromBody(item.constructor);

        return ("" == funcName) ? baseType : funcName;
}

/**
 * Given the name of a function and the array of types, this generates a
 * string showing the intended usage of the function.
 * makeProto(toTest,['string','number','Array']) == 'toTest(string,number,Array)';
 */
function makeProto(funcID,paramArray){
        return funcID+"("+ paramArray+ ")";
}

/**
 * Given the name of a function and the arguments array it was called with this creates a
 * string showing the actual usage of the function.
 * Similar to output to makeProto().
 */
function makeActualCall(funcID,args){
        var proto = funcID +"(";
        for(var i=0;i<args.length;i++){
                if(0!=i) proto += ",";
                proto += fineTypeof(args[i]);
        }
        proto += ")";
        return proto;
}


// *******************************************************************
// END DEBUG FUNCTIONS
// *******************************************************************

function hideHideable(id) {
        var obj=document.getElementById(id);
        vsAssert(null!=obj,"hideHideable() called on "+id+"; this object wasn't found.");
        obj.className='vcm-hide';
}

function showHideable(id) {
        var obj = document.getElementById(id);
        vsAssert(null!=obj,"showHideable() called on "+id+"; this object wasn't found.");
        obj.className='vcm-show';
}


function makeHideButtonMatch(toToggle,stateVar,nowHid, nowShown,hiddenSrc,shownSrc) {
        var toTog = document.getElementById(toToggle);
        var state = document.getElementById(stateVar);
        vsAssert(null!=toTog,"makeHideButtonMatch() called on "+toToggle+"; this object wasn't found.");
        vsAssert(null!=state,"makeHideButtonMatch() called on "+stateVar+"; this object wasn't found.");

        if (state.value == nowHid) {
                toTog.src = hiddenSrc;
        } else if (state.value == nowShown) {
                toTog.src = shownSrc;
        } else {
                vsAssert(false, "makeHideButtonMatch() called var("+state.value+") didn't match ("+nowHid+") or ("+nowShown+").");
        }
}

function changeHideState(toToggle,oneVal,otherVal) {
        var obj=document.getElementById(toToggle);
        vsAssert(null!=obj, "changeHideState() called on "+toToggle+" which wasn't found.");
        vsAssertType("hidden",obj);
        if (obj.value == oneVal){
                obj.value = otherVal;
        }else{
                obj.value = oneVal;
        }
}

function makeHideableMatch(toShowHide,hideStateID) {
        var stateObj = document.getElementById(hideStateID);
        vsAssert(null!=stateObj, "makeHideableMatch() called with hideStateID of "+hideStateID+"which isn't defined.");

        if ("not-hidden" == stateObj.value) {
                showHideable(toShowHide);
        } else if ("hidden" == stateObj.value) {
                hideHideable(toShowHide);
        } else {
                vsAssert(false,"makeHideableMatch() called when with state set to "+stateObj.value+" which doesn't match 'not-hidden' or 'hidden'.)");
        }
}


function isMenuItemDisabled(id){
        vsAssert(null!=id,"isMenuItemDisabled: called w/ null id ");
        var obj = document.getElementById(id);
        vsAssert(null!=obj,"isMenuItemDisabled: Couldn't find id "+id);
        return ("disabled"==obj.className);
}

function menuItemOnClick(obj,href){
        vsAssert(null!=obj,"menuItemOnClick(): called w/ null object.");
        vsAssert(null!=href,"menuItemOnClick(): called w/ null href.");
        var tailString = "_aTag";
        var index = obj.id.length - tailString.length;
        vsAssert(obj.id.substring(index)==tailString,"id had incorrect ending.");
        var baseId = obj.id.substring(0,index);
        if(!isMenuItemDisabled(baseId)){
                window.location=href;
        }
}

function addMenuToolTip(id,msg){
        vsAssert(null!=id,"addToolTip() called with null id.");
        vsAssert(null!=msg,"addToolTip() called with null message.");
        var toLookup = id+"_aTag";
        var obj = document.getElementById(toLookup);
        vsAssert(null!=obj,"addToolTipFailed: Couldn't find id "+toLookup);
        obj.title=msg;
}

function disableMenuItem(id,tip){
        vsAssert(null!=id,"disableMenuItem() called with null id.");
        vsAssert(null!=tip,"disableMenuItem() called with null tip.");
        // Attempt the tool tip first, it will assert if this id is incorrect
        // Check for null dropdown manager in case checkbox was clicked
        // while page still loading (JAGaf83611)
        if ( !isMenuItemDisabled(id) && ourDropdownMenuManager != null ) {
            addMenuToolTip(id,tip);
            ourDropdownMenuManager.disableMenuItem(id);
        }
}
function enableMenuItem(id){
        vsAssert(null!=id,"enableMenuItem() called with null id.");
        // Attempt the tool tip first, it will assert if this id is incorrect
        // Check for null dropdown manager in case checkbox was clicked
        // while page still loading (JAGaf83611)
        if ( isMenuItemDisabled(id) && ourDropdownMenuManager != null ) {
            addMenuToolTip(id,"");
            ourDropdownMenuManager.enableMenuItem(id);
        }
}


function getValue(id){
    vsValidateArgs(['string']);
    var elems = document.getElementsByName(id);
    if(elems.length == 0) {
        elems = new Array();
        var el = document.getElementById(id);
        if(el)
            elems[0] = el;
    }
    // For radio button group, IE returns an object of type "radio" and Mozilla returns null
    var values = new Array();
    for(var i = 0; i < elems.length; i++) {
        var obj = elems[i];
        if(obj.type == "hidden" && obj.value == "#IGNORE#")
            continue;
        if(obj.type == "radio" || obj.type == "checkbox")
            if(!obj.checked)
                continue;
        values[values.length] = obj.value;
    }
    return values.join(",");
}

function setValue(id, value){
    vsValidateArgs(['string', 'string']);
    var elems = document.getElementsByName(id);
    if(elems.length == 0) {
        elems = new Array();
        var el = document.getElementById(id);
        if(el)
            elems[0] = el;
    }
    var theOption = null;
    var prevOption = null;
    for(var i = 0; i < elems.length; i++) {
        var obj = elems[i];
        if(obj.type == "hidden" && obj.value == "#IGNORE#")
            continue;
        if(obj.type == "radio" || obj.type == "checkbox") {
            if(obj.value == value) {
                if(!obj.checked)
                    theOption = obj;
            } else {
                if(obj.checked)
                    prevOption = obj;
            }
        } else {
            obj.value = value;
            if(obj.onclick)
                obj.onclick(null);
            break;
        }
    }
    if(prevOption != null) {
        prevOption.checked = false;
        if(prevOption.onclick)
            prevOption.onclick(null);
    }
    if(theOption != null) {
        theOption.checked = true;
        if(theOption.onclick)
            theOption.onclick(null);
    }
}

// The following text must match what is declared in the Context.java file!
var HTTP_SESSION_ID="HTTP_SESSION_ID_FOR_PAGEG"; // Used to create named session windows.

var popup;

/**
 * Makes visible the busy pane, which blocks further input after a form submit
 * has begun.
 */
function displayBusy() {
    // NOTE: the element ID must match BusyG.DIV_ID
    var busyDiv = document.getElementById("busydiv");
    // NOTE: this style value is checked in doPageRefresh() to detect the
    // that the busyDiv is displayed.
    busyDiv.style.display="block";

    busyDiv.style.position="absolute";
    busyDiv.style.left="0";
    busyDiv.style.top="0";

    if (document.all) { // IE
        var html = document.getElementsByTagName("html")[0];
        w = Math.max(getWindowWidth(), document.body.scrollWidth);
        h = Math.max(getWindowHeight(), document.body.scrollHeight);
        busyDiv.style.width = w + "px";
        busyDiv.style.height = h + "px";
    } else { // Mozilla
        busyDiv.style.width =  getWindowWidth() + window.scrollMaxX + "px";
        busyDiv.style.height = getWindowHeight() + window.scrollMaxY + "px";
    }

    busyDiv.style.cursor="wait";
    busyDiv.style.opacity="0.5";
    busyDiv.style.filter="alpha(opacity=50)";
    busyDiv.style.backgroundColor="white";

    busyDiv.style.zIndex=99999;
    // Need to disable the <select> tags, which
    // IE does not render correctly according to Z-order (they "punch through" the busydiv)
    var selects = document.body.getElementsByTagName("SELECT");
    var i;
    for ( i = 0; i < selects.length; i++ ) {
        // can't disable, this causes select to not post data
        selects[i].style.visibility = "hidden";
    }
    timer = window.setTimeout("animateBusy()", 100, "javascript");
}

/**
 * Animates the busy image on the busy pane.
 */
function animateBusy() {
    // The following bizarre code is required to get GIFs to animate after
    // a form submit in IE.
    // NOTE: the element id must match BusyG.IMAGE_ID
    var src = document.getElementById("busyimage").src;
    document.getElementById("busyimage").src = src;
}

/*
 * Parse a string (dataStr) using a specified field separator and return
 * the requested field (fieldNum; 0-N). If the requested field does not
 * exist, an empty string is returned.
 * Passing in null for separator will result in one field.  Passing in
 * an empty string will result in each character in the string in its own
 * field.
 */
function getDataField(dataStr, fieldNum, separator) {
    vsValidateArgs(["string","number","string"]);
        var fields = dataStr.split(separator);
        if (fieldNum>=0 && fieldNum < fields.length) {
                return fields[fieldNum];
        }
        return "";
}

/**
 * howMuchSmallerAllowed If the size of the object is less then intended size,
 *      but THIS close, then don't resize. In IE everytime an object is resized
 *      it triggers a page resize.  Since resizing an object is often in the page
 *      page onresize handler, an infinite loop can form.
 */
var howMuchSmallerAllowed = 5;

/**
 * minSRHeight and minSRWidth are the minimum sizes for the resizable scrolling
 * region.
 */
var minSRWidth = 200;
var minSRHeight = 200;

/**
 * Find height of window in which this is executed
 * @return The height in pixels of the current window.
 */
function getWindowHeight(){
    var height;
    if(document.all){
        // In IE
                height=document.body.clientHeight;
    }else{
        // In mozilla
        height=window.innerHeight;
    }
    return height;
}

/**
 * Resize the height of an html object, if its height isn't already 'close enough'
 * Currently if the id doesn't refer to an existing object, this code will just fall through
 * this is because it is called to resize a scrolling region on all MainPage tabs, even
 * though only two have the scrolling region.
 * @param id The id of the html object to resize.
 * @param intendedHeight Number of pixels this object height should be should be set to.
 */
function resizeHeight(id,intendedHeight){
    vsValidateArgs(["string","number"]);

    // Get the html object to resize
    var objectToResize = document.getElementById(id);
    if(objectToResize!=null){
        // Get the height as a number
        var currentHeight = parseInt(objectToResize.style.height);
        // Resize if bigger then space, or more then a little too small.
        if(     currentHeight>intendedHeight ||
                currentHeight < intendedHeight-howMuchSmallerAllowed )
        {
            // Do the resizing
            objectToResize.style.height = intendedHeight+"px";
        }
    }
}

/**
 * Find width of window in which this is executed
 * @return The width in pixels of the current window.
 */
function getWindowWidth(){
    var width;
    if(document.all){
        // In IE
                width=document.body.clientWidth;
    }else{
        // In mozilla
        width=window.innerWidth;
    }
    return width;
}

/**
 * Resize the width of an html object, if its width isn't already 'close enough'
 * Currently if the id doesn't refer to an existing object, this code will just fall through
 * this is because it is called to resize a scrolling region on all MainPage tabs, even
 * though only two have the scrolling region.
 * @param id The id of the html object to resize.
 * @param intendedWidth Number of pixels this object width should be should be set to.
 */
function resizeWidth(id,intendedWidth){
    vsValidateArgs(["string","number"]);

    // Get the html object to resize
    var objectToResize = document.getElementById(id);
    if(objectToResize!=null){
        var currentWidth = parseInt(objectToResize.style.width);
        // Resize if bigger then space, or more then a little too small.
        if(     currentWidth>intendedWidth ||
                currentWidth<intendedWidth-howMuchSmallerAllowed )
        {
            // Do the resizing
            objectToResize.style.width = intendedWidth+"px";
        }
    }
}

/**
 * Resize the height and width of the specified object.
 * @param id The id of the html object to resize.
 * @param intendedHeight Number of pixels this object height should be should be set to.
 * @param intendedWidth Number of pixels this object width should be should be set to.
 */
function resizeHeightWidth(id,intendedHeight,intendedWidth){
    vsValidateArgs(["string","number","number"]);
    resizeHeight(id,intendedHeight);
    resizeWidth(id,intendedWidth);
}

/**
 * Get the height of the pageErrorList DIV element (if any).
 * Note: "pageErrorList" is defined in PageG.java.
 * @return the height of the error element in pixels (or 0 if none)
 */
function getErrorHeight(){
    var errorList = document.getElementById("pageErrorList");
    if (errorList) {
            return errorList.offsetHeight;
    } else {
            return 0;
    }
}

/**
 * Expand an html object to take up the whole window, except for the height and width
 * already consumed by other objects above/below/beside the target object.
 * Also take into account any errors that may be on the page and treat those
 * as adding to the heightAlreadyTaken.  The resulting size is forced to be a
 * minimum of at least 200x200 pixels.
 * @param id The id of the html object to resize.
 * @param heightAlreadyTaken Number of pixels of height of the current window
 *        which is already filled.
 * @param widthAlreadyTaken Number of pixels of width of the current window
 *        which is already filled.
 */
function resizeToFillWindow(id,heightAlreadyTaken,widthAreadyTaken){
    vsValidateArgs(["string","number","number"]);
    // First, resize to a small size.  This gives mozilla a chance to
    // remove its scrollbars and gives us about 20 more pixels to play
    // with.  Mozilla treats the space a browser scroll bar occupies
    // as part of the window size.  If we don't get rid of these
    // scroll bars, we will resize our object too large and the broswer
    // scroll bars will be needed to see it.
    resizeHeightWidth(id,100,100);
    var windowHeight = getWindowHeight();
    var errorHeight = getErrorHeight();
    var targetHeight = windowHeight-heightAlreadyTaken-errorHeight;
    if (targetHeight < minSRHeight) {
            targetHeight = minSRHeight;
    }
    var targetWidth = getWindowWidth()-widthAreadyTaken;
    if (targetWidth < minSRWidth) {
            targetWidth = minSRWidth;
    }
    resizeHeightWidth(id,targetHeight,targetWidth);
}

/**
 * This method finds any DIV tags that have _SnapToSize_ in their ID.
 * For each of these DIVs, it will compute the height of the contained
 * components and vertically resize the DIV to the smaller of the content or a
 * maximum height as specified in the DIV ID as _#h.
 *
 * The width of the DIV will always be resized to the smaller of the
 * content width or the window width minus a specified amount already consumed
 *
 * The Tag ID syntax is: GadgetName_SnapToSize_#h_#w, where the #h refers to the
 * maximum height to allow for the gadget and #w refers to the amount of
 * space already consumed (horizontally on the page).
 * For example:
 *    mydiv_SnapToSize_300h_40w
 * Means:
 *	The DIV has a maximum height of 300 pixels
 *	The DIV has a maximum width of WindowWidth-40 pixels
 *
 * snapToSize() calls should be placed in onload and onresize for a page that
 * will be defining these DIV elements.
 *
 * Note: the DIV should only wrap a single object (layout, etc), or a set of
 * vertically stacked objects.
 *
 */
function snapToSize(){
        var scrollbarAllowance = 25;	// space consumed by a scrollbar
        var divID = "_SnapToSize_";
    var myDivs = document.getElementsByTagName("div");
    for (i=0; i< myDivs.length; i++) {
                var id = myDivs[i].id;
                var idx = id.indexOf(divID);
                if (idx != -1) {
                        var bounds = id.substring(idx+divID.length);
                        var maxHeight = parseInt(bounds.substring(0,bounds.indexOf("h")));
                        bounds = bounds.substring(bounds.indexOf("_")+1);
                        var widthUsed = parseInt(bounds.substring(0,bounds.indexOf("w")));
                        var children = myDivs[i].childNodes;
                        var contentHeight = 0;
                        var contentWidth = 0;
                        for (j=0;j<children.length;j++) {
                                // Only add in our named items.  IE places other elements in the
                                // DOM that have no name, but do have a height.  However, these
                                // elements don't render and take up vertical space, so need to
                                // be ignored in our height calculations.
                                if (children[j].id != "" && children[j].offsetHeight) {
                                        contentHeight += children[j].offsetHeight;
                            }
                            // Note: you can't just add the widths since the browser often
                            // stacks things vertically. You also can't just take the
                            // maximum width and use that.  But we do anyway since there
                            // is no better solution.  As a result, this feature is limited
                            // to working with divs wrapping single objects (e.g. layouts)
                            // or vertically stacked objects.
                                if (children[j].offsetWidth) {
                                        if (children[j].offsetWidth > contentWidth) {
                                                contentWidth = children[j].offsetWidth;
                                        }
                            }
                        }
                        var vscroll=0; // assume no vertical scroll bar needed
                        targetHeight = contentHeight;
                        if (targetHeight > maxHeight) {
                                targetHeight = maxHeight;
                                vscroll = scrollbarAllowance; // we will have a vert scrollbar
                        }
                        targetWidth = contentWidth+vscroll;
                        windowWidth = getWindowWidth();
                        if (targetWidth > windowWidth-widthUsed) {
                                targetWidth = windowWidth - widthUsed - vscroll;
                                targetHeight += scrollbarAllowance; // for horiz scroll bar
                                if (targetHeight > maxHeight) {
                                        targetHeight = maxHeight;
                                }
                        }
                    resizeHeightWidth(id,targetHeight,targetWidth);
                }
        }
}

// Global references needed to pass values to finishCreateWindow(), below.
var newWindow;
var newWindowUrl;

/**
 * Creates a new top-level window with the indicated name and URL contents. Window
 * features may also be specified; see the DHTML documentation for window.open()
 * for format.
 */
function createWindow(url, windowName, features, replacementPattern) {
    vsValidateArgs(["string", "string", "string", "string"]);
    if ( replacementPattern != null
         && replacementPattern.length > 0
         && url.indexOf(replacementPattern) != -1 )
    {
        var field = document.getElementById(SELECTION_FIELD);
        var selection = field.value;
        var selectedObjects = selection.split(RS);
        var selectedIds = "";
        // Loop for all the objects in the selection list and create a comma-separated
        // list of the ids
        for ( var r = 0; r < selectedObjects.length; r++ ) {
            var selectedObject = selectedObjects[r];
            var objectAttributes = selectedObject.split(ES);
            if ( r != 0 ) {
                selectedIds += ",";
            }
            selectedIds += objectAttributes[ID_INDEX];
        }
        url = url.replace(replacementPattern, selectedIds);
    }

    var sessionField = document.getElementById(HTTP_SESSION_ID);
    var sessionID = sessionField.value;

    // Need to specify a URL; can't use default of "about:blank", as IE6 will generate a "about to
    // leave a secure internet connection" if this is called from an https page.
    // APP_CONTEXT should be set by PageG.
    newWindow = window.open(APP_CONTEXT + "/images/busy.gif", windowName + "_" + sessionID, features);
    newWindowUrl = url;
    // Firefox needs a delay here in order for busy image to appear, so wait 100 msec to
    // set the real URL of the new window.
    setTimeout("finishCreateWindow()", 100);
    newWindow.focus();
    if ( typeof(MxPortalTrackPopup) != "undefined" ) {
        MxPortalTrackPopup(newWindow);
    }
}

/**
 * Need to assign new window URL after a delay in order for Firefox to display the busy image
 */
function finishCreateWindow() {
    newWindow.location = newWindowUrl;
    newWindow = null;
    newWindowUrl = null;
}

/*
 * Launch an HP SIM tool referenced by the 'tool-id' provided.
 */
function launchHPSIMTool(toolId)
{
    if ( typeof(MxPortalWorkspaceCreate) != "undefined" ) {
        setTimeout("MxPortalWorkspaceCreate('"+ toolId + "')",100);
    }
}

/*
 * Invokes a specified action after the specified time.  Takes three parameters,
 * the first is the action field, the second is the action and the third is the
 * time to wait before invoking the action.  See executeAction() below.
 */
function executeActionInTimeout(field, action, time)
{
    window.setTimeout("executeAction('"+ field +"','"+ action +"')", time);
}

/*
 * Invokes a specified action and reposts the page.  Takes two parameters,
 * the first is the action field (e.g., PageG.ACTION_FIELD) and the second
 * is an encoded action.  Sample invocation:
 *
 * "executeAction('" + PageG.ACTION_FIELD + "','" + action.encode() + "')"
 */
function executeAction(field, action)
{
    document.getElementById(field).value=action;
    displayBusy();
    document.mainForm.submit();
}

var debugWindow;
var debugDocument;
var debugEnabled = false;
var firstMillis = null;
var previousMillis = null;

function log(message) {
    if (debugEnabled) {
        var date = new Date();
        var time = date.toTimeString();
        var millis = date.valueOf();
        if ( firstMillis == null ) {
            firstMillis = millis;
            previousMillis = millis;
        }
        var delta1 = millis - previousMillis;
        var delta2 = millis - firstMillis;
        previousMillis = millis;
        message = time + " (" + delta1 + " msec. delta, " + delta2 + " msec. total) "  + message;
        if ( debugWindow == null ) {
            debugWindow = window.open(null, "VSEDebugLogWindow");
            debugDocument = debugWindow.document.open();
            debugDocument.write("<html><head><title>Debug Log</title></head><body><h1>Debug Log</h1><pre id='debugElement' name='debugElement'></pre></body></html>");
        }
        var textNode = debugDocument.createTextNode(message);
        debugDocument.getElementById("debugElement").appendChild(textNode);
        debugDocument.getElementById("debugElement").appendChild(debugDocument.createElement("br"));
    }


}

function getSelectedRowCellText(tableName, column) {
        //Adding ".rs." to table name because ColumnTableG names the radio buttons
        //for each row (when setRadioButtons()) is called tableName+".rs."
        var radioName = tableName + ".rs.";

        var i=0;
        var radioElement = document.getElementById(radioName+i)
        while(radioElement != null) {
                if(radioElement.checked) {
                        return radioElement.parentNode.parentNode.cells[column].childNodes[0].data;
                }

                i++;
                radioElement = document.getElementById(radioName+i);
        }
}

/**
 * Given an element in the page returns the elements pixel offset
 * from the left of the page.
 */
function getLeftOffset(obj) {
        var leftOffset = 0;
        while ( obj != null && obj.style.position != "absolute" ) {
                leftOffset += obj.offsetLeft;
                obj = obj.offsetParent;
        }

        return leftOffset;
}

/**
 * Given an element in the page returns the cumulative horizontal scroll offset up
 * through the first absolutely positioned ancestor.
 */

function getLeftScroll(obj) {
        var leftScroll = 0;
        while ( obj != null ) {
                leftScroll += obj.scrollLeft;
                if ( obj.style.position == "absolute" ) break;
                obj = obj.parentNode;
        }

        return leftScroll;
}

/*
 * Given an element in the page returns the elements pixel offset
 * from the top of the page.
 */
function getTopOffset(obj) {
        var topOffset = 0;
        while ( obj != null && obj.style.position != "absolute" ) {
                if ( document.all && obj.style.overflow == "auto" ) break;
                topOffset += obj.offsetTop;
                obj = obj.offsetParent;
        }

        return topOffset;
}

/**
 * Given an element in the page returns the cumulative vertical scroll offset up
 * through the first absolutely positioned ancestor.
 */

function getTopScroll(obj) {
        var topScroll = 0;
        while ( obj != null ) {
                topScroll += obj.scrollTop;
                if ( obj.style.position == "absolute" ) break;
                obj = obj.parentNode;
        }

        return topScroll;
}

/**
 * Given an element in the page returns the vertical space available for a popup.
 */
function getVerticalSpace(obj) {
    while ( obj != null ) {
        if ( document.all ) { // IE
            if ( obj.style.overflow == "auto" ) {
                break;
            }
        }
        else { // Mozilla
            if ( obj.style.position == "absolute" ) {
                break;
            }
        }
        obj = obj.parentNode;
    }

    return obj.offsetHeight;
}

/*
 * Given an the id of a visible element and the id of a hidden element in
 * the page this method places the popup object in the appropriate
 * place on the screen based on the first elements location in the
 * page.
 */
function positionPopupContent(controlID, hiddenContentID) {

        controlObj = document.getElementById(controlID);
        hiddenContentObj = document.getElementById(hiddenContentID);

        var controlPositionLeft = getLeftOffset(controlObj);
        var controlPositionTop = getTopOffset(controlObj);
        var topScroll = getTopScroll(controlObj);
        var leftScroll = getLeftScroll(controlObj);

        var controlWidth = controlObj.offsetWidth;
        var controlHeight = controlObj.offsetHeight;
        
        var hiddenContentX = controlPositionLeft + controlWidth;
        var hiddenContentY = controlPositionTop + controlHeight;


        
        hiddenContentObj.style.zIndex=-1;
        hiddenContentObj.style.display="block";

        var thresholdX = getWindowWidth() / 2;

        if(controlPositionLeft > thresholdX) {
                hiddenContentX = controlPositionLeft - hiddenContentObj.offsetWidth;
                hiddenContentX = Math.max(hiddenContentX,0);
                hiddenContentY = Math.max(hiddenContentY,topScroll);
        }

        var thresholdY = getVerticalSpace(controlObj);
        if ( document.all ) thresholdY += topScroll;
        if(!document.all) hiddenContentY -= topScroll;

        // Sometimes firefox2 doesn't have a height or width for the span which is the control object. 
        // When this happens the popup can cover the trigger, causing cycling of popup on off on off......
        // When there is no dimensions, we put the popup above so it cant conflict.
        var lostDimensions = controlWidth==0 && controlHeight==0;
        if(lostDimensions || (( hiddenContentY + hiddenContentObj.offsetHeight) > thresholdY)) {
                hiddenContentY = controlPositionTop - hiddenContentObj.offsetHeight;
                if(!document.all) hiddenContentY -= topScroll;
        }

        hiddenContentObj.style.position="absolute";
        hiddenContentObj.style.left=(hiddenContentX).toString() + 'px';
        hiddenContentObj.style.top=(hiddenContentY).toString() + 'px';
        hiddenContentObj.style.zIndex=1;
}

function resizeContentArea() {
    var width = getWindowWidth();
    var height = getWindowHeight();

    var bannerHeight = "0";
    var banner = document.getElementById("_banner");
    if (banner) {
        bannerHeight = banner.offsetHeight;
    }

    //var errorHeight = getErrorHeight();

    // This element id must match the content area id used in PageG
    var contentArea = document.getElementById("_contentArea");
    //contentArea.style.top = (bannerHeight + errorHeight) + "px";
    contentArea.style.top = bannerHeight + "px";
    //contentArea.style.height = (height - bannerHeight - errorHeight) + "px";
    contentArea.style.height = (height - bannerHeight) + "px";
    contentArea.style.width = width + "px";
}
