/*
 * (C) Copyright 2001-2006 Hewlett-Packard Development Company, L.P.
 */

// The toggleCheck() function takes the name of a checkbox and
// switches its current state.  In addition, it resets the source
// for the actions menu frame to include the change in checkbox
// state so that menu.jsp can update the SelectionManager object
// with the new state of the checkbox.  If the function is called
// from within a JSP that does not include the actions menu iframe,
// getSelectedObjects() is called to update the selectedObjects
// element in the JSP with the correct state of the selected
// checkboxes.
function toggleCheck(name, imagesURL, jspURL)
{
   var image
   var actionsFrame

   image = document.images[name]
   actionsFrame = parent.document.getElementById("FRAME_PARMGR_ACTIONS")

   // First, look to see if the actions menu frame is actually visible
   // on the page.  If so, toggle the image for the checkbox in question
   // and reset the actions menu frame source with the modified checkbox
   // data as the request data.
   //
   if (actionsFrame != null) {
      if (image.src.match("uncheck.gif$") != null) {
         image.src = imagesURL + "/check.gif"
         actionsFrame.src = jspURL + "/menu.jsp?name=" + name + "&state=true"
      } else {
         image.src = imagesURL + "/uncheck.gif"
         actionsFrame.src = jspURL + "/menu.jsp?name=" + name + "&state=false"
      }

   // If the actions menu frame is not visible, then this function was
   // called from a dialog.  Check to see if the "selectedCells" element
   // is present in the page.  If it is, toggle the image for the
   // checkbox in question and update the value of selectedCells by
   // calling the getSelectedObjects() function.
   //
   } else if (document.getElementById("selectedCells") != null) {
      if (image.src.match("uncheck.gif$") != null) {
         image.src = imagesURL + "/check.gif"
      } else {
         image.src = imagesURL + "/uncheck.gif"
      }
      document.getElementById("selectedCells").value = getSelectedObjects()
   }

}

// The getSelectedObjects() function examines all images on the current
// page.  If the source of an image indicates that the image is checked,
// then add the name of the image to the list.
function getSelectedObjects()
{
   var image
   var imageCount = document.images.length
   var selectedObjectsList = ""

   // Examine all images on the page.  For those that are checked, add
   // the checkbox ID to the list of selected objects.
   //
   for (var i=0; i<imageCount; i++) {
     image = document.images[i]
     if (image.src.match("/check.gif$") != null) {
       if (selectedObjectsList.length == 0) {
         selectedObjectsList = image.id
       } else {
         selectedObjectsList += "," + image.id
       }
     }
   }
   return selectedObjectsList
}

// The setMenuState() function captures the current state of the action menu
// cascades and stores it in the hidden iframe in menu.jsp.
//
function setMenuState(jspURL)
{
   document.getElementById("FRAME_PARMGR_MENU_STATE").src = jspURL + "/menu_state.jsp?state=" + MxMenuGetState("MENU_PARMGR_ACTIONS")
}

// The deselectAllCheckboxes() function clears all checked checkboxes
// in the current view, then resets the action menu frame source so
// that the SelectionManager object will reset all selected checkbox
// data structures.
function deselectAllCheckboxes(imagesURL, jspURL)
{

   var actionsFrame
   var workspaceFrame
   var imageCount
   var image
   var imageRef

   actionsFrame = parent.document.getElementById("FRAME_PARMGR_ACTIONS")
   workspaceFrame = parent.document.getElementById("FRAME_PARMGR_WORKSPACE")
   if (isIE()) {
       imageCount = workspaceFrame.Document.images.length
   } else {
       imageCount = workspaceFrame.contentDocument.images.length
   }

   // First, toggle all checked checkbox images to unchecked, then
   // reset the actions menu frame source with the special value to
   // deselect all checkboxes.
   //
   for (var i=0; i<imageCount; i++) {
     if (isIE()) {
         image = workspaceFrame.Document.images[i]
     } else {
         image = workspaceFrame.contentDocument.images[i]
     }
     if (image.src.match("/check.gif$") != null) {
         image.src = imagesURL + "/uncheck.gif"
     }
   }
   actionsFrame.src = jspURL + "/menu.jsp?name=deselectAllCheckboxes"

}

// The loadMenuFrame() function sets the source of the action menu
// frame.  It is called after the workspace has finished rendering
// so that all of the visible checkboxes in the workspace will have
// been updated in the SelectionManager object properly.
function loadMenuFrame(jspURL)
{
   actionsFrame = parent.document.getElementById("FRAME_PARMGR_ACTIONS")
   if (actionsFrame != null) {
       actionsFrame.src = jspURL + "/menu.jsp"
   }
}

/*
 * Test to see if the current browser is IE.
 *
 * @return true if we are running on IE, false other wise.
 *
 * @precondition None.
 * @postcondition None.
 */
function isIE(){
    var NETSCAPE = "Netscape";

    if (navigator.appName == NETSCAPE){
        return false;
    } else {
        return true;
    }
}

// The showSlotDetails() function loads I/O slot details in the
// workspace iframe.
//
function showSlotDetails(catURL)
{
   var workspaceFrame

   workspaceFrame = parent.document.getElementById("FRAME_PARMGR_WORKSPACE")
   workspaceFrame.src = catURL
}

//
// Helper function to show an object.
//
function showObject(optionName){
    var opt;
    if (isIE()){
        opt = eval("document.all." + optionName);
    } else {
        opt = document.getElementById(optionName);
    }
    opt.className = 'show';
}

//
// Helper function to hide an object.
//
function hideObject(optionName){
    var opt;
    if (isIE()){
        opt = eval("document.all." + optionName);
    } else {
        opt = document.getElementById(optionName);
    }
    opt.className = 'hide';
}

// helper function to show help for a screen.
function showHelp(location) {
    var the_name = 'helpWindow';
    var window_features = "toolbar=yes,location=no,directories=no," +
        "status=no,menubar=no,scrollbars=yes," +
        "resizable=yes,width=660,height=600";
    var new_win = window.open(location, the_name, window_features);
    new_win.focus();
}

function openWindow(location) {
    var windowFeatures='HEIGHT=460,WIDTH=620,resizable=1,scrollbars=1';
    var newWin = window.open(location, "parmgrSubWind", windowFeatures);
    newWin.focus();
}

function isHpSimPortalPresent() {
    //
    // Check to see if we're running under HP SIM.
    // Don't just call MxPortalIsPreset() function because it will
    // cause JavaScript errors when not running in HP SIM.  Therefore,
    // check to see if the function is present, and then call it if so.
    //
    if(window.MxPortalIsPresent && MxPortalIsPresent())
    {
        return true;
    }
    return false;
}

function isHpSmhPortalPresent() {
    //FramesAreThere is provided by chp.js to identify
    //if the page is contained inside HP SMH
    if( window.FramesAreThere && window.FramesAreThere == true )
        {
                return true;
        }
        return false;
}
