/*
 * (C) Copyright 2005-2006 Hewlett-Packard Development Company, L.P.
 */



function TabManager() {

}

// NOTE: any changes to this function require corresponding changes to the unInit function
TabManager.prototype.init = function() {
	var divs = document.getElementsByTagName("DIV");
	for (var i=0;i<divs.length;i++) {
		if (( divs[i].className=="tabOn")|| ( divs[i].className=="tabOff"))  {
			// passes clicks from the div's themselves down into the link inside. This makes the tabs behave in a manner more consistent with application tabs. 
			if ( divs[i].className=="tabOff") {
				// a note on this click() method.   If you should find, on some new release of Mozilla, that anchorElements or other elements dont seem to have a click method or are throwing errors, then this might mean that a certain patch for mozilla's DOM has stopped working. (The patch in question concerns the fact that Mozilla does not currently give link elements a click method and that one must be then created for it.)

// GUIDO CODE EDITED !!!
/* This line used to always index child nodes at 0. However Firefox didn't have the desired A tag
at 0. It had a text node at indexes 0&2 and the A tag at 0. Now the code calls a function which
searches the childNodes for the correct index.

NOTE: the line of code inside the curley braces is dynamically defining a function, therefore the
correct index can't be calculated out here and passed into that line. The calculation must be made
inside the curley braces.
*/
				divs[i].onclick = function() {this.childNodes[findATagIndex(this.childNodes)].click();};
			}

			// min-width and min-height css doesnt work on ie6, so this goes in and does it by hand. 
			// note that there is currently an assumption that the second level tab divs are the IMMEDIATE children of the "secondaryTabSet" div. 
			if (document.all) {
				
				if (divs[i].parentNode.className=="secondaryTabSet") {
					if (divs[i].className == "tabOn") {
						if (divs[i].offsetWidth < 83) divs[i].style.width = "60px";
					}
					else if (divs[i].className == "tabOff") {
						if (divs[i].offsetWidth < 85) divs[i].style.width = "62px";
					}
				}
				else {
					if (divs[i].className == "tabOn") {
						if (divs[i].offsetWidth < 111) divs[i].style.width = "88px";
					}
					else if (divs[i].className == "tabOff") {
						if (divs[i].offsetWidth < 113) divs[i].style.width = "90px";
					}
				}
			}
		}
	}
}


// Release event handlers put in place by the init function
// NOTE: any changes to init() should be mirrored here
TabManager.prototype.unInit = function() {
	var divs = document.getElementsByTagName("DIV");
	for (var i=0;i<divs.length;i++) {
		if (( divs[i].className=="tabOn")|| ( divs[i].className=="tabOff"))  {
			if ( divs[i].className=="tabOff") {
				divs[i].onclick = null;
			}
		}
	}
}


/**
 * Fuction which searches the childNodes to find the A tag for this tab, and returns the
 * index of that childNode. If none of the nodes contain the A tag, this returns 0. 0 was
 * always used before this edit.
 * THIS WAS ADDED TO THE GUIDO CODE!!!
 * @param childNodes The array of childNodes to search.
 * @return 0 or the index of the <A> tag if it's present.
 */
function findATagIndex(childNodes){

    var index=0;
    // Search until we find an "A" tag
     while( (index<childNodes.length) && ("A"!=childNodes[index].nodeName)){
        index++;
    }
    // Check if the search was successful.
    if("A"!=childNodes[index].nodeName){
        return 0;
    }
    return index;
}

 
