<%--
/**
 * The JSP page for "analyze complex health'
 *
 * @version $Header: /usr/local/vse/parmgr/src/web/jsp/analyze_complex_health.jsp,v 1.50 2008/03/05 12:00:23 sridharav Exp $
 * @risk Medium
 *
 * @task name = Analyze complex health screen
 *      cycle = 5
 *      owner = Kurt
 *      phase = test
 *      status = done
 *      description = develop screen for problem checker results
 */
--%>

<%--
     Using the I18N tag here helps set the appropiate charset for the page.
     This is needed even though this reference to the bundle isn't used
     elsewhere in the page.
--%>
<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>
<i18n:bundle baseName="com.hp.parmgr.ui.tags.tags" id="bundle" />

<%@ page import="com.hp.parmgr.model.Discovery,
                 com.hp.parmgr.model.Cell,
                 com.hp.parmgr.ui.SessionTimeOut,
                 com.hp.parmgr.util.CellCompatibilityComparator,
                 com.hp.parmgr.util.Log,
                 com.hp.parmgr.util.ProblemChecker,
                 java.util.List,
                 java.util.ArrayList,
                 java.util.Iterator"
%>
<%@ page import="com.hp.parmgr.ui.tags.Util" %>
<%@page contentType="text/html;charset=UTF-8"%>
<%@page pageEncoding="UTF-8"%>

<%@ page errorPage="exception.jsp" %>

<script src="/mxportal/js/MxPortalApi.js" language="JavaScript" type="text/javascript"></script>
<script src="<%=Util.URL_PARMGR_JS%>" language="JavaScript" type="text/javascript"></script>
<script language='JavaScript' type='text/javascript'>
    if( isHpSimPortalPresent() ) {
        MxPortalWorkspaceSetTitleHtml("Partition Manager");
        MxPortalWorkspaceSetHelpTopicEx("parmgr", "about");
        MxPortalWorkspaceSetSubtitleHtml("");
    }
</script>

<jsp:useBean id="parsession" scope="session" class="com.hp.parmgr.ui.ParmgrSession" />

<%
    String imbeddedParam = "imbedded";
    String skipIfOKParam = "skipIfOK";
    String refreshParam  = "refresh";

    // Sometimes don't want to display the buttons (e.g. OK, Cancel)
    // or other features when the problem checker output is imbedded
    // in another page, for example, when complex health is displayed
    // as part of complex details.
    boolean imbedded = Boolean.valueOf(request.getParameter(imbeddedParam)).booleanValue();
    String skipIfOKstr = request.getParameter(skipIfOKParam);
    boolean skipIfOK = Boolean.valueOf(request.getParameter(skipIfOKParam)).booleanValue();

    java.util.ResourceBundle tagBundle =
        java.util.ResourceBundle.getBundle( "com.hp.parmgr.ui.tags.tags",
                                            parsession.getLocale());

    java.util.ResourceBundle achBundle =
        java.util.ResourceBundle.getBundle( "com.hp.parmgr.ui.Analyze",
                                            parsession.getLocale());

    java.util.ResourceBundle globalBundle =
        java.util.ResourceBundle.getBundle( "com.hp.parmgr.ui.Global",
                                            parsession.getLocale());


    String pageTitle    = achBundle.getString( "Analyze.title" );

    // Strings for summary section
    String summaryTitle = achBundle.getString( "Analyze.summary.title" );
    String statusLabel  = achBundle.getString( "Analyze.summary.statusLabel" );
    String checkLabel   = achBundle.getString( "Analyze.summary.checkLabel" );
    String noteLabel    = achBundle.getString( "Analyze.summary.noteLabel" );
    String errLockMsg   = achBundle.getString( "Analyze.summary.errLock" );
    String badCompMsg   = achBundle.getString( "Analyze.summary.badComp" );
    String badCableMsg  = achBundle.getString( "Analyze.summary.cable" );
    String nonredDomMsg = achBundle.getString( "Analyze.summary.nonred" );
    String compatMsg    = achBundle.getString( "Analyze.summary.compat" );
    String memoryMsg    = achBundle.getString( "Analyze.summary.memory" );
    String bootMsg      = achBundle.getString( "Analyze.summary.boot" );
    String errName      = achBundle.getString( "Analyze.summary.error.image" );
    String warnName     = achBundle.getString( "Analyze.summary.warn.image" );
    String unkName      = achBundle.getString( "Analyze.summary.unknown.image" );
    String okName       = achBundle.getString( "Analyze.summary.ok.image" );
    String naLabel      = tagBundle.getString( "ComplexDetails.NA" );

    // Strings for legend
    String legendTitle  = achBundle.getString( "Analyze.legend.caption");
    String errLabel     = achBundle.getString( "Analyze.legend.error");
    String warnLabel    = achBundle.getString( "Analyze.legend.warn");
    String unkLabel     = achBundle.getString( "Analyze.legend.unknown");
    String okLabel      = achBundle.getString( "Analyze.legend.ok");

    // Strings for notes section
    String notesTitle     = achBundle.getString( "Analyze.notes.title" );
    String errorNote      = achBundle.getString( "Analyze.notes.errors" );
    String lockNote       = achBundle.getString( "Analyze.notes.locks" );
    String badCellNote    = achBundle.getString( "Analyze.notes.badCell" );
    String badREONote     = achBundle.getString( "Analyze.notes.badREO" );
    String badDomNote     = achBundle.getString( "Analyze.notes.badDomain" );
    String unkChaNote     = achBundle.getString( "Analyze.notes.unkChassis" );
    String nonredNote     = achBundle.getString( "Analyze.notes.nonred" );
    String complexNote    = achBundle.getString( "Analyze.notes.complex" );
    String parCompNote    = achBundle.getString( "Analyze.notes.parCompat");
    String groupLabel     = achBundle.getString( "Analyze.notes.group");
    String protoLabel     = achBundle.getString( "Analyze.notes.protoGroup");
    String protoNote      = achBundle.getString( "Analyze.notes.haveProto");
    String noMinZINote    = achBundle.getString( "Analyze.notes.noMinZI");
    String noMinZIOSNote  = achBundle.getString( "Analyze.notes.noMinZIOS");
    String unkMinZIOSNote = achBundle.getString( "Analyze.notes.unkMinZIOS");
    String wasteCLMNote   = achBundle.getString( "Analyze.notes.wastedCLM");
    String maybeCLMNote   = achBundle.getString( "Analyze.notes.maybeWaste");
    String emptyNote      = achBundle.getString( "Analyze.notes.emptySlot");
    String inactNote      = achBundle.getString( "Analyze.notes.inactiveCell");
    String unknownStr     = achBundle.getString( "Analyze.notes.unknownCompat");
    String compatLabel    = achBundle.getString( "Analyze.notes.compatLabel");
    String firmwareLabel  = achBundle.getString( "Analyze.notes.firmwareLabel");
    String cellsLabel     = globalBundle.getString("Application.Cells.label");

    // Strings for log section
    String errorLog    = achBundle.getString( "Analyze.log.errors" );
    String lockLog     = achBundle.getString( "Analyze.log.locks" );
    String badCellLog  = achBundle.getString( "Analyze.log.badCell" );
    String badREOLog   = achBundle.getString( "Analyze.log.badREO" );
    String badDomLog   = achBundle.getString( "Analyze.log.badDomain" );
    String unkChaLog   = achBundle.getString( "Analyze.log.unkChassis" );
    String nonredLog   = achBundle.getString( "Analyze.log.nonred" );
    String complexLog  = achBundle.getString( "Analyze.log.complex" );
    String parCompLog  = achBundle.getString( "Analyze.log.parCompat");
    String groupLabelLog  = achBundle.getString( "Analyze.log.group");
    String protoLabelLog  = achBundle.getString( "Analyze.log.protoGroup");
    String protoLog    = achBundle.getString( "Analyze.log.haveProto");
    String noMinZILog  = achBundle.getString( "Analyze.log.noMinZI");
    String noMinZIOSLog   = achBundle.getString( "Analyze.log.noMinZIOS");
    String unkMinZIOSLog  = achBundle.getString( "Analyze.log.unkMinZIOS");
    String wasteCLMLog = achBundle.getString( "Analyze.log.wastedCLM");
    String maybeCLMLog = achBundle.getString( "Analyze.log.maybeWaste");
    String emptyLog    = achBundle.getString( "Analyze.log.emptySlot");
    String inactLog    = achBundle.getString( "Analyze.log.inactiveCell");

    // page references
    String helpPage     = "analyzeComplexHealth";
    String thisPage     = "analyze_complex_health.jsp";
    String tgtPage      = thisPage;

    // ACH can be invoked by the user from the menu or displayed as part
    // of complex details.  In those cases, the from URL will be set in
    // the parmgr session.  However, ACH is also run automatically
    // when the session starts (this is whenever the user has to log
    // in; coming from the CLI or wherever).  In that case, there
    // will be no from URL set in the parmgr session, since there is
    // no place for ACH to go back to.  Instead, ACH needs to go
    // *forward* to someplace.  In some situations, this someplace is
    // on the request, but not all (in particular, when the user is
    // coming back from a refresh).  For that reason, the URL is
    // tracked in a session attribute, set in run_analyze_complex_health.jsp.
    // That JSP is included in all JSPs through which the user can
    // initially enter parmgr (esp. from the CLI).
    String fromURL = parsession.getFromURL();
    if (fromURL == null) {
        // Coming from the CLI on the way to somewhere else.
        // Get the somewhere else.
        fromURL = (String)session.getAttribute("achFromURL");
    }

    // icons for first column of summary table
    String okIcon       = "<img src=\"" + Util.URL_BASE_IMAGES + "/" + okName   + "\">";
    String errIcon      = "<img src=\"" + Util.URL_BASE_IMAGES + "/" + errName  + "\">";
    String warnIcon     = "<img src=\"" + Util.URL_BASE_IMAGES + "/" + warnName + "\">";
    String unkIcon      = "<img src=\"" + Util.URL_BASE_IMAGES + "/" + unkName  + "\">";

    // Other string constants
    String BLANK        = "&nbsp;";
    String BREAK        = "<br>";
    String COMMA_SEP    = ", ";

    // Strings for buttons
    String OK           = tagBundle.getString( "Button.OK" );
    String Refresh      = tagBundle.getString( "Refresh.label" );
    String Help         = tagBundle.getString( "Button.Help" );

    Discovery discovery = parsession.getDiscovery();

    // if the user has hit the refresh button, clear the
    // cache, otherwise use existing data.
    boolean isLoading = false;
    if( request.getParameter(refreshParam) != null ) {
        discovery.clearCache();
        parsession.setCheckPending(true);
        isLoading = true;

        String thisURL = thisPage + "?" + imbeddedParam + "=" + imbedded +
                                    "&" + skipIfOKParam + "=" + request.getParameter(skipIfOKParam);

        tgtPage = Util.URL_BASE_JSP + "/loading.jsp?src=" + java.net.URLEncoder.encode(thisURL.toString(), "UTF-8");
    }

    //
    // Keep track of whether there are errors worth reporting.
    // Warnings generally aren't considered worth reporting.
    // If we're running Analyze Complex Health automatically
    // and no problems are worth reporting this page forwards
    // to the destination page rather than showing the complex
    // health.
    //
    boolean haveProblemsToReport = false;

    // accumulate notes as the various checkers run
    // so the note number matches the index, we'll insert
    // a 'dummy' note into the 0th element, and assume
    // that a note list with 1 element is 'empty'.
    List notes = new ArrayList();
    List noteIcons = new ArrayList();
    int currentNote = 0;
    notes.add("");
    noteIcons.add("");

    // output variables used throughout the checker code
    String iconFile = statusLabel;
    String summMsg  = checkLabel;
    StringBuffer noteNum = new StringBuffer(noteLabel);
    StringBuffer noteMsg = new StringBuffer();
    StringBuffer logMsg  = new StringBuffer();

    int i;       // a counter
%>

<HTML>


<HEAD>
<%@ include file="session_keep_alive.jsp" %>
    <link type="text/css" rel="stylesheet" href="<%=Util.URL_PARMGR_CSS%>">
    <link type="text/css" rel="stylesheet" href="<%=Util.URL_MXTABLE_CSS%>">
    <script type='text/javascript'
            language='JavaScript'
            src='<%=Util.URL_PARMGR_JS%>' >
    </script>

    <title>
        <%=pageTitle%>
    </title>

    <%@include file="cm_npar_scripts.jsp"%>
<%=SessionTimeOut.javascript(session, bundle.getLocale())%>
<META http-equiv="Content-Type" content="text/html;charset=UTF-8">
</HEAD>


<% if( isLoading ) { %>
<BODY onLoad="window.location.replace('<%=tgtPage%>')" >
<% } else { %>
<BODY>
<%
    Log.summary( Log.EVENT_START, Log.RESULT_NONE,
                 "Starting Analyze Complex Health" );
    ProblemChecker checker = new ProblemChecker( discovery );
    if (! imbedded) {
%>
<p align=right>
<table border=0 cellpadding=0 cellspacing=0 width="100%">
<tr>
    <td class=parmgr_tab_cell>
      <a class="parmgr-regular-text">
          <%=tagBundle.getString("ComplexScopeLabel") %>
          &nbsp;
          <%=discovery.getComplex().getName()%>
      </a>
    </td>
    <FORM action="<%=thisPage%>" method="post">
    <td class=parmgr_tab_cell align=right valign=bottom>
        <a class="parmgr-regular-text">
            <font size=-2><b>
            <%=tagBundle.getString("LastComplexScan.label") %>
            </b>&nbsp;&nbsp;<%=discovery.getLastUpdateTime()%>
            </font>
        </a>
        &nbsp;&nbsp;
        <INPUT class="button-bold" type="submit"
               value="<%=Refresh%>" name="refresh" />
     </td>
     </FORM>
</tr>
</table>
</p>
<% } // if( !imbedded %>
<p class="subwindow-heading"><%=pageTitle%></p>

<p>
<table>
<tr>
<td valign="top">
<table border=0 cellspacing=2 cellpadding=0>
<tr>
  <td class="prop-table-header"> <%=iconFile%> </td>
  <td class="prop-table-header"> <%=summMsg%>  </td>
  <td class="prop-table-header-last"> <%=noteNum.toString()%>  </td>
</tr>

<%

// check for error and locked cells, chassis, and partitions
summMsg = errLockMsg;
noteNum.delete(0,noteNum.length());

List errCells  = checker.getErrorCells();
List errChas   = checker.getErrorChassis();
List errPars   = checker.getErrorPartitions();
boolean haveErrors =
    ( !errCells.isEmpty() || !errChas.isEmpty() || !errPars.isEmpty() );

List lockCells = checker.getLockedCells();
List lockChas  = checker.getLockedChassis();
List lockPars  = checker.getLockedPartitions();
boolean haveLocks =
    ( !lockCells.isEmpty() || !lockChas.isEmpty() || !lockPars.isEmpty() );

if( haveErrors || haveLocks ) {
    // All of these are errors.  We can't get all of the info
    // we need.  Note that in general, on all of these clauses
    // we'll set the iconFile to the lowest condition that any
    // suberror can have, and reset upwards if any worse
    // suberror gets triggered, e.g. if there are two subconditions,
    // one a warning and one an error, then the default is warning,
    // and reset to error if the worse one is triggered.  The iconFile
    // will indicate the worst of any set of errors listed in the notes.
    iconFile = errIcon;
    if( haveErrors ) {
        if( noteNum.length() > 0 ) noteNum.append(COMMA_SEP);
        noteNum.append(++currentNote);
        // create note and append to note list
        noteMsg.append( errorNote );
        noteMsg.append( BREAK );
        noteMsg.append( checker.getCellLabels( errCells ) );
        noteMsg.append( checker.getChassisLabels( errChas ) );
        noteMsg.append( checker.getPartitionLabels( errPars ) );
        notes.add( currentNote, noteMsg.toString() );
        noteIcons.add( errIcon );
        noteMsg.delete( 0, noteMsg.length() );

        // log the result
        logMsg.append( errorLog );
        logMsg.append( checker.getCellLabels( errCells ) );
        logMsg.append( checker.getChassisLabels( errChas ) );
        logMsg.append( checker.getPartitionLabels( errPars ) );
        Log.error( logMsg.toString() );
        logMsg.delete( 0, logMsg.length() );
        haveProblemsToReport = true;
    }
    if( haveLocks ) {
        if( noteNum.length() > 0 ) noteNum.append(COMMA_SEP);
        noteNum.append(++currentNote);
        // create note and append to note list
        noteMsg.append( lockNote );
        noteMsg.append( BREAK );
        noteMsg.append( checker.getCellLabels( lockCells ) );
        noteMsg.append( checker.getChassisLabels( lockChas ) );
        noteMsg.append( checker.getPartitionLabels( lockPars ) );
        notes.add( currentNote, noteMsg.toString() );
        noteIcons.add( errIcon );
        noteMsg.delete( 0, noteMsg.length() );

        // log the result
        logMsg.append( lockLog );
        logMsg.append( checker.getCellLabels( lockCells ) );
        logMsg.append( checker.getChassisLabels( lockChas ) );
        logMsg.append( checker.getPartitionLabels( lockPars ) );
        Log.error( logMsg.toString() );
        logMsg.delete( 0, logMsg.length() );
        haveProblemsToReport = true;
    }
} else {
    iconFile = okIcon;
    noteNum.append(naLabel);
}
%>
<tr>
  <td class="prop-table-data" align=center> <%=iconFile%> </td>
  <td class="prop-table-data"> <%=summMsg%>  </td>
  <td class="prop-table-data"> <%=noteNum.toString()%>  </td>
</tr>

<%
// Check for failed or deconfigured components
summMsg = badCompMsg;
noteNum.delete(0,noteNum.length());

List badCells = checker.getCellsWithInoperativeComponents();
List badDoms  = checker.getDomainsWithFailedUnits();
List badREOS  = checker.getCellsWithUninitializedREO();
boolean haveBadCells = !badCells.isEmpty();
boolean haveBadDoms  = !badDoms.isEmpty();
boolean haveBadREOS  = !badREOS.isEmpty();

if( haveBadCells || haveBadDoms || haveBadREOS ) {
    // bad cells indicates deconfigured cpus or dimms.
    // these can be intential as well as unintentional
    // so we make this only a warning.
    // for domains, a failed component doesn't necessarily
    // cause a problem.  Only if too many of them are
    // failed, which is caught elsewhere.
    // For REOS, this indicates that the REO is either
    // failed or uninitialized.  We can't tell the
    // difference, so again only a warning.
    iconFile = warnIcon;
    if( haveBadCells ) {
        if( noteNum.length() > 0 ) noteNum.append(COMMA_SEP);
        noteNum.append(++currentNote);
        // create note and append to note list
        noteMsg.append( badCellNote );
        noteMsg.append( BREAK );
        noteMsg.append( checker.getCellLabels( badCells ) );
        notes.add( currentNote, noteMsg.toString() );
        noteIcons.add( warnIcon );
        noteMsg.delete( 0, noteMsg.length() );

        // log result
        logMsg.append( badCellLog );
        logMsg.append( checker.getCellLabels( badCells ) );
        Log.error( logMsg.toString() );
        logMsg.delete( 0, logMsg.length() );
        haveProblemsToReport = true;
    }
    if( haveBadDoms ) {
        if( noteNum.length() > 0 ) noteNum.append(COMMA_SEP);
        noteNum.append(++currentNote);
        // create note and append to note list
        noteMsg.append( badDomNote );
        noteMsg.append( BREAK );
        noteMsg.append( checker.getDomainLabels( badDoms ) );
        notes.add( currentNote, noteMsg.toString() );
        noteIcons.add( warnIcon );
        noteMsg.delete( 0, noteMsg.length() );

        // log result
        logMsg.append( badDomLog );
        logMsg.append( checker.getDomainLabels( badDoms ) );
        Log.error( logMsg.toString() );
        logMsg.delete( 0, logMsg.length() );
        haveProblemsToReport = true;
    }
    if( haveBadREOS ) {
        if( noteNum.length() > 0 ) noteNum.append(COMMA_SEP);
        noteNum.append(++currentNote);
        // create note and append to note list
        noteMsg.append( badREONote );
        noteMsg.append( BREAK );
        noteMsg.append( checker.getCellLabels( badREOS ) );
        notes.add( currentNote, noteMsg.toString() );
        noteIcons.add( warnIcon );
        noteMsg.delete( 0, noteMsg.length() );

        // log result
        logMsg.append( badDomLog );
        logMsg.append( checker.getCellLabels( badREOS ) );
        Log.error( logMsg.toString() );
        logMsg.delete( 0, logMsg.length() );
        haveProblemsToReport = true;
    }

} else {
    iconFile = okIcon;
    noteNum.append(naLabel);
}

%>
<tr>
  <td class="prop-table-data" align=center> <%=iconFile%> </td>
  <td class="prop-table-data"> <%=summMsg%>  </td>
  <td class="prop-table-data"> <%=noteNum.toString()%>  </td>
</tr>

<%
// Check for incorrectly cabled cabinets
summMsg = badCableMsg;
noteNum.delete(0,noteNum.length());

List unkChas = checker.getCellsConnectedToUnknownChassis();
boolean haveUnkChas = !unkChas.isEmpty();

if( haveUnkChas ) {
    // Bad cabling is only a warning.  The rest of
    // the complex will work correctly.
    iconFile = warnIcon;
    if( noteNum.length() > 0 ) noteNum.append(COMMA_SEP);
    noteNum.append(++currentNote);
    // create note and append to note list
    noteMsg.append( unkChaNote );
    noteMsg.append( BREAK );
    noteMsg.append( checker.getCellLabels( unkChas ) );
    notes.add( currentNote, noteMsg.toString() );
    noteIcons.add( warnIcon );
    noteMsg.delete( 0, noteMsg.length() );
    // log result
    logMsg.append( unkChaLog );
    logMsg.append( checker.getCellLabels( unkChas ) );
    Log.warning( logMsg.toString() );
    logMsg.delete( 0, logMsg.length() );

} else {
    iconFile = okIcon;
    noteNum.append(naLabel);
}
%>
<tr>
  <td class="prop-table-data" align=center> <%=iconFile%> </td>
  <td class="prop-table-data"> <%=summMsg%>  </td>
  <td class="prop-table-data"> <%=noteNum.toString()%>  </td>
</tr>

<%
// Check for nonredundant domains
summMsg = nonredDomMsg;
noteNum.delete(0,noteNum.length());

List nonredDoms = checker.getNonredundantDomains();
boolean haveNonredDoms = !nonredDoms.isEmpty();

if( haveNonredDoms ) {
    // This is when there are insufficient power supplies
    // or fans for the use.  We're at N- redundancy.
    iconFile = errIcon;
    if( noteNum.length() > 0 ) noteNum.append(COMMA_SEP);
    noteNum.append(++currentNote);
    // create note and append to note list
    noteMsg.append( nonredNote );
    noteMsg.append( BREAK );
    noteMsg.append( checker.getDomainLabels( nonredDoms ) );
    notes.add( currentNote, noteMsg.toString() );
    noteIcons.add( errIcon );
    noteMsg.delete( 0, noteMsg.length() );
    // log result
    logMsg.append( nonredLog );
    logMsg.append( checker.getDomainLabels( nonredDoms ) );
    Log.error( logMsg.toString() );
    logMsg.delete( 0, logMsg.length() );
    haveProblemsToReport = true;
} else {
    iconFile = okIcon;
    noteNum.append(naLabel);
}
%>
<tr>
  <td class="prop-table-data" align=center> <%=iconFile%> </td>
  <td class="prop-table-data"> <%=summMsg%>  </td>
  <td class="prop-table-data"> <%=noteNum.toString()%>  </td>
</tr>

<%
// Check cell compatibility
summMsg = compatMsg;
noteNum.delete(0,noteNum.length());

// These filter out the error objects, so none of the following
// code need check for them.
List complexGroups = checker.getComplexCompatibilityGroups();
List parGroups = checker.getCellCompatibilityGroups();
boolean haveComplexIncompat = ( complexGroups.size() > 1 );
boolean haveMultCellTypes   = ( parGroups.size() > 1 );

if( haveComplexIncompat || haveMultCellTypes ) {
    // incompatible cells in the complex may only mean
    // that the user has to be careful when grouping
    // them into partitions, so just a warning.
    iconFile = warnIcon;
    if( haveComplexIncompat ) {
        // but in this case, we've mixed things that should
        // never be in the same complex, so it's an error.
        iconFile = errIcon;
        if( noteNum.length() > 0 ) noteNum.append(COMMA_SEP);
        noteNum.append(++currentNote);
        // create note and append to note list
        noteMsg.append( complexNote );
        i = 1;
        for( Iterator iter = complexGroups.iterator(); iter.hasNext(); ++i ) {
            List group = (List) iter.next();
            noteMsg.append(BREAK);
            noteMsg.append(BREAK);
            noteMsg.append(groupLabel);
            noteMsg.append(BLANK);
            noteMsg.append( i );
            noteMsg.append(":");
            noteMsg.append(BREAK);
            // Add cell compatibility and firmware revision values
            Cell cell = (Cell) group.get(0);
            if (! cell.isErrorObject()) {
                noteMsg.append(compatLabel);
                noteMsg.append(":");
                noteMsg.append(BLANK);
                noteMsg.append(cell.getCellCompatibilityLabelString());
                noteMsg.append(BREAK);
                noteMsg.append(firmwareLabel);
                noteMsg.append(":");
                noteMsg.append(BLANK);
                noteMsg.append(cell.getFirmwareRevision());
            }
            else {
                noteMsg.append(compatLabel);
                noteMsg.append(":");
                noteMsg.append(BLANK);
                noteMsg.append(unknownStr);
                noteMsg.append(BREAK);
                noteMsg.append(firmwareLabel);
                noteMsg.append(":");
                noteMsg.append(BLANK);
                noteMsg.append(unknownStr);
            }
            noteMsg.append(BREAK);
            noteMsg.append(cellsLabel);
            noteMsg.append(": ");
            noteMsg.append( checker.getCellLabels( group ) );
        }
        notes.add( currentNote, noteMsg.toString() );
        noteIcons.add( errIcon );
        noteMsg.delete( 0, noteMsg.length() );
        // log result
        logMsg.append( complexLog );
        i = 1;
        for( Iterator iter = complexGroups.iterator(); iter.hasNext(); ++i ) {
            List group = (List) iter.next();
            logMsg.append(BREAK);
            logMsg.append(BREAK);
            logMsg.append(groupLabelLog);
            logMsg.append(BLANK);
            logMsg.append( i );
            logMsg.append(":");
            logMsg.append(BREAK);
            // Add cell compatibility and firmware revision values
            Cell cell = (Cell) group.get(0);
            if (! cell.isErrorObject()) {
                logMsg.append("Cell Compatibility");
                logMsg.append(":");
                logMsg.append(BLANK);
                logMsg.append(cell.getCellCompatibilityLabelString());
                logMsg.append(BREAK);
                logMsg.append("Firmware Revision");
                logMsg.append(":");
                logMsg.append(BLANK);
                logMsg.append(cell.getFirmwareRevision());
            }
            else {
                logMsg.append("Cell Compatibility");
                logMsg.append(":");
                logMsg.append(BLANK);
                logMsg.append(unknownStr);
                logMsg.append(BREAK);
                logMsg.append("Firmware Revision");
                logMsg.append(":");
                logMsg.append(BLANK);
                logMsg.append(unknownStr);
            }
            logMsg.append(BREAK);
            logMsg.append("Cells: ");
            logMsg.append( checker.getCellLabels( group ) );
        }
        Log.error( logMsg.toString() );
        logMsg.delete( 0, logMsg.length() );
        haveProblemsToReport = true;
    }
    if( haveMultCellTypes ) {
        if( noteNum.length() > 0 ) noteNum.append(COMMA_SEP);
        noteNum.append(++currentNote);
        // create note and append to note list
        noteMsg.append( parCompNote );
        i = 1;
        boolean haveProto = false;
        for( Iterator iter = parGroups.iterator(); iter.hasNext(); ++i ) {
            List group = (List) iter.next();
            noteMsg.append(BREAK);
            noteMsg.append(BREAK);
            if( CellCompatibilityComparator.isCellPrototype( (Cell) group.get(0) ) ) {
                noteMsg.append(protoLabel);
                haveProto = true;
            } else {
                noteMsg.append(groupLabel);
            }
            noteMsg.append(BLANK);
            noteMsg.append( i );
            noteMsg.append(":");
            noteMsg.append(BREAK);
            // Add cell compatibility and firmware revision values
            Cell cell = (Cell) group.get(0);
            if (! cell.isErrorObject()) {
                noteMsg.append(compatLabel);
                noteMsg.append(":");
                noteMsg.append(BLANK);
                noteMsg.append(cell.getCellCompatibilityLabelString());
                noteMsg.append(BREAK);
                noteMsg.append(firmwareLabel);
                noteMsg.append(":");
                noteMsg.append(BLANK);
                noteMsg.append(cell.getFirmwareRevision());
            }
            else {
                noteMsg.append(compatLabel);
                noteMsg.append(":");
                noteMsg.append(BLANK);
                noteMsg.append(unknownStr);
                noteMsg.append(BREAK);
                noteMsg.append(firmwareLabel);
                noteMsg.append(":");
                noteMsg.append(BLANK);
                noteMsg.append(unknownStr);
            }
            noteMsg.append(BREAK);
            noteMsg.append(cellsLabel);
            noteMsg.append(": ");
            noteMsg.append( checker.getCellLabels( group ) );
        }
        if( haveProto ) {
            noteMsg.append(BREAK);
            noteMsg.append(BREAK);
            noteMsg.append( protoNote );
        }
        notes.add( currentNote, noteMsg.toString() );
        noteIcons.add( warnIcon );
        noteMsg.delete( 0, noteMsg.length() );

        // log result
        logMsg.append( parCompLog );
        i = 1;
        haveProto = false;
        for( Iterator iter = parGroups.iterator(); iter.hasNext(); ++i ) {
            List group = (List) iter.next();
            logMsg.append(BREAK);
            logMsg.append(BREAK);
            if( CellCompatibilityComparator.isCellPrototype( (Cell) group.get(0) ) ) {
                logMsg.append(protoLabelLog);
                haveProto = true;
            } else {
                logMsg.append(groupLabelLog);
            }
            logMsg.append(BLANK);
            logMsg.append( i );
            logMsg.append(":");
            logMsg.append(BREAK);
            // Add cell compatibility and firmware revision values
            Cell cell = (Cell) group.get(0);
            if (! cell.isErrorObject()) {
                logMsg.append("Cell Compatibility");
                logMsg.append(":");
                logMsg.append(BLANK);
                logMsg.append(cell.getCellCompatibilityLabelString());
                logMsg.append(BREAK);
                logMsg.append("Firmware Revision");
                logMsg.append(":");
                logMsg.append(BLANK);
                logMsg.append(cell.getFirmwareRevision());
            }
            else {
                logMsg.append("Cell Compatibility");
                logMsg.append(":");
                logMsg.append(BLANK);
                logMsg.append(unknownStr);
                logMsg.append(BREAK);
                logMsg.append("Firmware Revision");
                logMsg.append(":");
                logMsg.append(BLANK);
                logMsg.append(unknownStr);
            }
            logMsg.append(BREAK);
            logMsg.append("Cells: ");
            logMsg.append( checker.getCellLabels( group ) );
        }
        if( haveProto ) {
            logMsg.append(BREAK);
            logMsg.append(BREAK);
            logMsg.append( protoLog );
        }
        Log.warning( logMsg.toString() );
        logMsg.delete( 0, logMsg.length() );
    }

} else {
    iconFile = okIcon;
    noteNum.append(naLabel);
}
%>
<tr>
  <td class="prop-table-data" align=center> <%=iconFile%> </td>
  <td class="prop-table-data"> <%=summMsg%>  </td>
  <td class="prop-table-data"> <%=noteNum.toString()%>  </td>
</tr>

<%
// Check memory configuration
summMsg = memoryMsg;
noteNum.delete(0,noteNum.length());

List noMinZI    = new ArrayList();
List noMinZIOS  = new ArrayList();
List unkMinZIOS = new ArrayList();
List unkCLM     = new ArrayList();
List wastedCLM  = new ArrayList();
checker.getPartitionsWithInadequateInterleavedMemory(noMinZI);
checker.getPartitionsWithInadequateInterleavedMemoryForOS(noMinZIOS,unkMinZIOS);
checker.getNParsWithWastedCLM( unkCLM, wastedCLM );
boolean haveNoMinZI    = !noMinZI.isEmpty();
boolean haveNoMinZIOS  = !noMinZIOS.isEmpty();
boolean haveUnkMinZIOS = !unkMinZIOS.isEmpty();
boolean haveWastedCLM  = !wastedCLM.isEmpty();
boolean haveMaybeWaste = !unkCLM.isEmpty();

if( haveNoMinZI || haveWastedCLM || haveMaybeWaste
    || haveNoMinZIOS || haveUnkMinZIOS )
{
    // maybeWaste is only a possible problem.  We're not even
    // sure if it exists.  haveNoMinZI is a warning, system
    // firmware will adjust if that's too low.  haveWastedCLM
    // is a warning as the cell will run, though perhaps some
    // available memory won't be used.  haveUnkMinZIOS is
    // a warning, we just don't know.  haveNoMinZIOS is an
    // error. The npar won't boot.
    iconFile = unkIcon;

    if( haveNoMinZI ) {
        iconFile = warnIcon;
        if( noteNum.length() > 0 ) noteNum.append(COMMA_SEP);
        noteNum.append(++currentNote);
        // create note and append to note list
        noteMsg.append( noMinZINote );
        noteMsg.append( BREAK );
        noteMsg.append( checker.getPartitionLongLabels( noMinZI ) );
        notes.add( currentNote, noteMsg.toString() );
        noteIcons.add( warnIcon );
        noteMsg.delete( 0, noteMsg.length() );
        // log result
        logMsg.append( noMinZILog );
        logMsg.append( checker.getPartitionLongLabels( noMinZI ) );
        Log.warning( logMsg.toString() );
        logMsg.delete( 0, logMsg.length() );
    }

    if( haveWastedCLM ) {
        iconFile = warnIcon;
        if( noteNum.length() > 0 ) noteNum.append(COMMA_SEP);
        noteNum.append(++currentNote);
        // create note and append to note list
        noteMsg.append( wasteCLMNote );
        noteMsg.append( BREAK );
        noteMsg.append( checker.getPartitionLongLabels( wastedCLM ) );
        notes.add( currentNote, noteMsg.toString() );
        noteIcons.add( warnIcon );
        noteMsg.delete( 0, noteMsg.length() );
        // log result
        logMsg.append( wasteCLMLog );
        logMsg.append( checker.getPartitionLongLabels( wastedCLM ) );
        Log.error( logMsg.toString() );
        logMsg.delete( 0, logMsg.length() );
        haveProblemsToReport = true;
    }

    if( haveMaybeWaste ) {
        if( noteNum.length() > 0 ) noteNum.append(COMMA_SEP);
        noteNum.append(++currentNote);
        // create note and append to note list
        noteMsg.append( maybeCLMNote );
        noteMsg.append( BREAK );
        noteMsg.append( checker.getPartitionLongLabels( unkCLM ) );
        notes.add( currentNote, noteMsg.toString() );
        noteIcons.add( unkIcon );
        noteMsg.delete( 0, noteMsg.length() );
        // log result
        logMsg.append( maybeCLMLog );
        logMsg.append( checker.getPartitionLongLabels( unkCLM ) );
        Log.warning( logMsg.toString() );
        logMsg.delete( 0, logMsg.length() );
    }

    if( haveUnkMinZIOS ) {
        iconFile = warnIcon;
        if( noteNum.length() > 0 ) noteNum.append(COMMA_SEP);
        noteNum.append(++currentNote);
        // create note and append to note list
        noteMsg.append( unkMinZIOSNote );
        noteMsg.append( BREAK );
        noteMsg.append( checker.getPartitionLongLabels( unkMinZIOS ) );
        notes.add( currentNote, noteMsg.toString() );
        noteIcons.add( warnIcon );
        noteMsg.delete( 0, noteMsg.length() );
        // log result
        logMsg.append( unkMinZIOSLog );
        logMsg.append( checker.getPartitionLongLabels( unkMinZIOS ) );
        Log.warning( logMsg.toString() );
        logMsg.delete( 0, logMsg.length() );
    }

    if( haveNoMinZIOS ) {
        iconFile = errIcon;
        if( noteNum.length() > 0 ) noteNum.append(COMMA_SEP);
        noteNum.append(++currentNote);
        // create note and append to note list
        noteMsg.append( noMinZIOSNote );
        noteMsg.append( BREAK );
        noteMsg.append( checker.getPartitionLongLabels( noMinZIOS ) );
        notes.add( currentNote, noteMsg.toString() );
        noteIcons.add( errIcon );
        noteMsg.delete( 0, noteMsg.length() );
        // log result
        logMsg.append( noMinZILog );
        logMsg.append( checker.getPartitionLongLabels( noMinZIOS ) );
        Log.error( logMsg.toString() );
        logMsg.delete( 0, logMsg.length() );
        haveProblemsToReport = true;
    }



} else {
    iconFile = okIcon;
    noteNum.append( naLabel );
}
%>
<tr>
  <td class="prop-table-data" align=center> <%=iconFile%> </td>
  <td class="prop-table-data"> <%=summMsg%>  </td>
  <td class="prop-table-data"> <%=noteNum.toString()%>  </td>
</tr>

<%
// Check for potential boot problems
summMsg = bootMsg;
List emptySlots = checker.getNParsWithEmptyCellSlotsSetToBoot();
List inactCells = checker.getNParsWithInactiveCellsSetToBoot();
boolean haveEmptySlots = !emptySlots.isEmpty();
boolean haveInactCells = !inactCells.isEmpty();
noteNum.delete(0,noteNum.length());
if( haveEmptySlots || haveInactCells ) {
    // These are also warnings.  The problem is a potentially
    // long boot time.  Once up the partition will run fine.
    iconFile = warnIcon;
    if( haveEmptySlots ) {
        if( noteNum.length() > 0 ) noteNum.append(COMMA_SEP);
        noteNum.append(++currentNote);
        // create note and append to note list
        noteMsg.append( emptyNote );
        noteMsg.append( BREAK );
        noteMsg.append( checker.getPartitionLongLabels( emptySlots ) );
        notes.add( currentNote, noteMsg.toString() );
        noteIcons.add( warnIcon );
        noteMsg.delete( 0, noteMsg.length() );
        // log result
        logMsg.append( emptyLog );
        logMsg.append( checker.getPartitionLongLabels( emptySlots ) );
        Log.warning( logMsg.toString() );
        logMsg.delete( 0, logMsg.length() );
    }
    if( haveInactCells ) {
        if( noteNum.length() > 0 ) noteNum.append(COMMA_SEP);
        noteNum.append(++currentNote);
        // create note and append to note list
        noteMsg.append( inactNote );
        noteMsg.append( BREAK );
        noteMsg.append( checker.getPartitionLongLabels( inactCells ) );
        notes.add( currentNote, noteMsg.toString() );
        noteIcons.add( warnIcon );
        noteMsg.delete( 0, noteMsg.length() );
        // log result
        logMsg.append( inactLog );
        logMsg.append( checker.getPartitionLongLabels( inactCells ) );
        Log.warning( logMsg.toString() );
        logMsg.delete( 0, logMsg.length() );
    }

} else {
    iconFile = okIcon;
    noteNum.append( naLabel );
}

//
// If we didn't see any serious problems and Analyze Complex Health
// was being run automatically, just forward to the expected page
// rather than showing the results.
//
if (!haveProblemsToReport && skipIfOK) {
    // try to make sure the url is relative for the forward.
    String root = Util.URL_BASE_JSP + "/";
    int relative = fromURL.indexOf(root);
    if (relative != -1) {
        fromURL = fromURL.substring(relative + root.length());
    }
    pageContext.forward(fromURL);
    return;
}
%>
<tr>
  <td class="prop-table-data" align=center> <%=iconFile%> </td>
  <td class="prop-table-data"> <%=summMsg%>  </td>
  <td class="prop-table-data"> <%=noteNum.toString()%>  </td>
</tr>
</td>
</table>
<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
<td valign="top">
<table border=0 cellpadding=0 cellspacing=0>
<tr>
<td class="prop-table-caption" colspan=2><%=legendTitle%></td>
</tr>
<tr>
<td class="prop-table-header"><%=okLabel%></td>
<td class="prop-table-data"><%=okIcon%></td>
</tr>
<tr>
<td class="prop-table-header"><%=unkLabel%></td>
<td class="prop-table-data"><%=unkIcon%></td>
</tr>
<tr>
<td class="prop-table-header"><%=warnLabel%></td>
<td class="prop-table-data"><%=warnIcon%></td>
</tr>
<tr>
<td class="prop-table-header"><%=errLabel%></td>
<td class="prop-table-data"><%=errIcon%></td>
</tr>
</table>
</td></tr>
</table>
</p>
<%
    if (! imbedded) {
%>
<form method="post" action="<%=thisPage%>" name="analyzeHealth">
<p>
<INPUT class="button"      type="button"
       value="<%=OK%>"     name="OK"
       onclick="window.location.replace('<%=fromURL%>')" />

<INPUT class="button"      type="button"
       value="<%=Help%>"   name="Help"
       onclick="showHelp('<%=parsession.getHelpURL(helpPage)%>')" />
</p>

</form>
<%
} // if( ! imbedded )

if( notes.size() > 1 ) {
%>
<p class="subwindow-heading"><%=notesTitle%></p>
<%
} else {
    Log.note( "No problems found." );
}
%>
<table>
<%
for( i = 1; i < notes.size(); ++i ) {
%>
<tr>
  <td class="prop-table-data" valign=top align=right><%=Integer.toString(i)%>.</td>
  <td class="prop-table-data" valign=top ><%=(String)noteIcons.get(i)%></td>
  <td class="prop-table-data" valign=top ><%=(String)notes.get(i)%></td>
</tr>
<%
} // end for
%>
</table>

<%
    Log.summary( Log.EVENT_DONE, Log.RESULT_NONE,
                 "Completed Analyze Complex Health" );
} // end if( ! isLoading )
%>
</BODY>
</HTML>
