<%--
/**
 * The JSP page for "assign cells to nPar'
 *
 * @version $Header: /usr/local/vse/parmgr/src/web/jsp/assign_cells_to_npar.jsp,v 1.32 2008/03/05 12:00:23 sridharav Exp $
 * @risk Medium
 *
 * @task name = Assign cells to npar action
 *       cycle = 4
 *       owner = Kurt
 *       phase = test
 *       status = done
 *       description = GUI for assign cells to npar action
 */
--%>

<%--
     Using the I18N tag here helps set the appropiate charset for the page.
     This is needed even though this reference to the bundle isn't used
     elsewhere in the page.
--%>
<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>
<i18n:bundle baseName="com.hp.parmgr.ui.Parmgr" id="bundle" />

<%@ page errorPage="exception.jsp" %>
<%@ page import="com.hp.parmgr.ui.SelectionManager,
                 com.hp.parmgr.ui.SessionTimeOut,
                 com.hp.parmgr.ui.UnauthorizedUserException,
                 com.hp.parmgr.model.HWPartition,
                 com.hp.parmgr.model.Discovery,
                 com.hp.parmgr.model.Complex,
                 com.hp.parmgr.model.Cell,
                 com.hp.parmgr.model.CellSlot,
                 com.hp.parmgr.util.Log,
                 com.hp.parmgr.util.StringFormatUtil,
                 java.util.List,
                 java.util.Iterator,
                 java.util.TreeSet" %>
<%@ page import="com.hp.parmgr.ui.tags.Util" %>
<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page pageEncoding="UTF-8"%>

<jsp:useBean id="parsession" scope="session" class="com.hp.parmgr.ui.ParmgrSession" />
<%
    java.util.ResourceBundle pmBundle =
        java.util.ResourceBundle.getBundle( "com.hp.parmgr.ui.Parmgr",
                                            parsession.getLocale());
    java.util.ResourceBundle acBundle =
        java.util.ResourceBundle.getBundle( "com.hp.parmgr.ui.AssignCells",
                                            parsession.getLocale());
    java.util.ResourceBundle tagBundle =
        java.util.ResourceBundle.getBundle( "com.hp.parmgr.ui.tags.tags",
                                            parsession.getLocale());
    java.util.ResourceBundle cmBundle =
        java.util.ResourceBundle.getBundle( "com.hp.parmgr.ui.CreateModifyNpar",
                                            parsession.getLocale());

    // set strings used in the page
    String nparOpt      = "nparID";
    String Continue     = pmBundle.getString( "button.continue.str" );
    String OK           = pmBundle.getString( "button.ok.str" );
    String Cancel       = pmBundle.getString( "button.cancel.str" );
    String Help         = pmBundle.getString( "button.help.str" );
    String pageIntroNParSelected =
                    acBundle.getString( "AssignCells.intro.selection" );
    String pageIntroNoNParSelected =
                    acBundle.getString( "AssignCells.intro.noselection" );
    String pageIntroContinue =
        acBundle.getString( "AssignCells.intro.continue" );
    String pageIntroCancel =
        acBundle.getString( "AssignCells.intro.cancel" );
    String pageTitle    = acBundle.getString( "AssignCells.title" );
    String helpPage     = "assignCellsGeneral";
    String tgtPage      = "modify_npar.jsp";
    String thisPage     = "assign_cells_to_npar.jsp";
    String assignedMsg  = acBundle.getString("AssignCells.error.assigned");
    String tooManyMsg   = acBundle.getString("AssignCells.error.tooMany");
    String noCellsMsg   = acBundle.getString("AssignCells.error.noCells");
    String errCellsMsg  = cmBundle.getString("assignErrorCells.error.str");
    String errCellsLog  = cmBundle.getString("errorCells.error.log");
%>
<HTML>
<HEAD>
<META http-equiv="Content-Type" content="text/html;charset=UTF-8">
<%@ include file="session_keep_alive.jsp" %>
    <link type="text/css" rel="stylesheet" href="<%=Util.URL_PARMGR_CSS%>">
    <script type='text/javascript'
            language='JavaScript'
            src='<%=Util.URL_PARMGR_JS%>' >
    </script>

    <title> <%=pageTitle%> </title>
    <%=SessionTimeOut.javascript(session, bundle.getLocale())%>
    <%@include file="cm_npar_scripts.jsp"%>

</HEAD>

<%
    Discovery discovery = parsession.getDiscovery();

    // Do this after getting discovery
    if (!parsession.userAuthorizedToMakeChanges("parmodify")) {
        throw new UnauthorizedUserException(parsession.getFromURL(), parsession.getLocale());
    }

    // get any possible parameters on the request
    boolean fromCancel   = (request.getParameter("cancel") != null);
    boolean fromContinue = (request.getParameter("continue") != null);
    // JAGaf88550: guard against cross site scripting vulnerabilities,
    // by encoding parameters that may be output to the HTML stream:
    String nparIdStr =
        StringFormatUtil.encodeHtmlEntities(request.getParameter(nparOpt));

    // Are we coming in on a cancel button hit?
    if( fromCancel ) {
        // remove selections from session
        session.removeAttribute( "selectedCells" );
        // log exit, and go back
        Log.summary( Log.EVENT_DONE, Log.RESULT_CANCELED,
                     "Cancel Assign Cells to nPartition" );
        // go back to the "cancel" page
%>
<BODY onload="window.location.replace('<%=parsession.getFromURL()%>')">
</BODY>
</HTML>
<%
   } else if( fromContinue ) {
       // coming in from the continue button
       // leave cell selections on the session
       // log the transition
       // note that the nparID value must be non-null in this case.
       Log.summary(Log.EVENT_DONE, Log.RESULT_SUCCESS,
                   "Transition from Assign Cells To nPartition to Modify nPartition." );
       // and go to modify npar
%>
<BODY onload="window.document.assignCells.submit()">
    <p>
    <b>
    <%=acBundle.getString("AssignCells.goToModify")%>
    </b>
    </p>
    <FORM method="get" action="<%=tgtPage%>" name="assignCells">
    <INPUT type="hidden" name="nparID" value="<%=nparIdStr%>">
    </FORM>
</BODY>
</HTML>
<%
   } else {

    // first time into this page
    // log the task entry.
    Log.summary(Log.EVENT_START, Log.RESULT_NONE,
                "Start Assign Cells to nPartition");

    // Get the data needed for the page
    int              implicitParID = parsession.getImplicitPartitionID();
    SelectionManager selectionMgr  = parsession.getSelectedCheckboxes();

    List    allNPars = discovery.getPartitions();
    Complex complex  = discovery.getComplex();

    // Make a local copy of selection manager to pass to modify npar page
    SelectionManager localSelects  = (SelectionManager) selectionMgr.clone();

    // If we have an implicit cell, make sure that goes into the
    // selected cells set.
    int implicitCellID = parsession.getImplicitCellID();
    if( implicitCellID >= 0 ) {
        localSelects.addSelection(
            SelectionManager.getCellCheckboxID(implicitCellID) );
    }
    TreeSet selectedCells = localSelects.getSelectedCells();

    // There must be at least one cell selected, at least implicitly
    String errorMsg = "";
    boolean haveNoCells = false;
    if( selectedCells.size() <= 0 ) {
        errorMsg = noCellsMsg;
        haveNoCells = true;
        Log.error( "No cells have been selected.");
    }

    // Note: if there are no cells selected, we'll skip the following
    // check as the iterator will be empty.
    // If there are any cells selected, they
    // must be free and they must not be error cells.
    boolean haveAssignedCells = false;
    boolean haveErrorCells = false;
    StringBuffer assignedCellsMsg = new StringBuffer();
    StringBuffer errorCellsMsg = new StringBuffer();
    for( Iterator iter = selectedCells.iterator(); iter.hasNext(); ) {
        int cellID = ((Integer) iter.next()).intValue();
        CellSlot slot = discovery.getCellSlot(cellID);

        // Check for free cell
        if( complex.getCellType(cellID) != Complex.FREE ) {
            if( !haveAssignedCells ) {
                assignedCellsMsg.append(assignedMsg);
            }
            Log.error( slot.getLongLabel() + " is already assigned to an nPartition." );
            assignedCellsMsg.append(" " + slot.getLongLabel());
            haveAssignedCells = true;
        }

        // Check for error cell
        Cell cell = discovery.getCell(cellID);
        if (cell != null && cell.isErrorObject()) {
            if (!haveErrorCells) {
                errorCellsMsg.append(errCellsMsg+" ");
                Log.error(errCellsLog);
                haveErrorCells = true;
            } else {
                errorCellsMsg.append("; ");
            }
            errorCellsMsg.append(slot.getLongLabel());
        }
    }
    if (haveErrorCells) {
        errorMsg = errorCellsMsg.toString();
        if (haveAssignedCells) {
            errorMsg += "</p><p>"+assignedCellsMsg.toString();
        }
    } else if (haveAssignedCells) {
        errorMsg = assignedCellsMsg.toString();
    }

    boolean haveError = haveNoCells || haveAssignedCells || haveErrorCells;

    // Get the ID of the selected npar, if there is one
    TreeSet selectedNPars = selectionMgr.getSelectedPartitions();
    int selectedParID = -1;
    if( implicitParID >= 0 ) {
       selectedParID = implicitParID;
    } else if( selectedNPars.size() > 0 ) {
       selectedParID = ((Integer) selectedNPars.first()).intValue();
    }

    if( !haveError && implicitParID < 0 && selectedNPars.size() > 1 ) {
        haveError = true;
        errorMsg  = tooManyMsg;
        Log.error( "More than one nPartition is selected." );
    }

    // assert: only free, non-error cells and 0 or 1 npar is selected.

%>

<BODY>
<p class="subwindow-heading"> <%=pageTitle%> </p>
<p class="parmgr-regular-text">
<%=tagBundle.getString("ComplexScopeLabel")%>
<%=complex.getName()%>
</p>

<p>
</p>
<%
    if( haveError ) {
        // only need OK button that will dismiss the error dialog
        // Message doesn't need additional help.
        // Log an exit.  Error has already been logged.
        Log.summary( Log.EVENT_DONE, Log.RESULT_FAILURE, "Assign Cells to nPartition failed.");
%>
        <%=errorMsg%>
        <form method="post" action="<%=thisPage%>" name="assignCells">
        <p>
        <INPUT class="button"
               type="button"
               value="<%=OK%>"
               name="ok"
               onclick="window.location.replace('<%=parsession.getFromURL()%>')"
               />
        </p>
        </form>
<%
    } else {
        // no error, do the normal page
        // put the selected cells into the parsession
        session.setAttribute( "selectedCells", localSelects );
        if( selectedParID >= 0 ) {
%>
            <%=pageIntroNParSelected%>
<%      } else { %>
            <%=pageIntroNoNParSelected%>
<%      } %>

<br><br> <%=pageIntroContinue%>
<br><br> <%=pageIntroCancel%>
<p>
<form method="post" action="<%=thisPage%>" name="assignCells">

    <table border="0">
<%
    // Start with the selected npar selected, or by default
    // the first one.
    int count = 0;
    for( Iterator iter = allNPars.iterator(); iter.hasNext(); ++count ) {
        HWPartition npar = (HWPartition) iter.next();
        String nparName;
        if (npar.isErrorObject()) {
            nparName = npar.getLabel();
        } else {
            nparName = npar.getLongLabel();
        }
        int nparID = npar.getID();
%>
        <tr> <td class="parmgr-regular-text" >
        <input type="radio" name="<%=nparOpt%>" value="<%=nparID%>"
<%
        // Check this radio button if it matches the selected npar
        // or if it's the first one and there are no selected npars
        if( (selectedParID >= 0 && selectedParID == nparID)
            || (selectedParID < 0 && count == 0) )
        {
%>
            checked
<%      } %>
        >
        <%=nparName%>
        </td> </tr>
<%  } /* end for all npars */ %>
    </table>
    <p>
    <INPUT class="button"
           type="submit"
           name="continue"
           value="<%=Continue%>"
           />
    <INPUT class="button"
           type="submit"
           name="cancel"
           value="<%=Cancel%>"
           />
    <INPUT class="button"
           type="button"
           value="<%=Help%>"
           name="help"
           onclick="showHelp('<%=parsession.getHelpURL(helpPage)%>')"
           />
    </p>

</form>
</p>
<%     } /* if( !haveError */ %>

</BODY>
</HTML>
<% } /* end first time into page */ %>
