<%--
/**
 * @task name = Add action menus to Cell Scope
 *       cycle = 3
 *       phase = TEST
 *       owner = Paul
 *       status = Done
 *       description = One-line fix
 *
 */
--%>

<%@ taglib uri="/com/hp/mx/taglibs/MxTabsTag" prefix="tabs" %>
<%@ taglib uri="/com/hp/parmgr/ui/tags/parmgr" prefix="parmgr" %>
<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>

<%@ page errorPage="exception.jsp" %>
<%@ page import="com.hp.parmgr.util.Menu" %>
<%@ page import="com.hp.parmgr.util.StringFormatUtil" %>
<%@ page import="com.hp.parmgr.model.Complex" %>
<%@ page import="com.hp.parmgr.model.Cell" %>
<%@ page import="com.hp.parmgr.model.CellSlot" %>
<%@ page import="com.hp.parmgr.ui.SessionTimeOut" %>
<%@ page import="com.hp.parmgr.ui.tags.Util" %>
<%@ page import="java.util.List" %>
<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page pageEncoding="UTF-8"%>

<i18n:bundle baseName="com.hp.parmgr.ui.CellView" id="bundle" />
<i18n:bundle baseName="com.hp.parmgr.ui.tags.tags" id="parmgrTagResources" />
<%@ include file="session_init.jsp" %>

<%
    com.hp.parmgr.model.Discovery discovery;
    discovery = parsession.getDiscovery();

    if (request.getParameter("refresh") != null) {
        /* Must clear cache before generating the HTML. */
        discovery.clearCache();
        parsession.setCheckPending(true);
    }
%>

<%@ include file="run_analyze_complex_health.jsp" %>
<%@ include file="check_pending_profile.jsp" %>

<%
    com.hp.parmgr.model.HWPartition partition;
    com.hp.parmgr.model.Complex complex = discovery.getComplex();
    com.hp.parmgr.ui.SelectionManager selectedCheckboxes;
    selectedCheckboxes = parsession.getSelectedCheckboxes();

    // JAGaf88550: guard against cross site scripting vulnerabilities,
    // by encoding parameters that may be output to the HTML stream:
    String szSelected =
        StringFormatUtil.encodeHtmlEntities(request.getParameter("selection"));
    if (szSelected == null) {
        szSelected = "GENERAL";
    }
    boolean isCellIDPresent = true;
    boolean isFreeCell = true;
    boolean validCellID = true;
    String cellLocation = "";
    String INVALID_CELL_ID = "-1";
    String AVAILABLE = "-1";
    String parID = AVAILABLE;
    String partitionName = "";
    int INVALID_CHASSIS_ID = -1;
    int chassisID = INVALID_CHASSIS_ID;

    // JAGaf88550: guard against cross site scripting vulnerabilities,
    // by encoding parameters that may be output to the HTML stream:
    String cellID =
        StringFormatUtil.encodeHtmlEntities(request.getParameter("globalID"));
    if (cellID == null) {
        isCellIDPresent = false;
        cellID = INVALID_CELL_ID;
    }
    int cellIDNum = Integer.parseInt(cellID);
    String fromURL="cell.jsp";

    if (isCellIDPresent) {
        CellSlot cellSlot = discovery.getCellSlot(cellIDNum);
        if (cellSlot != null) {
            cellLocation = cellSlot.getLongLabel();

            isFreeCell = (complex.getCellType(cellIDNum) == Complex.FREE);
            if (!isFreeCell) {
                parID = String.valueOf(complex.getCellAssignment(cellIDNum));
                if (parID != null) {
                   partition = discovery.getPartition(Integer.parseInt(parID));
                   if (partition.isErrorObject()) {
                       partitionName = "(" + partition.getLabel() + ")";
                   } else {
                       partitionName = partition.getName() + "(" + partition.getLabel() + ")";
                   }
                }
            }
            Cell cell = discovery.getCell(cellIDNum);
            if(cell != null && !cell.isErrorObject() && cell.isConnectedToIOChassis() ) {
                chassisID = cell.getConnectedIOChassisID();
            }
        } else {
            validCellID = false;
        }
    }

    /* The following variables indicate to the scope_header.jsp
     * that we are in the cell scope.
     */
    String currentURL = "cell.jsp";
    if (parID.equals(AVAILABLE)) {
        partitionName = parmgrTagResources.getString("Cell.status.available.label");
    }
    String chassisName = null;
    boolean isPartitionValid = true;
    boolean validChassisID = false;
%>

<HTML>
<HEAD>
<META http-equiv="Content-Type" content="text/html;charset=UTF-8">
<META HTTP-EQUIV="expires" CONTENT="0">
<meta http-equiv="Cache-Control" CONTENT="no-cache">
<meta http-equiv="Pragma" CONTENT="no-cache">
<%@ include file="session_keep_alive.jsp" %>
<tabs:MxTabs dumpHeadContent="true" urlBase="<%=Util.URL_BASE%>"/>
<script type='text/javascript' language='JavaScript' src='<%=Util.URL_PARMGR_JS%>'></script>
<%=SessionTimeOut.javascript(session, bundle.getLocale())%>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_PARMGR_CSS%>'>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_HARDWARE_CSS%>'>
<TITLE>Partition Manager - Cell <%=cellID%></TITLE>
</HEAD>

<BODY>
<table border=0 cellpadding=0 cellspacing=0 width="100%" height="100%">
<tr>
    <td>
        <%@ include file="scope_header.jsp" %>
    </td>
</tr>
<tr><td class=smc-filler>
<table border="0" cellpadding="0" cellspacing="0" width="100%">
<tr><td width="100%">
<tabs:MxTabs selection="<%=szSelected%>" style="boris" urlBase="<%=Util.URL_BASE%>">
    <selectors>
        <selector id="GENERAL">
            <label><i18n:message key="tab.General.label" bundle="<%=bundle%>" /></label>
            <url>
                <%=request.getRequestURI()%>?selection=GENERAL&amp;globalID=<%=cellID%>
            </url>
        </selector>
        <selector id="CPUMEM">
            <label><i18n:message key="tab.CPUMem.label" bundle="<%=bundle%>" /></label>
            <url>
                <%=request.getRequestURI()%>?selection=CPUMEM&amp;globalID=<%=cellID%>
            </url>
        </selector>

        <selector id="IO">
            <label><i18n:message key="tab.IO.label" bundle="<%=bundle%>" /></label>
            <url>
                <%=request.getRequestURI()%>?selection=IO&amp;globalID=<%=cellID%>
            </url>
        </selector>
    </selectors>
</tabs:MxTabs>
</td>
<%@ include file="logofflink.jsp"%>
</tr>
</table>
</td></tr>

<tr height="100%"><td bgcolor=white>

<table border=0 cellpadding=0 cellspacing=8 width="100%" height="100%">
<tr>
  <td>

<%
   String pageID="";
   String srcJsp="";
   if (!isCellIDPresent) {
     pageID = "error";
     srcJsp = "error.jsp?errorMsgID=ErrorMsg.NoCellID";
   } else if (!validCellID) {
     pageID = "error";
     srcJsp = "error.jsp?errorMsgID=ErrorMsg.InvalidCellID";
   } else if (szSelected.equals("GENERAL")) {
     pageID = "cellGeneralView";
     srcJsp = "cell_general.jsp?globalID=" + cellID;
   } else if (szSelected.equals("CPUMEM")) {
     pageID = "cellCPUMemView";
     srcJsp = "cell_cpu_mem.jsp?globalID=" + cellID;
   } if (szSelected.equals("IO")) {
     pageID = "cellIOView";
     srcJsp = "cell_io.jsp?globalID=" + cellID;
   }

   selectedCheckboxes.resetVisibleCheckboxes();
   parsession.setImplicitPartitionID(Integer.parseInt(parID));
   parsession.setImplicitCellID(cellIDNum);
   parsession.setImplicitChassisID(chassisID);
   parsession.setPageID(pageID);
   parsession.setFromURL(fromURL + "?selection=" + szSelected +
                         "&globalID=" + cellID);


%>

    <iframe name="FRAME_PARMGR_WORKSPACE" id="FRAME_PARMGR_WORKSPACE"
        scrolling=auto frameborder=0 width="100%" height="100%"
        src="<%=srcJsp%>">
    </iframe>
    </td>

<%-- /* Note that no source is specified for the menu actions frame in
      * this JSP.  The menu src will be loaded by the workspace frame
      * when it is done loading to ensure that the workspace has
      * completed rendering before the actions menu is created.
      */
--%>

    <td width=220>
    <BR>
    <iframe name="FRAME_PARMGR_ACTIONS" id="FRAME_PARMGR_ACTIONS"
        scrolling=auto frameborder=0 width="100%" height="100%"
        src="dummy.jsp">
    </iframe>
    </td>
  </tr>
</table>

</td></tr>
</table>

</BODY>
</HTML>
