<%--
/**
 * Table for setting cell options.
 * <p>
 * This table contains the selection menus for setting cell options.
 *
 * @version $Header: /usr/local/vse/parmgr/src/web/jsp/cell_config_table.jsp,v 1.23 2007/03/02 21:41:12 scheetz Exp $
 * @risk Medium
 */
--%>

<!-- begin cell config table -->
        <table class="item-list">
        <thead><tr>
            <td class=item-list-header-row>
                <i18n:message key="field.HardwareLocation.label" bundle="<%=bundle%>"/>
            </td>
            <td class=item-list-header-row>
                <i18n:message key="field.ConnectedTo.label" bundle="<%=bundle%>"/>
            </td>
            <td class=item-list-header-row>
                <i18n:message key="field.CanBeCore.label" bundle="<%=bundle%>"/>
            </td>
            <td class=item-list-header-row>
                <i18n:message key="field.CellType.no.asterisk.label" bundle="<%=bundle%>"/>
            </td>
            <td class=item-list-header-row>
                <i18n:message key="field.UseOnNextBoot.label" bundle="<%=bundle%>"/>
            </td>
            <td class=item-list-header-row>
                <i18n:message key="field.FailureUsage.label" bundle="<%=bundle%>"/>
            </td>
            <td class=item-list-header-row>
                <i18n:message key="field.CoreCellChoice.label" bundle="<%=bundle%>"/>
            </td>
        </tr></thead>
        <tbody>

<%
    int cab, bay, chassis;
    TreeMap cells = parConfig.getCellBeans();

    int numCoreChoices = 0;
    if (! haveErrorCells) {
        // Get the number of core cell choices to put into the selection
        // menu in the set core choice column.  We don't want to give the
        // user more choices than they actually have cells for.
        numCoreChoices = parConfig.getNumCoreChoices();
    }

    // Loop through all the cells in the partition and display a row in the
    // cell options table for each.  If there are error cells, selectors
    // are displayed only for the use-on-next-boot column.
    for (Iterator iter = cells.values().iterator(); iter.hasNext();) {

        CellBean cell = (CellBean)iter.next();
        boolean isErrorCell = cell.isErrorObject();

        int cellID = cell.getGlobalID();
        CellSlot cellSlot = discovery.getCellSlot(cellID);
%>
        <tr>

<%
            // First column is the cell's name
%>
            <td class="item-list-row">
                <a class="link" href="javascript:openWindow('cell_properties.jsp?globalID=<%=cellID%>')">
                <%=cellSlot.getLongLabel()%>
                </a>
            </td>
            <td class="item-list-row">
<%
        // Get the chassis the cell is connected to for the "Connected To"
        // column of the table.  For error cells, a question mark (the
        // "unknown" value) is displayed.  For non-error cells that do not
        // have a connected chassis, a dash (the N/A value) is displayed.
        if ( ! isErrorCell) {

            if (cell.isConnectedToIOChassis()){
                IOChassisSlot ioChassisSlot =
                discovery.getChassisSlot(cell.getConnectedIOChassisID());
                cab = ioChassisSlot.getCabinetID();
                bay = ioChassisSlot.getIOBayNumber();
                chassis = ioChassisSlot.getSlotNumber();
%>
                <a class="link" href="javascript:openWindow('chassis_properties.jsp?cab=<%=cab%>&amp;bay=<%=bay%>&amp;chassis=<%=chassis%>')">
                <%=ioChassisSlot.getLongLabel()%>
                </a>
<%          } else {
                // not connected to a chassis
%>
                <i18n:message key="cell.NA.string" bundle="<%=bundle%>"/>
<%          }
        } else {
            // error cell
%>
            <i18n:message key="field.unknown.string" bundle="<%=bundle%>"/>
            <input id="errorCell<%=cellID%>" type="hidden" name="errorCell<%=cellID%>" value="true"/>
<%      } %>
        </td>
        <td class="item-list-row">
<%
        // Get can-be-core-cell for the cell.

        // Determine if the cell can be a core cell.  This information comes
        // from the partition, so we can determine the value for error cells.
        if ( ! isErrorCell) {

            if (cell.canBeCore()) {
%>
                <i18n:message bundle="<%=cellResources%>" key="field.YES.label"/>
                <input type="hidden" name="canBeCore<%=cellID%>" value="true"/>
<%          } else { %>
                <i18n:message bundle="<%=cellResources%>" key="field.NO.label"/>
<%          }
        } else {
            // For error cells in partitions that the user is modifying, we
            // can figure out if the cell can be a core cell from the
            // partition.  If the user is creating a new partition, we can't
            // tell if the cell can be a core cell because the information
            // would have to come from the cell (an error cell).
            HWPartition partition = parConfig.getPartition();
            if (partition != null) {
                // The user is modifying a partition.
                int coreChoice = partition.getCoreCellChoice(cellID);
                if (coreChoice != Cell.CORE_CHOICE_NONE) {
%>
                    <i18n:message bundle="<%=cellResources%>" key="field.YES.label"/>
                    <input type="hidden" name="canBeCore<%=cellID%>" value="true"/>
<%
                } else {
%>
                    <i18n:message bundle="<%=cellResources%>" key="field.NO.label"/>
<%
                }
            } else {
                // The user is creating a partition.
%>
                <i18n:message bundle="<%=bundle%>" key="field.unknown.string"/>
<%
            }
        }
%>

        </td>

<%
        String cellFailureUsageSelector = "failureUsage"+cellID;
        String cellTypeSelector = "cellType"+cellID;

        // Get cell type for the cell.

        // Here, cell is a CellBean, and getType gets the cell type,
        // which comes from the active complex.  So we don't have to
        // worry about error cells.
        int cellType = cell.getType();
%>
        <td class="item-list-row">
                <select size="1" name="<%=cellTypeSelector%>"
                    onChange="adjustCellFailureUsageOptions(
                        this,
                        this.form.<%=cellFailureUsageSelector%>)">
                <option value="<%=Complex.BASE%>"
                    <%=cellType==Complex.BASE ? "selected" : ""%>>
                    <i18n:message key="cell.usage.base" bundle="<%=bundle%>"/>
                </option>
                <option value="<%=Complex.FLOATING%>"
                    <%=cellType==Complex.FLOATING ? "selected" : ""%>>
                    <i18n:message key="cell.usage.floating" bundle="<%=bundle%>"/>
                </option>
                </select>
        </td>

<%
        // Get use-on-next-boot for the cell.

        // This is the only column in which the user may change values when
        // there are error cells in the partition.

        // cell is a CellBean and use-on-next-boot comes from the partition,
        // so it doesn't matter if the cell in the bean is an error cell.
        boolean useOnNextBoot = cell.getUseOnNextBoot();
%>
        <td class="item-list-row">
            <select size="1" name="useOnNextBoot<%=cellID%>">
            <option value="true"
                <%=useOnNextBoot ? "selected" : ""%>>
                <i18n:message bundle="<%=cellResources%>" key="field.YES.label"/>
            </option>
            <option value="false"
                <%=!useOnNextBoot ? "selected" : ""%>>
                <i18n:message bundle="<%=cellResources%>" key="field.NO.label"/>
            </option>
            </select>
        </td>

<%
        // Get failure usage for the cell.

        // cell is a CellBean and failure usage comes from the partition,
        // so it doesn't matter if the cell in the bean is an error cell.
        int failureUsage = cell.getFailureUsage();  %>
        <td class="item-list-row">
        <select size="1" name="<%=cellFailureUsageSelector%>">
<%
        if (cell.getType() == Complex.BASE){
            // only base cells have these choices.
%>
            <option value="<%=HWPartition.NORMAL_FAILURE_USAGE%>"
            <%=failureUsage==HWPartition.NORMAL_FAILURE_USAGE? "selected" : ""%>>
            <i18n:message key="cell.usage.base" bundle="<%=bundle%>"/>
            </option>

            <option value="<%=HWPartition.NO_INTERLEAVE_FAILURE_USAGE%>"
            <%=failureUsage==HWPartition.NO_INTERLEAVE_FAILURE_USAGE ? "selected" : ""%>>
            <i18n:message key="cell.usage.base.no.interleave" bundle="<%=bundle%>"/>
            </option>
<%        } %>

            <option value="<%=HWPartition.FLOATING_FAILURE_USAGE%>"
            <%=failureUsage==HWPartition.FLOATING_FAILURE_USAGE ? "selected" : ""%>>
            <i18n:message key="cell.usage.floating" bundle="<%=bundle%>"/>
            </option>
            <option value="<%=HWPartition.DECONFIGURE_FAILURE_USAGE%>"
            <%=failureUsage== HWPartition.DECONFIGURE_FAILURE_USAGE? "selected" : ""%>>
            <i18n:message key="cell.usage.do.not.use" bundle="<%=bundle%>"/>
            </option>
        </select>
        </td>

        <td class="item-list-row">
<%
        // Get core cell choice for the cell.

        // If there are no error cells, this column contains selectors
        // for those cells that can be core cells.  (It displays the NA
        // string for non-core cells.)  If there are error cells, this
        // column displays the current core cell choices (obtained from
        // the partition, but the user is not allowed to change them).
        //
        // Note that if there are error cells, the partition is guaranteed
        // to exist (we are in modify) because the user is not permitted
        // to get to the cell options screen via create if they have
        // selected error cells.
        String [] choices = { "core.choice.none",
                          "core.choice.first",
                          "core.choice.second",
                          "core.choice.third",
                          "core.choice.fourth"
        };

        if ( ! haveErrorCells) {

            // There are no error cells, so it's business as usual.  Display
            // selectors for the cells that can be core cells and the NA
            // string for those that can't.
            if (cell.canBeCore()) {
%>
                <select size="1" name="coreCellChoice<%=cellID%>"
                    onChange="validateCoreChoices(this.selectedIndex,
                                this.length,
                                this.parentNode.parentNode.rowIndex)">
<%
                int coreCellChoice = cell.getCoreChoice();
                for (int i = 0;
                     i <= numCoreChoices && i <= HWPartitionBean.MAX_CORE_CELLS;
                     ++i)
                {
%>
                    <option
<%
                        // print the key word "selected" according to the
                        // settings of the cell
                        if (coreCellChoice == i) {
                            out.print(" selected ");
                        }
%>
                        value="<%=i%>">
                        <i18n:message key="<%=choices[i]%>" bundle="<%=bundle%>"/>
                    </option>
<%              } %>
                </select>
<%          } else {
                // Cell can't be a core cell, so no selector, just NA (-)
%>
                    <i18n:message key="cell.NA.string" bundle="<%=bundle%>"/>
<%          }
        } else {
            // There are error cells.  Display all of the core cell choices,
            // which we can do even for error cells, since this value comes
            // from the partition.

            HWPartition partition = parConfig.getPartition();
            if (partition != null) {
                // The user is modifying a partition.
                int choice = partition.getCoreCellChoice(cellID);
                if (choice != Cell.CORE_CHOICE_NONE) {
%>
                    <i18n:message key="<%=choices[choice]%>" bundle="<%=bundle%>"/>
<%
                } else {
%>
                    <i18n:message key="cell.NA.string" bundle="<%=bundle%>"/>
<%
                }
%>
<%
            }
        }
%>
        </td>
        </tr>
<%
    }
%>
    </tbody>
    </table>
<%  if (haveErrorCells) { %>
        <input id="haveErrorCells" type="hidden" name="haveErrorCells" value="true"/>
<%  } else { %>
        <input id="haveErrorCells" type="hidden" name="haveErrorCells" value="false"/>
<%  } %>

<!-- end cell config table -->

