<%--
/**
 * The content rendered for the cell cpu/memory workspace page.
 *
 * @version $Header: /usr/local/vse/parmgr/src/web/jsp/cell_cpu_mem.jsp,v 1.19 2008/03/05 12:23:13 sridharav Exp $
 * @risk High
 *
 * @task name = Cell cpu and memory tab
 * cycle = 4
 * phase = TEST
 * owner = Mike
 * status = Done
 * description = The "cpus and memory" tab in the cell scope, referenced from cell.jsp
 *
 */
--%>

<%@ taglib uri="/com/hp/mx/taglibs/MxTabsTag" prefix="tabs" %>
<%@ taglib uri="/com/hp/parmgr/ui/tags/parmgr" prefix="parmgr" %>
<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>

<%@ page import="java.util.List" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="java.util.ListIterator" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="com.hp.parmgr.model.Discovery" %>
<%@ page import="com.hp.parmgr.model.Complex" %>
<%@ page import="com.hp.parmgr.model.HWPartition" %>
<%@ page import="com.hp.parmgr.model.Cell" %>
<%@ page import="com.hp.parmgr.model.CellSlot" %>
<%@ page import="com.hp.parmgr.model.IOChassisSlot" %>
<%@ page import="com.hp.parmgr.ui.SelectionManager" %>
<%@ page import="com.hp.parmgr.ui.tags.PartitionBackgroundKey" %>
<%@ page import="com.hp.parmgr.ui.tags.Util" %>
<%@ page import="com.hp.npar.mof.HP_NParComplex" %>
<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page pageEncoding="UTF-8"%>

<%@ page errorPage="exception.jsp" %>

<jsp:useBean id="parsession" scope="session" class="com.hp.parmgr.ui.ParmgrSession" />

<%
    boolean makeLinks = true;
    String makeLinksStr = request.getParameter("makeLinks");
    if (makeLinksStr != null) {
        makeLinks = new Boolean(request.getParameter("makeLinks")).booleanValue();
    }

    Discovery discovery = parsession.getDiscovery();
    Complex complex = discovery.getComplex();
    SelectionManager selectedCheckboxes = parsession.getSelectedCheckboxes();

    //
    // Fill the cache before getting into the html so that any Locked objects
    // are caught here.
    //
    discovery.getChassisSlots();
    discovery.getAllChassis();

    //
    // Get the cell ID. This ID should have been validated by cell.jsp
    //
    String globalID = request.getParameter("globalID");
    int cellID = (globalID == null) ? 0 : Integer.parseInt(globalID);

    CellSlot cellSlot = discovery.getCellSlot(cellID);

    List cellSlots = new ArrayList();
    cellSlots.add(cellSlot);

    List cells = new ArrayList(1);
    Cell cell = null;
    if (cellSlot.isPopulated()) {
            cell = discovery.getCell(cellID);
        // cell could be an error cell
        cells.add(cell);
    }

    boolean showActualCLM = false;
    boolean showRequestedCLM = false;

    //
    // figure out the partition and whether CLM is supported
    //
    List currentPartition = new ArrayList();
    boolean isFreeCell = (complex.getCellType(cellID) == Complex.FREE);
    if (!isFreeCell) {
        HWPartition partition = discovery.getPartition(complex.getCellAssignment(cellID));
        if (partition != null) {
           // partition could be an error partition
           currentPartition.add(partition);
           showRequestedCLM = true;
               showActualCLM = true;
        }
    }

    double requestedClmAmount = 0;

    if (showRequestedCLM) {
        requestedClmAmount = discovery.getRequestedCLMForCellInGB(cellID);
    }

%>

<HTML>
<HEAD>
<META http-equiv="Content-Type" content="text/html;charset=UTF-8">
<META HTTP-EQUIV="expires" CONTENT="0">
<%@ include file="session_keep_alive.jsp" %>
<i18n:bundle baseName="com.hp.parmgr.ui.ComplexView" id="bundle" />
<i18n:bundle baseName="com.hp.parmgr.ui.tags.tags" id="parmgrTagResources" />

<script type='text/javascript' language='JavaScript' src='<%=Util.URL_PARMGR_JS%>'>
</script>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_PARMGR_CSS%>'>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_HARDWARE_CSS%>'>
</HEAD>

<%
if (makeLinks) {
%>
<BODY onLoad="loadMenuFrame('<%=Util.URL_BASE_JSP%>')">
<%
} else {
%>
<BODY>
<%
}
%>

<%-- Begin overall table --%>
<table border=0 cellspacing=2 cellpadding=0>

  <%-- Begin first row in overall table --%>
  <tr>
    <td>

      <%-- Begin summary tables table --%>
      <table border="0" cellspacing="2" cellpadding="0">

        <tr>

          <%-- CPUs table --%>
          <td valign="top">
            <parmgr:cpusummarytable cells="<%=cells%>"
                                    resources="<%=parmgrTagResources%>" />
          </td>

          <%-- Memory table --%>

          <td valign="top">
           <parmgr:memorysummarytable cells="<%=cells%>"
                                      resources="<%=parmgrTagResources%>"
                                      showRequestedCLM="<%=showRequestedCLM%>"
                                      showActualCLM="<%=showActualCLM%>"
                                      requestedClmAmount =
                                                  "<%=requestedClmAmount%>"/>
          </td>
        </tr>

      </table>
      <%-- End summary tables table --%>

    </td>
  </tr>
  <%-- End second row in overall table --%>

  <tr>
    <td>
        <hr class="separator">
        <parmgr:partitionkey partitions="<%=currentPartition%>"
                             resources="<%=parmgrTagResources%>"
                             showCheckboxes="false"
                             selectedCheckboxes="<%=selectedCheckboxes%>"
                             links="<%=makeLinks%>" />
    </td>
  </tr>

  <%-- Begin third row in overall table --%>
  <tr>
    <td>

      <%-- Begin cells table --%>
      <table border=0 cellspacing="5" cellpadding="2">
      <tr>

      <td valign="top">

        <%-- Begin an individual cell/chassis table --%>
        <table border=0 cellspacing="0" cellpadding="0">

        <%-- Begin cell row --%>
        <tr>
          <td align="center">
            <parmgr:cellinfo discovery="<%=discovery%>"
                             slot="<%=cellSlot%>"
                             showCheckboxes="false"
                             resources="<%=parmgrTagResources%>"
                             showDimms="true"
                             showPartition="true"
                             showCPUs="true"
                             links="<%=makeLinks%>"
                             selectedCheckboxes="<%=selectedCheckboxes%>" />
          </td>
        </tr>
        <%-- End cell row --%>

<%
        if (cellSlot.isPopulated())
        {
          cell = discovery.getCell(cellSlot.getGlobalID());
          if (!cell.isErrorObject() && cell.isConnectedToIOChassis())
          {
            IOChassisSlot chassisSlot = discovery.getChassisSlot(cell.getConnectedIOChassisID());

%>

        <%-- Begin cell/chassis connector row --%>
        <tr>
          <td align="center">
              <img height="20" width="12" border="0"
                 src="<%=Util.URL_BASE_IMAGES + "/cv.gif"%>" alt="connected to">
          </td>
        </tr>
        <%-- End cell/chassis connector row --%>

        <%-- Begin chassis row --%>
        <tr>
          <td align="center">

              <parmgr:chassisinfo discovery="<%=discovery%>"
                               slot="<%=chassisSlot%>"
                               resources="<%=parmgrTagResources%>"
                               showCheckboxes="false"
                               showSlots="false"
                               showPartition="true"
                               links="<%=makeLinks%>"
                               selectedCheckboxes="<%=selectedCheckboxes%>" />

          </td>
        </tr>

<%
          } // if (cell.isConnectedToIOChassis())
        } // if (cellSlot.isPopulated())
%>

        </table>
      </td>

      </tr>
      </table>
      <%-- End cells table --%>

    </td>
  </tr>
  <%-- End third row in overall table --%>

<%-- End overall table --%>
</table>

</BODY>
</HTML>

