<%--
/**
 * The content for the body of the cell general tab and the
 * complex details page.
 *
 * @precondition The boolean variable "makeLinks" must
 *               be set to either true or false depending
 *               on whether items such as the partition
 *               assignment should be displayed as a link.
 *               If make links is not null, and is equal,
 *               ignoring case, to the string "true", then
 *               the links will be displayed.  See the
 *               constructor for Boolean(String).
 *               <p>
 *               The following style sheets must be loaded
 *               in the "head" section of the including jsp:
 *               .  /parmgr/css/parmgr.css
 *               .  /parmgr/css/hardware.css
 *               <p>
 *               The following java scripts must be loaded
 *               in the "head" section of the including jsp:
 *               .  /parmgr/js/parmgr.js
 *
 * @version $Header: /usr/local/vse/parmgr/src/web/jsp/cell_general_body.jsp,v 1.27 2006/03/27 17:20:51 scheetz Exp $
 */
--%>

<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>
<%@ taglib uri="/com/hp/parmgr/ui/tags/parmgr" prefix="parmgr" %>

<%@ page import="com.hp.parmgr.model.Discovery" %>
<%@ page import="com.hp.parmgr.model.Complex" %>
<%@ page import="com.hp.parmgr.model.HWPartition" %>
<%@ page import="com.hp.parmgr.model.Cell" %>
<%@ page import="com.hp.parmgr.model.CellSlot" %>
<%@ page import="com.hp.parmgr.model.IOChassis" %>
<%@ page import="com.hp.parmgr.model.IOChassisSlot" %>
<%@ page import="com.hp.parmgr.ui.tags.Util" %>
<%@ page import="com.hp.npar.mof.HP_NParComplex" %>
<%@ page import="com.hp.npar.mof.HP_NParPartition" %>
<%@ page import="com.hp.npar.mof.HP_NParComponent" %>
<%@ page import="com.hp.npar.mof.HP_NParCell" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="java.util.List" %>
<%@ page import="java.util.ResourceBundle" %>


<%@ page errorPage="exception.jsp" %>

<i18n:bundle baseName="com.hp.parmgr.ui.CellView" id="cellViewResources" />
<i18n:bundle baseName="com.hp.parmgr.ui.tags.tags" id="parmgrTagResources" />
<i18n:bundle baseName="com.hp.parmgr.ui.Global" id="globalResources" />
<i18n:bundle baseName="com.hp.parmgr.ui.Arches" id="archesResources" />

<jsp:useBean id="parsession" scope="session" class="com.hp.parmgr.ui.ParmgrSession" />

<%
   Discovery discovery  = parsession.getDiscovery();
   Complex complex      = discovery.getComplex();
   HWPartition partition = null;

   String makeLinksStr = request.getParameter("makeLinks");
   boolean makeLinks = new Boolean(makeLinksStr).booleanValue();

   String cellID = request.getParameter("globalID");

   int globalID = Integer.parseInt(cellID);
   int parID = -1;
   Cell cell = discovery.getCell(globalID);
   CellSlot cellSlot = discovery.getCellSlot(globalID);

   /*
    * Define some strings we use for unknown and not applicable fields.
    */
   String unknownStr = globalResources.getString("Application.Unknown.field");
   String naStr      = globalResources.getString("Application.NA.field");
   String yesStr     = globalResources.getString("Application.Yes.field");
   String noStr      = globalResources.getString("Application.No.field");

   boolean isErrorCell = cell.isErrorObject();

   boolean isFreeCell = (complex.getCellType(globalID) == Complex.FREE);

   /*
    * Initialize field values to unknown then figure them out if possible.
    */
   String useOnNextBoot = naStr;

   String partitionLabel = naStr;
   String isCoreCellCapable = unknownStr;
   String cellStatusImageKey = null;
   String cellStatusString;
   String ioChassisLabel = unknownStr;
   String cellArchitectureString = unknownStr;
   String cellCompatibilityString = unknownStr;
   String firmwareRevision = unknownStr;
   String actualUsageString = unknownStr;
   String normalUsageString = unknownStr;
   String failureUsageString = naStr;
   String cpuSpeed = unknownStr;
   String cpuCount = unknownStr;
   String installedDIMMsCount = unknownStr;
   String totalMemoryInstalledStringInGB = unknownStr;
   String sbaInitialized = unknownStr;
   String numIOCards = unknownStr;
   String isGSMCapable = unknownStr;
   String isHyperThreadCapable = unknownStr;

   ResourceBundle complexMofBundle = ResourceBundle.getBundle("com.hp.npar.mof.HP_NParComplex", parsession.getLocale());
   normalUsageString = complexMofBundle.getString(HP_NParComplex.PROP_CellType + "_" + complex.getCellType(globalID));

   //
   // Determine partition-related properties
   //
   if (!isFreeCell)
   {
       parID = complex.getCellAssignment(globalID);
       partition = discovery.getPartition(parID);

       String partitionName;

       if ( partition.isErrorObject() ) {
           useOnNextBoot = unknownStr;
           failureUsageString = unknownStr;
           partitionName = "(" + partition.getLabel() + ")";
       }
       else {
           useOnNextBoot = ( partition.getCellUseOnNextBoot(globalID) ) ? yesStr : noStr;
           ResourceBundle parMofBundle = ResourceBundle.getBundle("com.hp.npar.mof.HP_NParPartition", parsession.getLocale());
           failureUsageString = parMofBundle.getString(HP_NParPartition.PROP_FailureUsage + "_" + partition.getFailureUsage(globalID));
           partitionName = partition.getName() + "(" + partition.getLabel() + ")";
       }

       partitionLabel = "<img src='" +
           com.hp.parmgr.ui.tags.PartitionKey.getIcon(Util.URL_BASE, partition.getID()) +
           "' align='absmiddle'>&nbsp;";

       if (makeLinks) {
           partitionLabel += "<a class=\"link\" href=\"partition.jsp?partition=" +
               parID + "\" target=\"_parent\">" + partitionName +
               "</a>";
       }
       else {
           partitionLabel += partitionName;
       }
   }

   if (isErrorCell)
   {

       if (cell.getLockOwner() != null) {
           cellStatusImageKey = "locked";
           cellStatusString = globalResources.getString("Application.LockError.field");
       }
       else {
           cellStatusImageKey = "error";
           cellStatusString = globalResources.getString("Application.ReadError.field");
       }

   }
   else {
       /**
        * get cell architecture string, cell CPU type string,
        * firmware revision string, actual usage string, CPU speed,
        * CPU count, installed DIMMs count, and install memory (GB)
        */

       //
       // Set up the resources needed to localize the cell status.
       //
       ResourceBundle compMofBundle = ResourceBundle.getBundle("com.hp.npar.mof.HP_NParComponent",
                                                               parsession.getLocale());
       ResourceBundle cellMofBundle = ResourceBundle.getBundle("com.hp.npar.mof.HP_NParCell",
                                                               parsession.getLocale());


       cellArchitectureString = cell.getCellArchitectureString();
       cellCompatibilityString = cell.getCellCompatibilityLabelString();
       firmwareRevision = cell.getFirmwareRevision();
       actualUsageString = cellMofBundle.getString(HP_NParCell.PROP_CellUsage + "_" + cell.getActualUsage());
       cpuCount = Integer.toString(cell.getCPUCount());

       /* Determine Cell Status icon and string */
       if (cell.hasFailedOrDeconfiguredDevices() ) {
           cellStatusImageKey = "minor";
       }
       else {
           cellStatusImageKey = Integer.toString(cell.getStatus());
       }

       cellStatusString = compMofBundle.getString(HP_NParComponent.PROP_ComponentStatus + "_" + cell.getStatus());

       if ((!isFreeCell) &&
           (cell.getStatus() == cell.ACTIVE) &&
           (!partition.isErrorObject()) &&
           (partition.getCoreCellID() == globalID))
       {
           // this is the core cell, and it's active. We are not making the
           // core string internationalizable because we are conncatenating it
           // to a provider string, which is not internationalizable.
           cellStatusString += " Core";
       }


       IOChassisSlot ioChassisSlot = null;

       if (cell.getStatus() < Cell.INACTIVE)
       {
           //
           // We can't get some information about cells when they
           // are powered-off or in POST.
           //
           //
           // The chassis generally know what cell they are connected
           // to even when the cell is powered off. Look through the
           // chassis list to see if any are connected to this cell.
           //
           List allChassis = discovery.getAllChassis();
           for (Iterator iter = allChassis.iterator(); iter.hasNext();)
           {
               IOChassis chassis = (IOChassis) iter.next();
               if (chassis.isConnected() &&
                   (chassis.getConnectedCellID() == globalID )) {
                   ioChassisSlot = discovery.getChassisSlot(chassis.getSlotID());
                   break;
               }
           }
       }
       else // status >= Cell.INACTIVE
       {
           isCoreCellCapable = (cell.isCoreCellCapable()) ? yesStr : noStr;
           cpuSpeed = Long.toString(cell.getCPUSpeed()) + " MHz";
           installedDIMMsCount = Integer.toString(cell.getInstalledDIMMsCount());
           totalMemoryInstalledStringInGB = cell.getTotalMemoryInstalledStringInGB();
           isGSMCapable = (cell.isGsmCapable()) ? yesStr : noStr;
           isHyperThreadCapable = (cell.isHyperThreadCapable()) ? yesStr : noStr;

           /* get connected io chassis label and the SBA initialized label */

           if ( !cell.isConnectedToIOChassis() ) {
               ioChassisLabel = parmgrTagResources.getString("Cell.notConnected");
               sbaInitialized = naStr;
               numIOCards = naStr;
           }
           else {
               int ioChassisID = cell.getConnectedIOChassisID();
               ioChassisSlot = discovery.getChassisSlot(ioChassisID);

               sbaInitialized = ( cell.isREOInitialized() ) ? yesStr : noStr;

               IOChassis chass = discovery.getChassis(ioChassisSlot);
               numIOCards = Integer.toString(chass.getPopulatedPCISlotCount());

           }

       }

       //
       // If we found an attached chassis,
       // create the label for the chassis.
       //
       if (ioChassisSlot != null)
       {
           if (makeLinks) {
               ioChassisLabel = "<a class='link' target='_parent' href='chassis.jsp?cab=" +
                   ioChassisSlot.getCabinetID() +
                   "&bay=" + ioChassisSlot.getIOBayNumber() +
                   "&chassis=" + ioChassisSlot.getNumber() + "'>" +
                   ioChassisSlot.getLongLabel() + "</a>";
           }
           else {
               ioChassisLabel = ioChassisSlot.getLongLabel();
           }

       }

   } // ! isErrorCell

   //
   // Determine the URL of the status image from the resource key figured
   // out above.
   //
   String cellStatusImage = Util.URL_BASE_IMAGES + "/" +
       parmgrTagResources.getString("Cell.status." + cellStatusImageKey + ".image");

%>

 <tr>
    <td>
      <table>
        <tr>
          <td>
            <img src="<%=Util.URL_BASE_IMAGES + "/cell_temp.gif"%>" width="216" height="289" align="absmiddle">
          </td>
        </tr>
      </table>
    </td>
    <td>
      <table class="properties" border="0" cellspacing="2" cellpadding="0" width="100%">
        <tr>
          <td colspan="2" class="prop-table-caption">
            <i18n:message key="generalTab.cell.generalProperties"
                          bundle="<%=globalResources%>"/>
          </td>
        </tr>
        <tr>
          <td class="prop-table-header">
            <i18n:message key="field.GlobalCellNumber.label"
                          bundle="<%=cellViewResources%>"/>
          </td>
          <td class="prop-table-data">
             <%=globalID%>
          </td>
        </tr>
        <tr>
          <td class="prop-table-header">
            <i18n:message key="field.CellLocation.label"
                          bundle="<%=cellViewResources%>"/>
          </td>
          <td class="prop-table-data">
            <%=cellSlot.getLongLabel()%>
          </td>
        </tr>
        <tr>
          <td class="prop-table-header">
            <i18n:message key="field.PartitionAssignment.label"
                          bundle="<%=cellViewResources%>"/>
          </td>
          <td class="prop-table-data">
            <%=partitionLabel%>
          </td>
        </tr>
        <tr>
          <td class="prop-table-header">
            <i18n:message key="field.CellArchitecture.label"
                          bundle="<%=cellViewResources%>"/>
          </td>
          <td class="prop-table-data">
            <%=cellArchitectureString%>
          </td>
        </tr>
        <tr>
          <td class="prop-table-header">
            <i18n:message key="field.Compatibility.label"
                          bundle="<%=cellViewResources%>"/>
          </td>
          <td class="prop-table-data">
            <%=cellCompatibilityString%>
          </td>
        </tr>
        <tr>
          <td class="prop-table-header">
            <i18n:message key="field.IOChassisConnection.label"
                          bundle="<%=cellViewResources%>"/>
          </td>
          <td class="prop-table-data">
            <%=ioChassisLabel%>
          </td>
        </tr>
        <tr>
          <td class="prop-table-header">
            <i18n:message key="field.FirmwareRevision.label"
                          bundle="<%=cellViewResources%>"/>
          </td>
          <td class="prop-table-data">
            <%=firmwareRevision%>
          </td>
        </tr>
        <tr>
          <td class="prop-table-header">
            <i18n:message key="field.Status.label"
                          bundle="<%=cellViewResources%>"/>
          </td>
          <td class="prop-table-data">
            <img src='<%=cellStatusImage%>'> <%=cellStatusString%>
          </td>
        </tr>
        <tr>
          <td class="prop-table-header">
            <i18n:message key="field.ActualUsage.label"
                          bundle="<%=cellViewResources%>"/>
          </td>
          <td class="prop-table-data">
            <%=actualUsageString%>
          </td>
        </tr>
        <tr>
          <td class="prop-table-header">
            <i18n:message key="field.NormalUsage.label"
                          bundle="<%=cellViewResources%>"/>
          </td>
          <td class="prop-table-data">
            <%=normalUsageString%>
          </td>
        </tr>
        <tr>
          <td class="prop-table-header">
            <i18n:message key="field.FailureUsage.label"
                          bundle="<%=cellViewResources%>"/>
          </td>
          <td class="prop-table-data">
            <%=failureUsageString%>
          </td>
        </tr>
        <tr>
          <td class="prop-table-header">
            <i18n:message key="field.UseOnNextBoot.label"
                          bundle="<%=cellViewResources%>"/>
          </td>
          <td class="prop-table-data">
            <%=useOnNextBoot%>
          </td>
        </tr>
        <tr>
          <td class="prop-table-header">
            <i18n:message key="field.CoreCellCapable.label"
                          bundle="<%=cellViewResources%>"/>
          </td>
          <td class="prop-table-data">
            <%=isCoreCellCapable%>
          </td>
        </tr>
        <tr>
          <td class="prop-table-header">
            <i18n:message key="field.ClockSpeed.label"
                          bundle="<%=cellViewResources%>"/>
          </td>
          <td class="prop-table-data">
            <%=cpuSpeed%>
          </td>
        </tr>
<%-- @TODO:  Un-comment for the official Montecito release
        <tr>
          <td class="prop-table-header">
            <i18n:message key="cell.general.gsm.capable"
                          bundle="<%=archesResources%>"/>
          </td>
          <td class="prop-table-data">
            <%=isGSMCapable%>
          </td>
        </tr>
--%>
        <tr>
          <td class="prop-table-header">
            <i18n:message key="cell.general.hyperthread.capable"
                          bundle="<%=archesResources%>"/>
          </td>
          <td class="prop-table-data">
            <%=isHyperThreadCapable%>
          </td>
        </tr>
        <tr>
          <td class="prop-table-header-last">
            <i18n:message key="field.SbaInitialized.label"
                          bundle="<%=cellViewResources%>"/>
          </td>
          <td class="prop-table-data-last">
            <%=sbaInitialized%>
          </td>
        </tr>

        <tr>
          <td>
          &nbsp;
          </td>
        </tr>

        <tr>
          <td colspan="2" class="prop-table-caption">
            <i18n:message key="generalTab.summaryLabel"
                          bundle="<%=globalResources%>"/>
          </td>
        </tr>
        <tr>
          <td class="prop-table-header">
            <i18n:message key="generalTab.summaryTable.numCPUs"
                          bundle="<%=globalResources%>"/>
          </td>
          <td align="right" class="prop-table-data">
            <%=cpuCount%>
          </td>
        </tr>
        <tr>
          <td class="prop-table-header">
            <i18n:message key="generalTab.summaryTable.numDIMMs"
                          bundle="<%=globalResources%>"/>
          </td>
          <td align="right" class="prop-table-data">
            <%=installedDIMMsCount%>
          </td>
        </tr>
        <tr>
          <td class="prop-table-header">
            <i18n:message key="generalTab.summaryTable.amountMem"
                          bundle="<%=globalResources%>"/>
          </td>
          <td align="right" class="prop-table-data">
            <%=totalMemoryInstalledStringInGB%>
          </td>
        </tr>
        <tr>
          <td class="prop-table-header-last">
            <i18n:message key="generalTab.summaryTable.numIOCards"
                          bundle="<%=globalResources%>"/>
          </td>
          <td align="right" class="prop-table-data-last">
            <%=numIOCards%>
          </td>
        </tr>
      </table>
    </td>
  </tr>
