<%--
/**
 * The content rendered for the cell I/O tab.
 *
 * @task name = Implement I/O functionality for Cell Scope.
 * cycle = 4
 * owner = Paul
 * phase = TEST
 * status = Done
 * description = I/O for Cells.
 *
 * @version $Header: /usr/local/vse/parmgr/src/web/jsp/cell_io.jsp,v 1.17 2008/03/05 12:23:13 sridharav Exp $
 * @risk: Low
 *
 */
--%>

<%@ taglib uri="/com/hp/parmgr/ui/tags/parmgr" prefix="parmgr" %>
<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>


<%@ page errorPage="exception.jsp" %>

<jsp:useBean id="parsession" scope="session" class="com.hp.parmgr.ui.ParmgrSession" />

<%@ page import="java.util.List" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="com.hp.parmgr.model.Discovery" %>
<%@ page import="com.hp.parmgr.model.Complex" %>
<%@ page import="com.hp.parmgr.model.HWPartition" %>
<%@ page import="com.hp.parmgr.model.IOChassisSlot" %>
<%@ page import="com.hp.parmgr.model.IOChassis" %>
<%@ page import="com.hp.parmgr.model.Cell" %>
<%@ page import="com.hp.parmgr.ui.SelectionManager" %>
<%@ page import="com.hp.parmgr.ui.tags.Util" %>
<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page pageEncoding="UTF-8"%>

<i18n:bundle baseName="com.hp.parmgr.ui.Parmgr" id="parmgrProperties" />
<i18n:bundle baseName="com.hp.parmgr.ui.tags.tags" id="parmgrTagResources" />

<%
    boolean makeLinks = true;
    String makeLinksStr = request.getParameter("makeLinks");
    if (makeLinksStr != null) {
        makeLinks = new Boolean(request.getParameter("makeLinks")).booleanValue();
    }

    /*
     * Cell is guaranteed to be valid because it's checked in
     * cell.jsp prior to loading the cell_io.jsp workspace iframe.
     */
    String cellID = request.getParameter("globalID");

    Discovery discovery;
    Complex complex;
    Cell cell;
    int numChassisSlots = 0;

    discovery = parsession.getDiscovery();
    complex = discovery.getComplex();

    cell = discovery.getCell(Integer.parseInt(cellID));

    if (!cell.isErrorObject() && cell.isConnectedToIOChassis()) {
        /* Cell is connected to an I/O chassis */

        HWPartition partition;
        SelectionManager selectedCheckboxes;
        IOChassisSlot ioChassisSlot;
        IOChassis ioChassis;
        selectedCheckboxes = parsession.getSelectedCheckboxes();
        boolean isConnected = false;

        /*
         * The partitionkey taglib expects a list of partitions but in
         * this case we don't have a list.  So we'll build one and stick
         * our single partition in it.
         */

        List currentPartition = new ArrayList();
        boolean isFreeCell = (complex.getCellType(Integer.parseInt(cellID)) == Complex.FREE);
        if (!isFreeCell) {
           partition = discovery.getPartition(complex.getCellAssignment(Integer.parseInt(cellID)));
           if (partition != null) {
              // This could be an error object
              currentPartition.add(partition);
           }
        }

        /*
         * Get the I/O Chassis slot and add the I/O Chassis to the list
         * which is required by the iosummarytable taglib.
         */

        List ioChassisList = new ArrayList();
        ioChassisSlot = discovery.getChassisSlot(cell.getConnectedIOChassisID());
        numChassisSlots ++;

        if (ioChassisSlot.isPopulated()) {
            ioChassis = discovery.getChassis(ioChassisSlot);
            // This could be an error object
            ioChassisList.add(ioChassis);
        }

%>

<HTML>
<HEAD>
<META http-equiv="Content-Type" content="text/html;charset=UTF-8">
<META HTTP-EQUIV="expires" CONTENT="0">
<%@ include file="session_keep_alive.jsp" %>
<script type='text/javascript' language='JavaScript' src='<%=Util.URL_PARMGR_JS%>'></script>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_PARMGR_CSS%>'>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_HARDWARE_CSS%>'>

<i18n:bundle baseName="com.hp.parmgr.ui.Parmgr" id="bundle" />
</script>
</HEAD>

<%
if (makeLinks) {
%>
<BODY onLoad="loadMenuFrame('<%=Util.URL_BASE_JSP%>')">
<%
} else {
%>
<BODY>
<%
}
%>

<!-- begin overall table -->
<table border=0 cellpadding=0 cellspacing=10>
  <!-- begin first row in overall table -->
  <tr>
    <td class="subwindow-heading">
      <%=parmgrTagResources.getString("CellIOViewLabel")%>
    </td>
  </tr>
  <!-- end first row in overall table -->

  <!-- begin second row in overall table -->
  <tr>
    <td>
      <!-- begin I/O summary table -->
      <parmgr:iosummarytable ioChassisList="<%=ioChassisList%>"
                             numIOChassisSlots="<%=numChassisSlots%>"
                             resources="<%=parmgrTagResources%>"
                             showPresentAbsentChassis="false" />
      <!-- end I/O summary table -->
    </td>
  </tr>
  <!-- end second row in overall table -->

  <!-- begin third row in overall table -->
  <tr>
    <td>
      <HR class="separator">
    </td>
  </tr>
  <!-- end third row in overall table -->

  <!-- begin fourth row in overall table -->
  <tr>
    <td class="subwindow-heading">
      <%=parmgrTagResources.getString("DetailsLabel")%>
    </td>
  </tr>
  <!-- end fourth row in overall table -->

  <!-- begin fifth row in overall table -->
  <tr>
    <td>
      <!-- begin partition key -->
      <parmgr:partitionkey partitions="<%=currentPartition%>"
                           showCheckboxes="false"
                           showAvailable="<%=currentPartition.size() == 0%>"
                           resources="<%=parmgrTagResources%>"
                           selectedCheckboxes="<%=selectedCheckboxes%>"
                           links="<%=makeLinks%>" />
      <!-- end partition key -->
    </td>
  </tr>
  <!-- end fifth row in overall table -->

  <!-- begin sixth row in overall table -->
  <tr>
    <td>
      <table border=0 cellspacing=0 cellpadding=5>
        <tr>

        <td>
          <table border=0 cellpadding=0 cellspacing=0>
          <tr>
            <td>
              <parmgr:chassisinfo discovery="<%=discovery%>"
                                slot="<%=ioChassisSlot%>"
                                resources="<%=parmgrTagResources%>"
                                showCheckboxes="false"
                                showSlots="true"
                                showPartition="true"
                                links="<%=makeLinks%>"
                                selectedCheckboxes="<%=selectedCheckboxes%>" />
          </td>
          <td>

            <img height="12" width="28" src="<%=Util.URL_BASE_IMAGES + "/ch.gif"%>"
               alt='<i18n:message key="field.ChassisConnector.text" bundle="<%=parmgrProperties%>" />'>

          </td>
          <td>
          <parmgr:cellinfo discovery="<%=discovery%>"
                           slot="<%=discovery.getCellSlot(Integer.parseInt(cellID))%>"
                           resources="<%=parmgrTagResources%>"
                           showCheckboxes="false"
                           showDimms="false"
                           showPartition="true"
                           showCPUs="false"
                           links="<%=makeLinks%>"
                           selectedCheckboxes="<%=selectedCheckboxes%>" />
          </td>
        </tr>
      </table>
    </td>

  </tr>
  </table>
  </td>
  </tr>
  <!-- end sixth row in overall table -->

</table>
<!-- end overall table -->

<%

    } // if cell not an error object and cell.isConnectedToIOChassis())
    else if (cell.isErrorObject()) { %>
        <HTML>
        <HEAD>
        <META HTTP-EQUIV="expires" CONTENT="0">
        <%@ include file="session_keep_alive.jsp" %>
        <link type='text/css' rel='stylesheet' href='<%=Util.URL_PARMGR_CSS%>'>
        </HEAD>
        <BODY>
        <%=parmgrTagResources.getString("CellIOView.CellIsErrorObject")%>
<%  } else { // Cell is not connected to an I/O chassis %>
        <HTML>
        <HEAD>
        <META HTTP-EQUIV="expires" CONTENT="0">
        <%@ include file="session_keep_alive.jsp" %>
        <link type='text/css' rel='stylesheet' href='<%=Util.URL_PARMGR_CSS%>'>
        </HEAD>
        <BODY>
        <%=parmgrTagResources.getString("CellIOView.CellNotConnectedLabel")%>
<%  } %>

</BODY>
</HTML>
