<%--
/**
 * The JSP page for powering off a cell
 *
 * @version $Header: /usr/local/vse/parmgr/src/web/jsp/cell_power.jsp,v 1.25 2008/03/05 12:23:13 sridharav Exp $
 * @risk Medium
 *
 */
--%>

<%@ page errorPage="exception.jsp" %>
<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>
<%@ page import="com.hp.parmgr.ui.SessionTimeOut,
                 com.hp.parmgr.ui.CellPower,
                 com.hp.parmgr.ui.RunCellPower,
                 com.hp.parmgr.ui.CheckCellPower,
                 com.hp.parmgr.ui.UnauthorizedUserException,
                 com.hp.parmgr.ui.DialogException,
                 com.hp.parmgr.util.WaitForCellToPowerOn,
                 com.hp.parmgr.util.StringFormatUtil,
                 com.hp.parmgr.model.Discovery,
                 java.text.MessageFormat,
                 java.util.ResourceBundle" %>
<%@ page import="com.hp.parmgr.ui.tags.Util" %>
<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page pageEncoding="UTF-8"%>

<jsp:useBean
    id="parsession"
    scope="session"
    class="com.hp.parmgr.ui.ParmgrSession" />

<i18n:bundle baseName="com.hp.parmgr.ui.tags.tags" id="bundle" />
<i18n:bundle baseName="com.hp.parmgr.ui.PowerCell" id="powerCell" />
<i18n:bundle baseName="com.hp.parmgr.ui.Parmgr" id="parmgrBundle" />
<i18n:bundle baseName="com.hp.parmgr.util.WaitMessages" id="waitMessages" />

<%
    final String OK          = bundle.getString( "Button.OK" );
    final String CANCEL      = bundle.getString( "Button.Cancel" );
    final String HELP        = bundle.getString( "Button.Help" );
    String returnToUrl = parsession.getFromURL();
    final String helpUrl = parsession.getHelpURL("cellPower");
    String title = "";
    String message = "";
    String command = "";
    // JAGaf88550: guard against cross site scripting vulnerabilities,
    // by encoding parameters that may be output to the HTML stream:
    String operation =
        StringFormatUtil.encodeHtmlEntities(request.getParameter("cellPowerTask"));
    String waitForDialog = null;
    int cellId = CellPower.INVALID_ID;

    Discovery discovery = parsession.getDiscovery();

    // Do this after getting discovery
    if (!parsession.userAuthorizedToMakeChanges("frupower")) {
        throw new UnauthorizedUserException(parsession.getFromURL(), parsession.getLocale());
    }

    Object [] msgArgs = { discovery.getComplex().getName() };
    MessageFormat format = new MessageFormat(parmgrBundle.getString("complexName.fmt"));
    String complexName = format.format(msgArgs);

    String okButton = request.getParameter("OK");
    if (okButton != null) {
        cellId = Integer.parseInt(request.getParameter("cellId"));
        returnToUrl = request.getParameter("returnToUrl");
        RunCellPower task =
            RunCellPower.run(parsession, operation,
                             "com.hp.parmgr.ui.PowerCell",
                             returnToUrl, cellId);
        if (task.isPowerOn()) {
            WaitForCellToPowerOn wait =
                new WaitForCellToPowerOn(discovery, waitMessages, cellId);
            wait.resetStartTime();
            wait.setForwardURL(returnToUrl);
            parsession.setWaitBean(wait);
            waitForDialog = "wait.jsp";
        } else {
            //@issue:post-11.23:any:change to clear specific cell and chassis
            discovery.clearCellCache();
            discovery.clearChassisCache();
            DialogException de = new DialogException(task.message(), returnToUrl,
                "com.hp.parmgr.ui.PowerCell");
            de.setLocale(parsession.getLocale());
            de.setTitle("complex.name.success.title");
            de.setLogError(false);  // not an error, so don't log as an error
            throw de;
        }
    } else {
        //@issue:post-11.23:any:change to clear specific cell and chassis
        discovery.clearComplexProfileCache();
        discovery.clearCellCache();
        discovery.clearChassisCache();

        // This throws an exception if the user is not allowed to change the
        // cell's power state.
        CheckCellPower task = CheckCellPower.check(parsession, operation,
                                                   returnToUrl, OK);
        title = task.title();
        message = task.message();
        cellId = task.cellId();
        command = task.command();
    }
%>

<html>
<head>
<META http-equiv="Content-Type" content="text/html;charset=UTF-8">
<%@ include file="session_keep_alive.jsp" %>
<link type="text/css" rel="stylesheet" href="<%=Util.URL_PARMGR_CSS%>" />
<script type='text/javascript'
        language='JavaScript'
        src='<%=Util.URL_PARMGR_JS%>' >
</script>
<title>
<%=title%>
</title>
<%=SessionTimeOut.javascript(session, bundle.getLocale())%>
</head>
<%
// The waitForDialog variable is used to decide whether or not to go to the
// wait.jsp.  The wait.jsp has to have its name in the url because it does
// refreshes based on the url.  Calling pageConext.forward("wait.jsp") did
// not change the url.
if (waitForDialog != null) {
%>
<body onLoad="window.location.replace('<%=waitForDialog%>')">
</body>
<% } else { %>

<body>
<p align="left" class="subwindow-heading">
<%=title%>
</p>
<p>
<%=complexName%>
</p>
<p align="left">
<%=message%>
</p>
<hr class=separator>
<form method="post" action="cell_power.jsp" name="powerCell">
    <p align="left">
    <input class="button" type="submit" value="<%=OK%>" name="OK" />

    <input class="button" type="button" value="<%=CANCEL%>" name="CANCEL"
           onclick="window.location.replace('<%=returnToUrl%>')" />

    <input class="button" type="button" value="<%=HELP%>" name="HELP"
           onclick="showHelp('<%=helpUrl%>')" />

    <input type="hidden" name="cellId" value="<%=cellId%>" />
    <input type="hidden" name="cellPowerTask" value="<%=operation%>" />
    <input type="hidden" name="returnToUrl" value="<%=returnToUrl%>" />

    </p>
</form>

<p align="left">
<%=parmgrBundle.getString("commandPreview")%>
    <br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
    [<%=OK%>]:&nbsp;<code><%=command%></code>
</p>

</body>

<% } //end (waitForDialog != null) %>

</html>

