<%--
/**
 * @task name = Create chassis scope
 *       cycle = 5
 *       phase = TEST
 *       owner = Mike
 *       status = Done
 *       description = Create chassis scope
 *
 */
--%>

<%@ taglib uri="/com/hp/mx/taglibs/MxTabsTag" prefix="tabs" %>
<%@ taglib uri="/com/hp/parmgr/ui/tags/parmgr" prefix="parmgr" %>
<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>

<%@ page errorPage="exception.jsp" %>
<%@ page import="com.hp.parmgr.util.Menu" %>
<%@ page import="com.hp.parmgr.util.StringFormatUtil" %>
<%@ page import="com.hp.parmgr.ui.SelectionManager" %>
<%@ page import="com.hp.parmgr.ui.tags.Util" %>
<%@ page import="com.hp.parmgr.model.Discovery" %>
<%@ page import="com.hp.parmgr.model.Complex" %>
<%@ page import="com.hp.parmgr.model.HWPartition" %>
<%@ page import="com.hp.parmgr.model.IOChassisSlot" %>
<%@ page import="com.hp.parmgr.model.IOChassis" %>
<%@ page import="com.hp.parmgr.model.CellSlot" %>
<%@ page import="com.hp.parmgr.model.Cell" %>
<%@ page import="java.util.List" %>
<%@ page import="com.hp.parmgr.ui.SessionTimeOut" %>
<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page pageEncoding="UTF-8"%>

<i18n:bundle baseName="com.hp.parmgr.ui.CellView" id="bundle" />
<i18n:bundle baseName="com.hp.parmgr.ui.tags.tags" id="parmgrTagResources" />
<%@ include file="session_init.jsp" %>

<%
    Discovery discovery = parsession.getDiscovery();

    if (request.getParameter("refresh") != null) {
        /* Must clear cache before generating the HTML. */
        discovery.clearCache();
        parsession.setCheckPending(true);
    }
%>

<%@ include file="run_analyze_complex_health.jsp" %>
<%@ include file="check_pending_profile.jsp" %>

<%
    Complex complex = discovery.getComplex();
    SelectionManager selectedCheckboxes = parsession.getSelectedCheckboxes();

    // JAGaf88550: guard against cross site scripting vulnerabilities,
    // by encoding parameters that may be output to the HTML stream:
    String szSelected =
        StringFormatUtil.encodeHtmlEntities(request.getParameter("selection"));
    if (szSelected == null) {
        szSelected = "GENERAL";
    }
    String fromURL="chassis.jsp";
    boolean isChassisIDPresent = true;
    boolean isFreeCell = true;
    boolean validChassisID = true;
    String INVALID_CHASSIS_ID = "-1";
    String AVAILABLE = "-1";
    String parID = AVAILABLE;
    String partitionName = "";
    String chassisName = "";
    String chassisSlotID = AVAILABLE;
    String cellID = AVAILABLE;

    // JAGaf88550: guard against cross site scripting vulnerabilities,
    // by encoding parameters that may be output to the HTML stream:
    String cabID =
        StringFormatUtil.encodeHtmlEntities(request.getParameter("cab"));
    String bayID =
        StringFormatUtil.encodeHtmlEntities(request.getParameter("bay"));
    String chassisID =
        StringFormatUtil.encodeHtmlEntities(request.getParameter("chassis"));

    if ((cabID == null) || (bayID == null) || (chassisID == null)) {
        isChassisIDPresent = false;
        chassisID = INVALID_CHASSIS_ID;
    }

    IOChassisSlot chassisSlot = null;
    IOChassis chassis = null;
    CellSlot cellSlot = null;
    Cell cell = null;

    if (isChassisIDPresent)
    {
        chassisSlot = discovery.getChassisSlot(Integer.parseInt(cabID),
            Integer.parseInt(bayID), Integer.parseInt(chassisID));

        if (chassisSlot != null)
        {
            chassisName = chassisSlot.getLongLabel();
            chassisSlotID = String.valueOf(chassisSlot.getID());

            if (chassisSlot.isPopulated())
            {
                chassis = discovery.getChassis(chassisSlot);

                if (!chassis.isErrorObject() && chassis.isConnected())
                {
                    // get the cell that the chassis connected to
                    int globalID = chassis.getConnectedCellID();
                    cellID = String.valueOf(globalID);
                    cellSlot = discovery.getCellSlot(globalID);
                    if (cellSlot.isPopulated()) {
                        cell = discovery.getCell(globalID);
                    }

                    // if the chassis is in a partition (is connected to a cell
                    // that is in a partition), get the partition name and ID
                    isFreeCell = (complex.getCellType(globalID) == Complex.FREE);
                    if (!isFreeCell) {
                        parID = String.valueOf(complex.getCellAssignment(globalID));
                        if (parID != null) {
                            HWPartition partition = discovery.getPartition(Integer.parseInt(parID));
                            if (partition.isErrorObject()) {
                                partitionName = "(" + partition.getLabel() + ")";
                            } else {
                                partitionName = partition.getName() + "(" + partition.getLabel() + ")";
                            }
                        }
                    }
                }
            }
        } else {
            validChassisID = false;
        }
    }

    /* The following variables indicate to the scope_header.jsp
     * that we are in the chassis scope.
     */
    String currentURL = "chassis.jsp";
    if (parID.equals(AVAILABLE)) {
        partitionName = parmgrTagResources.getString("Cell.status.available.label");
    }
    boolean isPartitionValid = true;
    boolean isCellIDPresent = false;
    String cellLocation = "";
%>

<HTML>
<HEAD>
<META http-equiv="Content-Type" content="text/html;charset=UTF-8">
<META HTTP-EQUIV="expires" CONTENT="0">
<meta http-equiv="Cache-Control" CONTENT="no-cache">
<meta http-equiv="Pragma" CONTENT="no-cache">
<%@ include file="session_keep_alive.jsp" %>
<tabs:MxTabs dumpHeadContent="true" urlBase="<%=Util.URL_BASE%>"/>
<script type='text/javascript' language='JavaScript' src='<%=Util.URL_PARMGR_JS%>'></script>
<%=SessionTimeOut.javascript(session, bundle.getLocale())%>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_PARMGR_CSS%>'>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_HARDWARE_CSS%>'>
<TITLE>Partition Manager - Chassis <%=chassisName%></TITLE>
</HEAD>

<BODY>

<table border=0 cellpadding=0 cellspacing=0 width="100%" height="100%">
<tr>
    <td>
        <%@ include file="scope_header.jsp" %>
    </td>
</tr>
<tr><td class=smc-filler>
<table border="0" cellpadding="0" cellspacing="0" width="100%">
<tr><td width="100%">
<tabs:MxTabs selection="<%=szSelected%>" style="boris" urlBase="<%=Util.URL_BASE%>">
    <selectors>
        <selector id="GENERAL">
            <label><i18n:message key="tab.General.label" bundle="<%=bundle%>" /></label>
            <url>
                <%=request.getRequestURI()%>?selection=GENERAL&amp;cab=<%=cabID%>&amp;bay=<%=bayID%>&amp;chassis=<%=chassisID%>
            </url>
        </selector>
        <selector id="IO">
            <label><i18n:message key="tab.IO.label" bundle="<%=bundle%>" /></label>
            <url>
                <%=request.getRequestURI()%>?selection=IO&amp;cab=<%=cabID%>&amp;bay=<%=bayID%>&amp;chassis=<%=chassisID%>
            </url>
        </selector>
    </selectors>
</tabs:MxTabs>
</td>
<%@ include file="logofflink.jsp"%>
</tr>
</table>
</td></tr>

<tr height="100%"><td bgcolor=white>

<table border=0 cellpadding=0 cellspacing=8 width="100%" height="100%">
<tr>
  <td>

<%
   String pageID="";
   String srcJsp="";
   if (!isChassisIDPresent) {
     pageID = "error";
     srcJsp = "error.jsp?errorMsgID=ErrorMsg.NoChassisID";
   } else if (!validChassisID) {
     pageID = "error";
     srcJsp = "error.jsp?errorMsgID=ErrorMsg.InvalidChassisID";
   } else if (szSelected.equals("GENERAL")) {
     pageID = "chassisGeneralView";
     srcJsp = "chassis_general.jsp?makeLinks=true&chassisID=" + chassisSlotID;
   } else if (szSelected.equals("IO")) {
     pageID = "chassisIOView";
     srcJsp = "chassis_io.jsp?cab=" + cabID + "&bay=" + bayID + "&chassis=" + chassisID;
   }

   selectedCheckboxes.resetVisibleCheckboxes();
   parsession.setImplicitPartitionID(Integer.parseInt(parID));
   parsession.setImplicitCellID(Integer.parseInt(cellID));
   parsession.setImplicitChassisID(Integer.parseInt(chassisSlotID));
   parsession.setPageID(pageID);
   parsession.setFromURL(fromURL + "?selection=" + szSelected + "&cab=" +
                         cabID + "&bay=" + bayID + "&chassis=" + chassisID);

%>

    <iframe name="FRAME_PARMGR_WORKSPACE" id="FRAME_PARMGR_WORKSPACE"
        scrolling=auto frameborder=0 width="100%" height="100%"
        src="<%=srcJsp%>">
    </iframe>
    </td>

<%-- /* Note that no source is specified for the menu actions frame in
      * this JSP.  The menu src will be loaded by the workspace frame
      * when it is done loading to ensure that the workspace has
      * completed rendering before the actions menu is created.
      */
--%>

    <td width=220>
    <BR>
    <iframe name="FRAME_PARMGR_ACTIONS" id="FRAME_PARMGR_ACTIONS"
        scrolling=auto frameborder=0 width="100%" height="100%"
        src="dummy.jsp">
    </iframe>
    </td>
  </tr>
</table>

</td></tr>
</table>

</BODY>
</HTML>
