<%--
/**
 * The content for the body of the chassis general info for
 * the complex details page.  Since there is no chassis
 * scope, there is no chassis general tab.  If there were,
 * this page could be used there.
 * <p>
 * NOTE: this page is designed to be similar to the other
 * *_general_body.jsp files even though it is only used
 * by complex_details.jsp at this time.  Therefore, the
 * makeLinks argument, is used, and the small partition
 * icon is displayed next to the partition name, even
 * though it's not really needed at the present time.
 *
 * @precondition The boolean variable "makeLinks" must
 *               be set to either true or false depending
 *               on whether items such as the attached
 *               cell should be displayed as a link.
 *               If make links is not null, and is equal,
 *               ignoring case, to the string "true", then
 *               the links will be displayed.  See the
 *               constructor for Boolean(String).
 *               <p>
 *               The following style sheets must be loaded
 *               in the "head" section of the including jsp:
 *               .  /parmgr/css/parmgr.css
 *               .  /parmgr/css/hardware.css
 *               <p>
 *               The following java scripts must be loaded
 *               in the "head" section of the including jsp:
 *               .  /parmgr/js/parmgr.js
 *
 * @version $Header: /usr/local/vse/parmgr/src/web/jsp/chassis_general_body.jsp,v 1.14 2005/11/09 19:14:00 tmartin Exp $
 */
--%>
<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>
<%@ taglib uri="/com/hp/parmgr/ui/tags/parmgr" prefix="parmgr" %>
<%@ page import="java.lang.Boolean" %>
<%@ page import="com.hp.parmgr.model.Discovery" %>
<%@ page import="com.hp.parmgr.model.IOChassisSlot" %>
<%@ page import="com.hp.parmgr.model.IOChassis" %>
<%@ page import="com.hp.parmgr.model.Complex" %>
<%@ page import="com.hp.parmgr.model.HWPartition" %>
<%@ page import="com.hp.parmgr.model.CellSlot" %>
<%@ page import="com.hp.parmgr.ui.tags.PartitionKey" %>
<%@ page import="com.hp.parmgr.ui.tags.ChassisInfo" %>
<%@ page import="com.hp.parmgr.ui.tags.Util" %>

<i18n:bundle baseName="com.hp.parmgr.ui.CellView" id="cellViewResources" />
<i18n:bundle baseName="com.hp.parmgr.ui.tags.tags" id="parmgrTagResources" />
<i18n:bundle baseName="com.hp.parmgr.ui.Global" id="globalResources" />

<jsp:useBean id="parsession" scope="session" class="com.hp.parmgr.ui.ParmgrSession" />
<%
   Discovery discovery = parsession.getDiscovery();
   String slotIDStr    = request.getParameter("chassisID");
   int slotID          = Integer.parseInt(slotIDStr);
   IOChassisSlot slot  = discovery.getChassisSlot(slotID);
   IOChassis chassis   = discovery.getChassis(slot);
   String makeLinksStr = request.getParameter("makeLinks");
   boolean makeLinks   = new Boolean(makeLinksStr).booleanValue();

   boolean isErrorChassis = chassis.isErrorObject();
   String unknownStr = globalResources.getString("Application.Unknown.field");
   String naStr = globalResources.getString("Application.NA.field");

   /* get chassis status icon and text*/
   String chassisStatusImage = ChassisInfo.chassisStatusImage(slot, chassis, parmgrTagResources, Util.URL_BASE + "/");
   String chassisStatusText = ChassisInfo.chassisStatusText(chassis, parmgrTagResources);

   /* get connected cell label, and partition assignment string */
   int parID = -1;
   int cellID = -1;
   boolean isAssigned = false;

   String cellLabel = unknownStr;
   String partitionAssignment = unknownStr;
   String pciSlotCountStr = unknownStr;
   String emptyPCISlotCountStr = unknownStr;
   String populatedPCISlotCountStr = unknownStr;
   String numMassStorageCardsStr = unknownStr;
   String numNetworkingCardsStr = unknownStr;
   String numOtherCardsStr = unknownStr;

   if (! isErrorChassis) {
       if( ! chassis.isConnected() ) {
           cellLabel = parmgrTagResources.getString("Cell.notConnected");
           partitionAssignment = naStr;
           isAssigned = false;
       }
       else {
           cellID = chassis.getConnectedCellID();
           CellSlot cellSlot = discovery.getCellSlot(cellID);
           cellLabel = cellSlot.getLongLabel();
           Complex complex = discovery.getComplex();
           if( complex.getCellType(cellID) != Complex.FREE ) {
               parID = complex.getCellAssignment(cellID);
               HWPartition par = discovery.getPartition(parID);
               String parIcon = "<img src=\"" + PartitionKey.getIcon(Util.URL_BASE, parID) + "\" border=\"0\" align=\"absmiddle\">&nbsp;";
               if (par.isErrorObject()) {
                   partitionAssignment = parIcon + par.getLabel();
               } else {
                   partitionAssignment = parIcon + par.getLongLabel();
               }
               isAssigned = true;
           }
           else {
               partitionAssignment = naStr;
               isAssigned = false;
           }
       }

       if (chassis.isIOSlotDataAvailable())
       {
           pciSlotCountStr = Integer.toString(chassis.getPCISlotCount());
           emptyPCISlotCountStr = Integer.toString(chassis.getEmptyPCISlotCount());
           populatedPCISlotCountStr = Integer.toString(chassis.getPopulatedPCISlotCount());
           numMassStorageCardsStr = Integer.toString(chassis.getNumMassStorageCards());
           numNetworkingCardsStr = Integer.toString(chassis.getNumNetworkingCards());
           numOtherCardsStr = Integer.toString(chassis.getNumOtherCards());
       }
   }
%>
<tr>
  <td>
    <table>
      <tr>
        <td><img src="<%=Util.URL_BASE_IMAGES + "/iochassis.gif"%>" width="231" height="289"></td>
      </tr>
    </table>
  </td>
  <td valign="top">
    <table class="properties" border="0" cellspacing="2" cellpadding="0" width="100%">
      <tr>
        <td colspan="2" class="prop-table-caption">
          <i18n:message key="generalTab.chassis.generalProperties"
                        bundle="<%=globalResources%>"/>
        </td>
      </tr>
      <tr>
        <td class="prop-table-header">
          <i18n:message key="generalTab.chassis.location"
                        bundle="<%=globalResources%>"/>
        </td>
        <td class="prop-table-data">
            <%=slot.getLongLabel()%>
        </td>
      </tr>
      <tr>
        <td class="prop-table-header">
          <i18n:message key="Application.ConnectedTo.label"
                        bundle="<%=globalResources%>"/>
        </td>
        <td class="prop-table-data">
           <%
              if (! isErrorChassis) {
                if(makeLinks && (cellID != -1)) { %>
                  <a class="link" href="cell.jsp?globalID=<%=cellID%>" target="_parent">
                  <%=cellLabel%></a>
           <%   } else { %>
                  <%=cellLabel%>
           <%
                }
              } else {
           %>
                  <%=cellLabel%>
           <%
              }
           %>

        </td>
      </tr>
      <tr>
        <td class="prop-table-header">
          <i18n:message key="field.PartitionAssignment.label"
                        bundle="<%=cellViewResources%>"/>
        </td>
        <td class="prop-table-data">
          <% if (makeLinks && isAssigned) { %>
            <a class="link" href="partition.jsp?partition=<%=parID%>" target="_parent">
          <% } %>
            <%=partitionAssignment%>
          <% if (makeLinks && isAssigned) { %>
            </a>
          <% } %>
        </td>
      </tr>
      <tr>
        <td class="prop-table-header">
          <i18n:message key="field.Status.label"
                        bundle="<%=cellViewResources%>"/>
        </td>
        <td class="prop-table-data">
          <%=chassisStatusImage%> <%=chassisStatusText%>
        </td>
      </tr>
      <tr>
        <td class="prop-table-header">
          <i18n:message key="SummaryTable.TotalIOSlots.label"
                        bundle="<%=parmgrTagResources%>"/>
        </td>
        <td class="prop-table-data">
            <%=pciSlotCountStr%>
        </td>
      </tr>
      <tr>
        <td class="prop-table-header">&nbsp;&nbsp;
          <i18n:message key="SummaryTable.EmptyIOSlots.label"
                        bundle="<%=parmgrTagResources%>"/>
        </td>
        <td class="prop-table-data">
            <%=emptyPCISlotCountStr%>
        </td>
      </tr>
      <tr>
        <td class="prop-table-header">&nbsp;&nbsp;
          <i18n:message key="SummaryTable.OccupiedIOSlots.label"
                        bundle="<%=parmgrTagResources%>"/>
        </td>
        <td class="prop-table-data">
            <%=populatedPCISlotCountStr%>
        </td>
      </tr>
      <tr>
        <td class="prop-table-header">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
          <i18n:message key="SummaryTable.MassStorageCards.label"
                        bundle="<%=parmgrTagResources%>"/>
        </td>
        <td class="prop-table-data">
            <%=numMassStorageCardsStr%>
        </td>
      </tr>
      <tr>
        <td class="prop-table-header">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
          <i18n:message key="SummaryTable.NetworkCards.label"
                        bundle="<%=parmgrTagResources%>"/>
        </td>
        <td class="prop-table-data">
            <%=numNetworkingCardsStr%>
        </td>
      </tr>
      <tr>
        <td class="prop-table-header">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
          <i18n:message key="SummaryTable.OtherCards.label"
                        bundle="<%=parmgrTagResources%>"/>
        </td>
        <td class="prop-table-data">
            <%=numOtherCardsStr%>
        </td>
      </tr>
    </table>
  </td>
</tr>
