<%--
/**
 * @task name = Create chassis scope IO slot page
 *       cycle = 5
 *       phase = TEST
 *       owner = Mike
 *       status = Done
 *       description = Create a chassis scope IO slot page
 *
 */
--%>

<%@ taglib uri="/com/hp/mx/taglibs/MxTabsTag" prefix="tabs" %>
<%@ taglib uri="/com/hp/parmgr/ui/tags/parmgr" prefix="parmgr" %>
<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>

<%@ page errorPage="exception.jsp" %>
<%@ page import="com.hp.parmgr.ui.SelectionManager" %>
<%@ page import="com.hp.parmgr.model.Discovery" %>
<%@ page import="com.hp.parmgr.model.Complex" %>
<%@ page import="com.hp.parmgr.model.IOChassisSlot" %>
<%@ page import="com.hp.parmgr.model.IOChassis" %>
<%@ page import="com.hp.parmgr.model.IOSlot" %>
<%@ page import="com.hp.parmgr.model.IOCard" %>
<%@ page import="com.hp.parmgr.ui.SelectionManager" %>
<%@ page import="com.hp.parmgr.ui.tags.Checkbox" %>
<%@ page import="com.hp.parmgr.ui.tags.Util" %>
<%@ page import="java.util.List" %>
<%@ page import="java.util.Arrays" %>
<%@ page import="java.util.Iterator" %>
<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page pageEncoding="UTF-8"%>

<jsp:useBean id="parsession" scope="session" class="com.hp.parmgr.ui.ParmgrSession" />

<%

    Discovery discovery = parsession.getDiscovery();
    Complex complex = discovery.getComplex();
    SelectionManager selectedCheckboxes = parsession.getSelectedCheckboxes();

    boolean makeLinks = true;
    String makeLinksStr = request.getParameter("makeLinks");
    if (makeLinksStr != null) {
       makeLinks = new Boolean(makeLinksStr).booleanValue();
    }

    String fromURL="chassis.jsp";
    boolean isChassisIDPresent = true;
    boolean validChassisID = true;
    String INVALID_CHASSIS_ID = "-1";
    String AVAILABLE = "-1";
    String chassisName = "";
    String chassisSlotID = AVAILABLE;

    String cabID = request.getParameter("cab");
    String bayID = request.getParameter("bay");
    String chassisID = request.getParameter("chassis");

    if ((cabID == null) || (bayID == null) || (chassisID == null)) {
        isChassisIDPresent = false;
        chassisID = INVALID_CHASSIS_ID;
    }

        IOChassisSlot chassisSlot = null;
        IOChassis chassis = null;

    if (isChassisIDPresent)
    {
        chassisSlot = discovery.getChassisSlot(Integer.parseInt(cabID),
            Integer.parseInt(bayID), Integer.parseInt(chassisID));

        if (chassisSlot != null)
        {
            chassisName = chassisSlot.getLongLabel();
                        chassisSlotID = String.valueOf(chassisSlot.getID());

                        if (chassisSlot.isPopulated())
            {
                                chassis = discovery.getChassis(chassisSlot);
            }
        } else {
            validChassisID = false;
        }
    }

%>

<HTML>
<HEAD>
<META http-equiv="Content-Type" content="text/html;charset=UTF-8">
<META HTTP-EQUIV="expires" CONTENT="0">
<%@ include file="session_keep_alive.jsp" %>
<script type='text/javascript' language='JavaScript' src='<%=Util.URL_PARMGR_JS%>'></script>
<i18n:bundle baseName="com.hp.parmgr.ui.tags.tags" id="parmgrTagResources" />
<link type='text/css' rel='stylesheet' href='<%=Util.URL_PARMGR_CSS%>'>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_HARDWARE_CSS%>'>
<TITLE>Partition Manager - Chassis <%=chassisName%></TITLE>
</HEAD>

<BODY onLoad="loadMenuFrame('<%=Util.URL_BASE_JSP%>')">

<% if ( ! validChassisID) { %>

<jsp:include page="error.jsp">
  <jsp:param name="errorMsgID" value="ErrorMsg.NoChassisID" />
</jsp:include>

<% } else if (chassis.isErrorObject()) { %>

<jsp:include page="error.jsp">
  <jsp:param name="errorMsgID" value="ErrorMsg.ChassisErrorObject" />
</jsp:include>

<% } else {
    List ioSlots = Arrays.asList(chassis.getIOSlots());
%>

   <table class="item-list" width="100%">
   <thead>
     <tr>
       <td class="item-list-header-row">
         <i18n:message key="ComplexDetails.IOSlot" bundle="<%=parmgrTagResources%>" />
       </td>
       <td class="item-list-header-row">
         <i18n:message key="ComplexDetails.Description" bundle="<%=parmgrTagResources%>" />
       </td>
     </tr>
   </thead>
   <tbody>

<%

     for (Iterator iter = ioSlots.iterator(); iter.hasNext();)
     {
        IOSlot currentSlot = (IOSlot) iter.next();
        String currentSlotCheckboxId = null;
        boolean isCurrentSlotCheckboxSelected = false;

        if (makeLinks) {
           /* Retrieve checkbox information for this I/O slot.  The
            * checkbox taglib requires an ID and the selected state
            * of the checkbox.  In this view, all I/O slot checkboxes
            * are always enabled.  Since that is the default value for
            * "enabled" in the checkbox taglib, it's unnecessary to
            * pass that value along.
            */
           currentSlotCheckboxId = selectedCheckboxes.getID(currentSlot);
           isCurrentSlotCheckboxSelected =
              selectedCheckboxes.isSelected(currentSlotCheckboxId);
           selectedCheckboxes.addVisibleCheckbox(currentSlotCheckboxId);
        }

        String currentDesc =
           parmgrTagResources.getString("IOSlot.empty.label");
        String currentSlotId = currentSlot.getLabel();

        if (currentSlot.isPopulated())  {
           IOCard currentCard = currentSlot.getCard();
           currentDesc = currentCard.getLabel();
        }
%>

     <tr>
       <td class="item-list-row-align-left">

<%
        if (makeLinks) {
%>
         <parmgr:checkbox id="<%=currentSlotCheckboxId%>"
                          selected="<%=isCurrentSlotCheckboxSelected%>" />
         <a class="link" target="pdwebWindow" href="cat.jsp?slot=<%=currentSlotId%>&actionID=ATTSLOT" title="<%=currentSlotId%>:  <%=currentDesc%>">
<%
        }
%>
        <%=currentSlotId%>
<%
        if (makeLinks) {
%>
         </a>
<%
        }
%>
       </td>
       <td class="item-list-row-align-left">
         <%=currentDesc%>
       </td>
     </tr>

<%   } %>

   </tbody>
   </table>

<% } %>

</BODY>
</HTML>
