<%@ page import="java.text.NumberFormat" %>
<%@ page import="com.hp.parmgr.model.DIMM" %>

<%@ include file="cm_npar_clm_scripts.jsp"%>

<%
Log.detail(Log.EVENT_INTERMEDIATE, Log.RESULT_NONE, 
        "Configure Memory");
NumberFormat nf = DIMM.getMemoryNumberFormat(discovery.getLocale());
%>

<p class="parmgr-regular-text">
    <i18n:message key="configure.memory.intro" bundle="<%=bundle%>"/>

</p>

<form action="<%=formAction%>" method="post" name="memConfig"
      onSubmit="return checkTotalInterleave(document.memConfig);" >

<%-- hidden value used to keep track of which step we are on --%>
<input type="hidden" name="stepNumber" value="<%=HWPartitionBean.CONFIG_MEM%>">

<p>
  <TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>
    <TR>
      <TD>
        <font class="wizard-page-field-label">
        <i18n:message key="configure.memory.total.memory.label" bundle="<%=bundle%>"/>&nbsp;&nbsp;
        </font>
      </TD>
      <TD ALIGN="right">
        <span id="totalBaseMem"><%=nf.format(parConfig.getTotalMemFromBaseCells())%></span>
      </TD>
    </TR>
    <TR>
      <TD>
        <font class="wizard-page-field-label">
        <i18n:message key="configure.memory.bootable.memory.label" bundle="<%=bundle%>"/>&nbsp;&nbsp;
        </font>
      </TD>
      <TD ALIGN="right">
        <%=nf.format(parConfig.getTotalBootableMemoryForPar())%>
      </TD>
    </TR>
<%
  double minOSInterleave = parConfig.getMinOSInterleave();
  if (minOSInterleave > 0) {
%>
    <TR>
      <TD>
        <font class="wizard-page-field-label">
        <i18n:message key="configure.memory.osMinZI.label" bundle="<%=bundle%>"/>&nbsp;&nbsp;
        </font>
      </TD>
      <TD ALIGN="right">
        <%=nf.format(minOSInterleave)%>
      </TD>
    </TR>
<%
  }
%>

  </TABLE>
</p>

<p class="parmgr-regular-text">
<%
    // if we are in modify, show the current interleave memory range
    // information.
    if (formAction.equals("modify_npar.jsp")){
%>
<parmgr:InterleaveRangeTable discovery="<%=discovery%>"
                             resources="<%=bundle%>"
                             parID="<%=parID%>"
                             isLinkPopUp="true"
                             showLinks="true"
/>
<%  }        %>
</p>

<%
    boolean renderActual;
    // only display actual CLM numbers for each cell if the current task is
    // modify and the partition being modified is active.
    int parStatus = discovery.getPartitionStatus(parID);
    if (formAction.equals("modify_npar.jsp") &&
        (parStatus == NParComponent.ACTIVE)){
        renderActual = true;
    } else {
        renderActual = false;
    }

    List cellList = new ArrayList(parConfig.getCellBeans().values());
%>

<parmgr:CLMTable discovery="<%=discovery%>"
                 resources="<%=bundle%>"
                 cells="<%=cellList%>"
                 parID="<%=parID%>"
                 renderActual="<%=renderActual%>"
                 renderInputs="true"
                 isLinkPopUp="true"
                 showLinks="true"
/>

<!-- display Enable Hyper-Threading option, only if cells are capable -->
<% if (parConfig.isHyperThreadingCapable()) { %>
<p class="parmgr-bold-text">
<input type="checkbox" name="enable_hyper_threading" value="true"
  <%=parConfig.isHyperThreadingEnabled() ? "checked" : ""%>
>
<i18n:message key="modify.changes.hyperthreading.enable" bundle="<%=bundle%>"/>
</p>
<% } %>
<p>
<%=ClmWarning.printCLMWarnings(discovery, parID, false, bundle.getLocale())%>

<% if (parConfig.isHyperThreadingCapable()) { %>
<p class='parmgr-regular-text'>
<i18n:message key="modify.changes.hyperthreading.warning.os.warn" bundle="<%=bundle%>"/>
</p>
<% } %>
