<script language="javascript">
<%--
/*
 * This method validates that a name for the partition or complex is correct.
 * It is used by the modify partition, create partition and set complex name
 * tasks. 
 *
 * When the name is invalid the error messages, lengthMessage and 
 * contentMessage are displayed to the user in a java script alert pop up.
 *
 * The global variable, doNotValidate, affects the behavior of this function 
 * and can be set to true or false.  If it is true then the name will not be 
 * validated and the function will always return true.  If false the function
 * behaves as described above.
 *
 * @param name the string to check if it is a valid name.
 * @param lengthMessage the error message to display when the length of the 
 * new name equals 0.
 * @param contentMessage the error message to display when the new name 
 * contains charaters that are not allowed.
 * @return true if the name is an allowable change, otherwise, false.
 * 
 * @precondition The global variable, doNotValidate, is set to true or false.
 * @postcondition a message dialog will be invoked with the error message if 
 *                the user entered an inapropriate value.
 * @sideeffect none.
 */
--%>
function validateName(name, lengthMessage, contentMessage){
    if (doNotValidate) {
        return true;
    }

    var re=/^[._ a-zA-Z0-9][-._ a-zA-Z0-9]*$/; //the allowed characaters in a name.

    if (name.length == 0){
	alert(lengthMessage);
	return false;
    }

    if (!re.test(name)) {
	alert(contentMessage);
	return false;
    }

    return true;
}
</script>
