<%--
/**
 * The content rendered for the complex cells page.
 *
 * @version $Header: /usr/local/vse/parmgr/src/web/jsp/complex_cells.jsp,v 1.20 2008/03/05 12:40:57 sridharav Exp $
 * @risk High
 *
 * @task name = complex cells tab
 * cycle = 2
 * phase = code
 * owner = Chris
 * status = done
 * description = This is an entirely new tab and the HLD design is being
 * re-done from the first evo.
 *
 * @task name = create cell tag lib
 * cycle = 2
 * phase = code
 * owner = Chris
 * status = done
 * description = Probably need a tag lib for generating the cells on this
 * page.  This will likely be used on the cell view too.
 */
--%>

<%@ taglib uri="/com/hp/mx/taglibs/MxTabsTag" prefix="tabs" %>
<%@ taglib uri="/com/hp/parmgr/ui/tags/parmgr" prefix="parmgr" %>
<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>

<%@ page errorPage="exception.jsp" %>

<%@ page import="java.util.List" %>
<%@ page import="java.util.ListIterator" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="com.hp.parmgr.model.Discovery" %>
<%@ page import="com.hp.parmgr.model.Cell" %>
<%@ page import="com.hp.parmgr.model.CellSlot" %>
<%@ page import="com.hp.parmgr.model.IOChassisSlot" %>
<%@ page import="com.hp.parmgr.ui.SelectionManager" %>
<%@ page import="com.hp.parmgr.ui.tags.PartitionBackgroundKey" %>
<%@ page import="com.hp.parmgr.ui.tags.Util" %>
<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page pageEncoding="UTF-8"%>

<jsp:useBean id="parsession" scope="session" class="com.hp.parmgr.ui.ParmgrSession" />

<%

    Discovery discovery = parsession.getDiscovery();
    SelectionManager selectedCheckboxes = parsession.getSelectedCheckboxes();

    List cells = discovery.getCells();
    List cellSlots = discovery.getCellSlots();

    //
    // Fill the cache before getting into the html so that any Locked objects
    // are caught here.
    //
    discovery.getPartitions();
    discovery.getChassisSlots();
    discovery.getAllChassis();
%>

<HTML>
<HEAD>
<META http-equiv="Content-Type" content="text/html;charset=UTF-8">
<META HTTP-EQUIV="expires" CONTENT="0">

<%@ include file="session_keep_alive.jsp" %>

<i18n:bundle baseName="com.hp.parmgr.ui.ComplexView" id="bundle" />
<i18n:bundle baseName="com.hp.parmgr.ui.tags.tags" id="parmgrTagResources" />

<script type='text/javascript' language='JavaScript' src='<%=Util.URL_PARMGR_JS%>'>
</script>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_PARMGR_CSS%>'>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_HARDWARE_CSS%>'>
</HEAD>

<BODY onLoad="loadMenuFrame('<%=Util.URL_BASE_JSP%>')">

<%-- Begin overall table --%>
<table border=0 cellspacing=2 cellpadding=0>

  <%-- Begin first row in overall table --%>
  <tr>
    <td>

      <%-- Begin summary tables table --%>
      <table border="0" cellspacing="2" cellpadding="0">

        <tr>

          <%-- Cells table --%>
          <td valign="top">

            <parmgr:cellsummarytable cells="<%=cells%>"
                                resources="<%=parmgrTagResources%>"
                                numCellSlots="<%=cellSlots.size()%>" />

          </td>

          <%-- CPUs table --%>
          <td valign="top">
            <parmgr:cpusummarytable cells="<%=cells%>"
                                resources="<%=parmgrTagResources%>" />
          </td>

          <%-- Memory table --%>
          <td valign="top">
            <parmgr:memorysummarytable cells="<%=cells%>"
                                   resources="<%=parmgrTagResources%>" />
          </td>
        </tr>

      </table>
      <%-- End summary tables table --%>

    </td>
  </tr>
  <%-- End second row in overall table --%>

  <tr>
    <td>
        <hr class="separator">
        <parmgr:partitionkey partitions="<%=discovery.getPartitions()%>"
                             resources="<%=parmgrTagResources%>"
                             selectedCheckboxes="<%=selectedCheckboxes%>" />
    </td>
  </tr>

  <%-- Begin third row in overall table --%>
  <tr>
    <td>

      <%-- Begin cells table --%>
      <table border=0 cellspacing="5" cellpadding="2">

<%
    int i = 0;
%>

      <tr>

<%
    for (Iterator iter = cellSlots.iterator(); iter.hasNext();)
    {

        CellSlot cellSlot = (CellSlot) iter.next();
        int cellID = cellSlot.getGlobalID();

        if (i % 4 == 0) {
           if (i > 0) {
%>

      </tr>
      <tr>

<%
           }
        }
%>

      <td valign="top">

        <%-- Begin an individual cell/chassis table --%>
        <table border=0 cellspacing="0" cellpadding="0">

        <%-- Begin cell row --%>
        <tr>
          <td align="center">
            <parmgr:cellinfo discovery="<%=discovery%>"
                             slot="<%=cellSlot%>"
                             resources="<%=parmgrTagResources%>"
                             showDimms="true"
                             showPartition="true"
                             showCPUs="true"
                             selectedCheckboxes="<%=selectedCheckboxes%>" />
          </td>
        </tr>
        <%-- End cell row --%>

<%
        if (cellSlot.isPopulated())
        {
          Cell cell = discovery.getCell(cellSlot.getGlobalID());
          if (!cell.isErrorObject()) {
              if (cell.isConnectedToIOChassis())
              {
                  IOChassisSlot chassisSlot = discovery.getChassisSlot(cell.getConnectedIOChassisID());

%>

            <%-- Begin cell/chassis connector row --%>
            <tr>
              <td align="center">
                <img height="20" width="12" border="0"
                 src="<%=Util.URL_BASE_IMAGES + "/cv.gif"%>" alt="connected to">
              </td>
            </tr>
            <%-- End cell/chassis connector row --%>

            <%-- Begin chassis row --%>
            <tr>
              <td align="center">

              <parmgr:chassisinfo discovery="<%=discovery%>"
                               slot="<%=chassisSlot%>"
                               resources="<%=parmgrTagResources%>"
                               showSlots="false"
                               showPartition="true"
                               selectedCheckboxes="<%=selectedCheckboxes%>" />

              </td>
            </tr>

<%
              } // if cell connected
           }  // if cell is error object
        } // if cell slot populated
%>

        </table>
      </td>

<%
    i++;
    } // for each cell slot
%>

    </tr>
  </table>
<%-- End cells table --%>

    </td>
  </tr>
  <%-- End second row in overall table --%>

<%-- End overall table --%>
</table>

</BODY>
</HTML>




















