<%--
/**
 * The JSP page for the Hardware Big Picture View in the "Complex Scope".
 * <p>
 * This page contains the contents of the "hardware" tab in the
 * "Complex Scope".
 *
 * @version $Header: /usr/local/vse/parmgr/src/web/jsp/complex_hardware.jsp,v 1.15 2008/03/05 12:40:58 sridharav Exp $
 * @risk Medium
 *
 * @task name = Create the hardware page
 *       cycle = 1
 *       phase = CODE
 *       owner = Mike
 *       status = Done
 *       description = implement the basic content of the page.
 *
 * @task name = Create printer-friendly link for Complex Hardware page
 *       cycle = 9
 *       phase = DESIGN
 *       owner = Paul
 *       status = Done
 *       description = Create JSP which does not include links or checkboxes.
 *
 */
--%>

<%@ taglib uri="/com/hp/parmgr/ui/tags/parmgr" prefix="parmgr" %>
<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>

<%@ page errorPage="exception.jsp" %>
<%@ page import="com.hp.parmgr.model.Discovery" %>
<%@ page import="com.hp.parmgr.ui.SelectionManager" %>
<%@ page import="com.hp.parmgr.ui.tags.Util" %>
<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page pageEncoding="UTF-8"%>

<jsp:useBean id="parsession" scope="session" class="com.hp.parmgr.ui.ParmgrSession" />

<%

     Discovery discovery = parsession.getDiscovery();
     SelectionManager selectedCheckboxes = parsession.getSelectedCheckboxes();

     //
     // Fill the cache before getting into the html so that any Locked objects
     // are caught here.
     //
     discovery.getCellSlots();
     discovery.getCells();
     discovery.getPartitions();
     discovery.getChassisSlots();
     discovery.getAllChassis();
%>

<HTML>
<HEAD>
<META http-equiv="Content-Type" content="text/html;charset=UTF-8">
<META HTTP-EQUIV="expires" CONTENT="0">
<%@ include file="session_keep_alive.jsp" %>
<i18n:bundle baseName="com.hp.parmgr.ui.ComplexView" id="bundle" />
<i18n:bundle baseName="com.hp.parmgr.ui.tags.tags" id="parmgrTagResources" />

<script type='text/javascript' language='JavaScript' src='<%=Util.URL_PARMGR_JS%>'>
</script>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_PARMGR_CSS%>'>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_HARDWARE_CSS%>'>
</HEAD>

<BODY onLoad="loadMenuFrame('<%=Util.URL_BASE_JSP%>')">

<table border="0" cellpadding="0" cellspacing="10">
  <tbody>
    <tr>
      <td>
        <parmgr:partitionkey partitions="<%=discovery.getPartitions()%>"
                             resources="<%=parmgrTagResources%>"
                             selectedCheckboxes="<%=selectedCheckboxes%>"/>
      </td>
    </tr>
    <tr>
      <td>
        <parmgr:cabinets discovery="<%=discovery%>"
                         resources="<%=parmgrTagResources%>"
                         selectedCheckboxes="<%=selectedCheckboxes%>"/>
      </td>
    </tr>
  </tbody>
</table>

</BODY>
</HTML>
