<%--
/**
 * The JSP page for the I/O Big Picture View in the "Complex Scope".
 * <p>
 * This page contains the contents of the "I/O" tab in the
 * "Complex Scope".
 *
 * @version $Header: /usr/local/vse/parmgr/src/web/jsp/complex_io.jsp,v 1.20 2008/03/05 12:40:58 sridharav Exp $
 * @risk Medium
 *
 * @task name = Create the I/O page
 *       cycle = 3
 *       phase = TEST
 *       owner = Paul
 *       status = Done
 *       description = Call I/O Chassis taglib for each chassis in complex.
 *
 * @task name = Provide dummy URL for CAT card/slot details
 *       cycle = 3
 *       phase = TEST
 *       owner = Paul
 *       status = Done
 *       description = Prepare for CAT integration
 *
 */
--%>

<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>
<%@ taglib uri="/com/hp/parmgr/ui/tags/parmgr" prefix="parmgr" %>

<%@ page errorPage="exception.jsp" %>
<%@ page import="java.util.List" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="com.hp.parmgr.model.Discovery" %>
<%@ page import="com.hp.parmgr.model.IOChassisSlot" %>
<%@ page import="com.hp.parmgr.model.IOChassis" %>
<%@ page import="com.hp.parmgr.model.Cabinet" %>
<%@ page import="com.hp.parmgr.ui.SelectionManager" %>
<%@ page import="com.hp.parmgr.ui.tags.Util" %>
<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page pageEncoding="UTF-8"%>

<i18n:bundle baseName="com.hp.parmgr.ui.ComplexView" id="bundle" />
<i18n:bundle baseName="com.hp.parmgr.ui.Parmgr" id="parmgrProperties" />
<i18n:bundle baseName="com.hp.parmgr.ui.tags.tags" id="parmgrTagResources" />

<jsp:useBean id="parsession" scope="session" class="com.hp.parmgr.ui.ParmgrSession" />

<%

     List ioChassisList = new ArrayList();

     Discovery discovery = parsession.getDiscovery();
     SelectionManager selectedCheckboxes = parsession.getSelectedCheckboxes();

     List ioChassisSlots = discovery.getChassisSlots();
     Iterator iter = ioChassisSlots.iterator();

     while (iter.hasNext()) {
        IOChassisSlot currChassisSlot = (IOChassisSlot) iter.next();
        if (currChassisSlot.isPopulated()) {
                ioChassisList.add(discovery.getChassis(currChassisSlot));
        }
     }

%>

<HTML>
<HEAD>
<META http-equiv="Content-Type" content="text/html;charset=UTF-8">
<META HTTP-EQUIV="expires" CONTENT="0">
<%@ include file="session_keep_alive.jsp" %>
<script type='text/javascript' language='JavaScript' src='<%=Util.URL_PARMGR_JS%>'>
</script>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_PARMGR_CSS%>'>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_HARDWARE_CSS%>'>

</HEAD>

<BODY onLoad="loadMenuFrame('<%=Util.URL_BASE_JSP%>')">

<!-- begin overall table -->
<table border=0 cellpadding=0 cellspacing=10>
  <!-- begin first row in overall table -->
  <tr>
    <td class="subwindow-heading">
      <%=parmgrTagResources.getString("ComplexIOViewLabel")%>
    </td>
  </tr>
  <!-- end first row in overall table -->

  <!-- begin second row in overall table -->
  <tr>
    <td>
      <!-- begin I/O summary table -->
      <parmgr:iosummarytable ioChassisList="<%=ioChassisList%>"
                             numIOChassisSlots="<%=ioChassisSlots.size()%>"
                             resources="<%=parmgrTagResources%>"
                             showPresentAbsentChassis="true" />
      <!-- end I/O summary table -->
    </td>
  </tr>
  <!-- end second row in overall table -->

  <!-- begin third row in overall table -->
  <tr>
    <td>
      <HR class="separator">
    </td>
  </tr>
  <!-- end third row in overall table -->

  <!-- begin fourth row in overall table -->
  <tr>
    <td class="subwindow-heading">
      <%=parmgrTagResources.getString("DetailsLabel")%>
    </td>
  </tr>
  <!-- end fourth row in overall table -->

  <!-- begin fifth row in overall table -->
  <tr>
    <td>
      <!-- begin partition key -->
      <parmgr:partitionkey partitions="<%=discovery.getPartitions()%>"
                           resources="<%=parmgrTagResources%>"
                           selectedCheckboxes="<%=selectedCheckboxes%>" />
      <!-- end partition key -->
    </td>
  </tr>
  <!-- end fifth row in overall table -->

  <!-- begin sixth row in overall table -->
  <tr>
    <td>
      <table border=0 cellspacing=0 cellpadding=5>
        <tr>

<%
  int i = 0;
  Iterator iter2 = ioChassisSlots.iterator();

  while (iter2.hasNext()) {
    IOChassisSlot currChassisSlot = (IOChassisSlot) iter2.next();
    Cabinet currCabinet = discovery.getCabinet(currChassisSlot.getCabinetID());
    int cabType = currCabinet.getType();

    if (i % 2 == 0) {
      if (i > 0) {
%>

        </tr>
        <tr>

<%
      }
    }
%>

    <td>
      <table border=0 cellpadding=0 cellspacing=0>
        <tr>
          <td>
<%
    if (!currChassisSlot.isPopulated()) {
%>
          </td>
          <td>
<%
    } else {
%>
            <parmgr:chassisinfo discovery="<%=discovery%>"
                                slot="<%=currChassisSlot%>"
                                resources="<%=parmgrTagResources%>"
                                showSlots="true"
                                showPartition="true"
                                selectedCheckboxes="<%=selectedCheckboxes%>" />

          </td>
          <td>

<%
        IOChassis currChassis = discovery.getChassis(currChassisSlot);
        boolean isChassisConnected = !currChassis.isErrorObject() &&
                                     currChassis.isConnected();
        if (isChassisConnected) {
%>

            <img height="12" width="28" src="<%=Util.URL_BASE_IMAGES + "/ch.gif"%>"
               alt='<i18n:message key="field.ChassisConnector.text" bundle="<%=parmgrProperties%>" />'>

<%      }
%>

          </td>
          <td>

<%
        if (isChassisConnected) {
%>

          <parmgr:cellinfo discovery="<%=discovery%>"
                           slot="<%=discovery.getCellSlot(currChassis.getConnectedCellID())%>"
                           resources="<%=parmgrTagResources%>"
                           showDimms="false"
                           showPartition="true"
                           showCPUs="false"
                           selectedCheckboxes="<%=selectedCheckboxes%>" />


<%      }
    }
%>

          </td>
        </tr>
      </table>
    </td>

<%
    i++;
  }
%>
  </tr>
  </table>
  </td>
  </tr>
  <!-- end sixth row in overall table -->

</table>
<!-- end overall table -->

</BODY>
</HTML>
