<%--
/**
 * The content rendered for the complex power and cooling tab.
 *
 * @version $Header: /usr/local/vse/parmgr/src/web/jsp/complex_power_cooling.jsp,v 1.15 2008/03/05 12:40:58 sridharav Exp $
 * @risk: Low
 *
 * @task name = Create Power and Cooling view
 *       cycle = 5
 *       phase = TEST
 *       owner = Mike
 *       status = Done
 *       description = Create the page which shows the power and cooling domains
 */
--%>
<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>

<%@ page errorPage="exception.jsp" %>
<%@ page import="com.hp.parmgr.model.Discovery" %>
<%@ page import="com.hp.parmgr.model.Cabinet" %>
<%@ page import="com.hp.parmgr.model.Domain" %>
<%@ page import="com.hp.parmgr.model.DomainDevice" %>
<%@ page import="com.hp.parmgr.ui.tags.Util" %>
<%@ page import="java.util.List" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="java.util.Collections" %>
<%@ page import="java.util.Comparator" %>
<%@ page import="java.util.ResourceBundle" %>
<%@ page import="java.util.MissingResourceException" %>
<%@ page import="java.text.MessageFormat" %>
<%@ page import="com.hp.npar.mof.HP_NParPowerCoolingDomain" %>
<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page pageEncoding="UTF-8"%>

<jsp:useBean id="parsession" scope="session" class="com.hp.parmgr.ui.ParmgrSession" />

<%
    Discovery discovery = parsession.getDiscovery();
    List cabinets = discovery.getCabinets();

%>

<HTML>
<HEAD>
<META http-equiv="Content-Type" content="text/html;charset=UTF-8">
<META HTTP-EQUIV="expires" CONTENT="0">
<%@ include file="session_keep_alive.jsp" %>
<i18n:bundle baseName="com.hp.parmgr.ui.ComplexView" id="bundle" />
<i18n:bundle baseName="com.hp.parmgr.ui.tags.tags" id="parmgrTagResources" />

<script type='text/javascript' language='JavaScript' src='<%=Util.URL_PARMGR_JS%>'></script>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_PARMGR_CSS%>'>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_BASE_CSS + "/powercool.css"%>'>
<TITLE>Partition Manager - Complex <%=discovery.getComplex().getName()%></TITLE>
</HEAD>

<BODY onLoad="loadMenuFrame('<%=Util.URL_BASE_JSP%>')">
<!-- cabinets -->
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="4">
  <TR>

<%
    ResourceBundle domainBundle = ResourceBundle.getBundle("com.hp.npar.mof." + Domain.OBJECT_PATH, parsession.getLocale());

    MessageFormat domainFormat = new MessageFormat(bundle.getString("field.domain.format"));

     //
     // draw a box for each cabinet containing the power and cooling domains.
     //
     for (Iterator iter = cabinets.iterator(); iter.hasNext();)
     {
         Cabinet cabinet = (Cabinet) iter.next();
         List domains = discovery.getDomains(cabinet.getID());

         //
         // Sort the domains so that they come out in the order in which we want
         // to see them. Any unexpected domains will be shown last.
         //
         // The order should be Cabinet Cooling, Backplane Power, I/O fans,
         // Cabinet Power, I/O power (if any) and Backplane Cooling (if any.)
         //
         Collections.sort(domains, new Comparator () {
             private int weight(Domain d) {
                 int weight = 100;
                 switch (d.getDomainType()) {
                     case Domain.POWER:
                         switch (d.getSubType()) {
                             case Domain.CABINET:   weight = 40; break;
                             case Domain.IO:        weight = 50; break;
                             case Domain.BACKPLANE: weight = 20; break;
                         }
                         break;
                     case Domain.COOLING:
                         switch (d.getSubType()) {
                             case Domain.CABINET:   weight = 10; break;
                             case Domain.IO:        weight = 30; break;
                             case Domain.BACKPLANE: weight = 60; break;
                         }
                         break;
                 }
                 return weight;
             }
             public int compare(Object o1, Object o2) {
                 int w1 = weight((Domain) o1);
                 int w2 = weight((Domain) o2);
                 if (w1 < w2) {
                     return -1;
                 }
                 else if (w1 > w2) {
                     return 1;
                 }
                 return 0;
             }
         });

         String failedStatusImage = Util.URL_BASE_IMAGES + "/" +
             bundle.getString("device.status.failed.image");
         String okStatusImage = Util.URL_BASE_IMAGES + "/" +
             bundle.getString("device.status.ok.image");
%>
    <TD> <!-- a cabinet -->
      <TABLE CLASS="domain-cabinet" CELLPADDING="0" CELLSPACING="4">
        <TR>
          <TD CLASS="domain-cabinet-label"><%=cabinet.getLabel()%></TD>
        </TR>
<%
          //
          // Draw a table for each domain containing some stats and showing a graphic
          // for each device.
          //
          for (Iterator domainIter = domains.iterator(); domainIter.hasNext();)
          {
             Domain domain = (Domain) domainIter.next();

             if (domain.getSlotCount() <= 0) {
                 continue; // no device slots in the domain. Don't bother drawing it.
             }

             String domainSubTypeStr = domainBundle.getString(HP_NParPowerCoolingDomain.PROP_DomainSubtype + "_" + domain.getSubType());
             String domainTypeStr = domainBundle.getString(HP_NParPowerCoolingDomain.PROP_DomainType + "_" + domain.getDomainType());

             Object [] domainArgs = { domainSubTypeStr,
                                      domainTypeStr };
             String domainHeading = domainFormat.format(domainArgs);
%>

        <TR><TD CLASS="domain-device-group">
          <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="2" WIDTH="100%">
            <CAPTION CLASS="prop-table-caption"><%=domainHeading%></CAPTION>
            <TR>
              <TD CLASS="prop-table-header">&nbsp;</TD>
              <TD CLASS="prop-table-header" WIDTH="46%"><i18n:message key="field.HAStatus.label" bundle="<%=bundle%>" /></TD>
              <TD CLASS="prop-table-data" WIDTH="46%"><%=domain.getRedundancyStateString()%></TD>
            </TR>
            <TR>
              <TD CLASS="prop-table-header"><IMG SRC="<%=okStatusImage%>"></TD>
              <TD CLASS="prop-table-header"><i18n:message key="field.OK.label" bundle="<%=bundle%>" /></TD>
              <TD CLASS="prop-table-data"><%=domain.getUnitCount() - domain.getFailedCount()%></TD>
            </TR>
            <TR>
              <TD CLASS="prop-table-header"><IMG SRC="<%=failedStatusImage%>"></TD>
              <TD CLASS="prop-table-header"><i18n:message key="field.Failed.label" bundle="<%=bundle%>" /></TD>
              <TD CLASS="prop-table-data"><%=domain.getFailedCount()%></TD>
            </TR>
            <TR>
              <TD CLASS="prop-table-header">&nbsp;</TD>
              <TD CLASS="prop-table-header"><i18n:message key="field.Maximum.label" bundle="<%=bundle%>" /></TD>
              <TD CLASS="prop-table-data"><%=domain.getSlotCount()%></TD>
            </TR>
            <TR>
              <TD COLSPAN="3">
                <!-- domain devices -->
                <TABLE CELLPADDING="0" CELLSPACING="0" BORDER="0">
                  <TR>
<%
            //
            // Figure out what domain type string to use for looking up resources.
            // (We don't call domain.getDomainTypeString() because it can be localized.)
            //
            String domainType;
            switch (domain.getDomainType()) {
                case Domain.POWER:   domainType = "Power"; break;
                case Domain.COOLING: domainType = "Cooling"; break;
                default: domainType = "unknown";
            }

            MessageFormat altTextFormat = new MessageFormat(bundle.getString("device.altText.format"));

            //
            // Draw each of the devices in the domain.
            //
            DomainDevice [] devices = domain.getDomainDevices();

            //
            // Wrap on some sane number. For most cabinets putting up to 5
            // on a single line but wrapping at 3 for more than 5 devices
            // seems to look decent.
            //
            int devPerCol = (devices.length < 6) ? 5 : 3;

            for(int i = 0; i < devices.length; i++)
            {
                //
                // Figure out the status string to use for looking up resources.
                //
                String status;
                if (devices[i].isPresent()) {
                    status = (devices[i].isFailed()) ? "failed" : "ok";
                }
                else {
                    status = "absent";
                }

                //
                // Get the status and device image resources.
                // These will be the names of the images to display.
                //
                String statusImage = Util.URL_BASE_IMAGES + "/" +
                    bundle.getString("device.status." + status + ".image");
                String deviceImage = Util.URL_BASE_IMAGES + "/";

                try {
                    deviceImage += bundle.getString("device." + domainType + "." + status + ".image");
                }
                catch (MissingResourceException ex)
                {
                    //
                    // This can happen if the domainType isn't power or cooling.
                    // If so, we'll just let the deviceImage be ""
                    //
                }

                Object [] altTextArgs = {
                    devices[i].getLongLabel(),
                    bundle.getString("device.status." + status + ".text")
                };

                String altText = altTextFormat.format(altTextArgs);

                //
                // Wrap the devices row as needed.
                //
                if ((i > 0) && ((i % devPerCol) == 0)) {
%>
                   </TR>
                   <TR>
<%
                }

                //
                // Draw the device as a graphic plus its status icon and device number.
                //
%>
                     <TD CLASS="domain-device">
                       <TABLE CELLPADDING="0" CELLSPACING="2" BORDER="0" CLASS="parmgr-regular-text">
                         <TR>
                           <TD ROWSPAN="2"><IMG ALIGN="top" ALT="<%=altText%>" SRC="<%=deviceImage%>"></TD>
                           <TD VALIGN="top"><IMG ALIGN="top" ALT="<%=altText%>" SRC="<%=statusImage%>"></TD>
                         </TR>
                         <TR>
                           <TD VALIGN="bottom"><%=i%></TD>
                         </TR>
                       </TABLE>
                     </TD>
<%
            } // for i
%>
                  </TR>
                </TABLE> <!-- domain devices -->
              </TD>
            </TR>
          </TABLE>
        </TD></TR>
<%

         } // for domains
%>
        </TABLE>
      </TD> <!-- a cabinet -->
<%
     } // for cabinets
%>
  </TR>
</TABLE> <!-- cabinets -->
</BODY>
</HTML>
