<%--
/**
 * The JSP page for turning off all the LEDs in the complex.
 *
 * @version $Header: /usr/local/vse/parmgr/src/web/jsp/complex_turn_off_all_LEDs.jsp,v 1.24 2008/03/05 12:40:58 sridharav Exp $
 * @risk Medium
 *
 * @task name = Complex Task: turn off all LEDs
 *       cycle = 5
 *       phase = test
 *       owner = Ming
 *       status = done
 *       description = none.
 */
--%>

<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>

<%@ page import="com.hp.parmgr.ui.SessionTimeOut" %>
<%@ page import="com.hp.parmgr.ui.tags.Util" %>
<%@ page import="com.hp.parmgr.util.FRULedTask" %>
<%@ page import="com.hp.parmgr.util.TaskUtil" %>
<%@ page import="com.hp.parmgr.util.CommandFailedException" %>
<%@ page import="com.hp.parmgr.util.CommandIOException" %>
<%@ page import="com.hp.parmgr.util.Log" %>
<%@ page import="com.hp.parmgr.model.Discovery" %>
<%@ page import="com.hp.parmgr.model.Cabinet" %>
<%@ page import="java.util.List" %>
<%@ page import="java.text.MessageFormat" %>
<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page pageEncoding="UTF-8"%>

<jsp:useBean id="parsession" scope="session"
             class="com.hp.parmgr.ui.ParmgrSession" />

<i18n:bundle baseName="com.hp.parmgr.ui.Parmgr" id="bundle" />

<HTML>

<HEAD>
<META http-equiv="Content-Type" content="text/html;charset=UTF-8">
<%@ include file="session_keep_alive.jsp" %>
    <link type="text/css" rel="stylesheet" href="<%=Util.URL_PARMGR_CSS%>">
    <script type='text/javascript' language='JavaScript'
            src='<%=Util.URL_PARMGR_JS%>'></script>
<%=SessionTimeOut.javascript(session, bundle.getLocale())%>
    <title>
        <i18n:message key="complexTurnOffAllLEDs.title" bundle="<%=bundle%>" />
    </title>

</HEAD>

<BODY>

<p align="left" class="subwindow-heading">
    <i18n:message key="complexTurnOffAllLEDs.title" bundle="<%=bundle%>" />
</p>

<%
    boolean hasErr = false;
    String errMsg = null;
    String helpPage = "complexTurnOffAllLEDs";
    String fromURL = parsession.getFromURL();
    Discovery discovery = parsession.getDiscovery();

    Object [] msgArgs = { discovery.getComplex().getName() };
    MessageFormat format =
        new MessageFormat(bundle.getString("complexName.fmt"));
%>
<p>
    <%=format.format(msgArgs)%>
</p>
<br>
<table border cellpadding=3 width="100%">
<tr>
<th><%=bundle.getString("complexTurnOffAllLEDs.table.header.type")%></th>
<th><%=bundle.getString("complexTurnOffAllLEDs.table.header.status")%></th>
</tr>
<tr>
<td><%=bundle.getString("complexTurnOffAllLEDs.table.type.cell")%></td>
<td>
<%
    int type = discovery.getCabinet(0).getType();
    boolean onlyHasCellLed =
        ((type == Cabinet.KEYSTONE) || (type == Cabinet.MATTERHORN));

    // create command task object to turn off all LEDs.
    FRULedTask turnOffCellLEDs = FRULedTask.getAllCellLedsOffTask(parsession.getLoginCredentials());
    FRULedTask turnOffChassisLEDs = FRULedTask.getAllChassisLedsOffTask(parsession.getLoginCredentials());

    List cabList = discovery.getCabinets();
    FRULedTask turnOffCabinetLEDs = FRULedTask.getCabinetLEDTask(cabList, false,parsession.getLoginCredentials());

    // log the start of the task.
    Log.summary(Log.EVENT_START, Log.RESULT_NONE,
            "Starting to clear all attention LEDs in the complex.");

    // turn off all cell LEDs.
    try {
        turnOffCellLEDs.run();
%>
<p>
    <%=bundle.getString("complexTurnOffAllLEDs.cell.success.str")%>
</p>
<%
    }
    catch (CommandIOException ioe) {
        hasErr = true;
        Object [] ioeArgs = {ioe.getMessage()};
        MessageFormat ioeFormat =
            new MessageFormat(bundle.getString("error.ioError.format"));
        errMsg = ioeFormat.format(ioeArgs);
        TaskUtil.displayError(errMsg, bundle, out);
    } catch (CommandFailedException ce) {
        hasErr = true;
        errMsg = ce.getMessage();
        TaskUtil.displayError(errMsg, bundle, out);
    }
%>
</td>
</tr>
<%
    // turn off all chassis LEDs if there are any.
    boolean isChassisLEDPresent = discovery.isChassisLEDPresent();
    if (isChassisLEDPresent && (!onlyHasCellLed)){
        %>
        <tr>
        <td><%=bundle.getString("complexTurnOffAllLEDs.table.type.chassis")%></td>
        <td>
        <%
        try {
            turnOffChassisLEDs.run();
%>
<p>
    <%=bundle.getString("complexTurnOffAllLEDs.chassis.success.str")%>
</p>
<%
        }
        catch (CommandIOException ioe) {
            hasErr = true;
            Object [] ioeArgs = {ioe.getMessage()};
            MessageFormat ioeFormat =
                new MessageFormat(bundle.getString("error.ioError.format"));
            errMsg = ioeFormat.format(ioeArgs);
            TaskUtil.displayError(errMsg, bundle, out);
        } catch (CommandFailedException ce) {
            hasErr = true;
            errMsg = ce.getMessage();
            TaskUtil.displayError(errMsg, bundle, out);
        }
        %>
        </td>
        </tr>
        <%
    }
    // steady all cabinet LCDs.
    if (!onlyHasCellLed) {
        %>
        <tr>
        <td><%=bundle.getString("complexTurnOffAllLEDs.table.type.complex")%></td>
        <td>
        <%
        try {
            turnOffCabinetLEDs.run();
%>
<p>
    <%=bundle.getString("complexTurnOffAllLEDs.cabinet.success.str")%>
</p>
<%
        }
        catch (CommandIOException ioe) {
            hasErr = true;
            Object [] ioeArgs = {ioe.getMessage()};
            MessageFormat ioeFormat =
                new MessageFormat(bundle.getString("error.ioError.format"));
            errMsg = ioeFormat.format(ioeArgs);
            TaskUtil.displayError(errMsg, bundle, out);
        } catch (CommandFailedException ce) {
            hasErr = true;
            errMsg = ce.getMessage();
            TaskUtil.displayError(errMsg, bundle, out);
        }
        %>
        </td>
        </tr>
        <%
    }
%>
</table>
<%
    if (hasErr){
        // display result on the screen.
%>
<p>
    <%=bundle.getString("complexTurnOffAllLEDs.end.failure")%>
</p>
<%
        // log result
        Log.summary(Log.EVENT_DONE, Log.RESULT_FAILURE,
            "Failed to clear all attention LEDs.");
    } else {
        // log result
        Log.summary(Log.EVENT_DONE, Log.RESULT_SUCCESS,
            "All attention LEDs have been cleared.");
    }

%>

<br>
<p>
<i18n:message key="parmgr.commandTitle.str"  bundle="<%=bundle%>" />
</p>

<code>

<p align="left">
<%=turnOffCellLEDs.getCommand()%>
</p>

<% if (isChassisLEDPresent && (!onlyHasCellLed)) { %>
<p align="left">
<%=turnOffChassisLEDs.getCommand()%>
</p>
<% } %>

<% if (!onlyHasCellLed) { %>
<p align="left">
<%=turnOffCabinetLEDs.getCommand()%>
</p>
<% } %>

</code>

<p align=left>
    <INPUT class="button" type="button"
        value="<%=bundle.getString("button.ok.str")%>"
        name="Ok"
        onClick="window.location.replace('<%=fromURL%>');"
    />
    <INPUT class="button" type="button"
        value="<%=bundle.getString("button.help.str")%>"
        name="Help"
        onClick="showHelp('<%=parsession.getHelpURL(helpPage)%>')"
    />
</p>

</BODY>
</HTML>
