<%--
/**
 * The JSP page for the create npar wizard.
 *
 * @version $Header: /usr/local/vse/parmgr/src/web/jsp/create_npar.jsp,v 1.73 2008/03/05 12:48:29 sridharav Exp $
 * @risk Medium
 *
 * @task name = create npar
 *       cycle = 2
 *       phase = TEST
 *       owner = Ming
 *       status = Done
 *       description = create a hardware partition.
 *
 * @task name = don't use pop ups to report command failures for create/modify
 *       cycle = 6
 *       phase = TEST
 *       owner = Ming
 *       status = Done
 *       description = None.
 *
 * @task name = Integrate wait for dialog into create/modify
 *       cycle = 6
 *       phase = TEST
 *       owner = Ming
 *       status = Done
 *       description = use the wait for dialog to wait for cells to power on.
 */
--%>

<%@ page errorPage="exception.jsp" %>
<%@ page import="com.hp.parmgr.util.*,
                 com.hp.parmgr.model.*,
                 com.hp.parmgr.ui.*,
                 java.util.*" %>
<%@ page import="com.hp.parmgr.ui.tags.Util" %>

<%@ page import="java.util.regex.Pattern"%>
<%@ page import="java.util.regex.Matcher"%>
<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page pageEncoding="UTF-8"%>

<%@ taglib uri="/com/hp/parmgr/ui/tags/parmgr" prefix="parmgr" %>
<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>
<%@ taglib uri="/com/hp/mx/taglibs/MxTabsTag" prefix="tabs" %>

<%@ include file="session_init.jsp" %>
<jsp:useBean id="parConfig" scope="session"
    class="com.hp.parmgr.util.HWPartitionBean" />

<i18n:bundle baseName="com.hp.parmgr.ui.Parmgr" id="parmgrResources" />
<i18n:bundle baseName="com.hp.parmgr.ui.tags.tags" id="parmgrTagResources" />
<i18n:bundle baseName="com.hp.parmgr.ui.CellView" id="cellResources" />
<i18n:bundle baseName="com.hp.parmgr.ui.CreateModifyNpar" id="bundle"/>

<HTML>
<HEAD>
<META http-equiv="Content-Type" content="text/html;charset=UTF-8">
<%@ include file="session_keep_alive.jsp" %>
    <link type="text/css" rel="stylesheet" href="<%=Util.URL_PARMGR_CSS%>">
    <link type="text/css" rel="stylesheet" href="<%=Util.URL_MXTABLE_CSS%>">
    <link type="text/css" rel="stylesheet" href="<%=Util.URL_BASE_CSS + "/create_npar.css"%>">
    <link type="text/css" rel="stylesheet" href="<%=Util.URL_HARDWARE_CSS%>">
    <tabs:MxTabs dumpHeadContent="true" urlBase="<%=Util.URL_BASE%>"/>
    <script type='text/javascript' language='JavaScript'
            src='<%=Util.URL_PARMGR_JS%>'></script>
<%=SessionTimeOut.javascript(session, bundle.getLocale())%>
    <%@ include file="cm_npar_scripts.jsp" %>

    <title>
        <i18n:message bundle="<%=bundle%>" key="create.npar.title"/>
    </title>
</HEAD>

<%
    boolean exitTask = false;
    boolean taskCancel = false;
    boolean showPowerOrWaitDialog = false;
    boolean hasErr = false;
    boolean goToWait = false;
    boolean displaySuccess = false;
    boolean errorCells = false;
    int parID = -1;
    String fromURL;
    String message = new String();
    String toURL = null;
    boolean taskDone = false;
    String formAction="create_npar.jsp";
    Discovery discovery = parsession.getDiscovery();

    // Do this after getting discovery
    if (!parsession.userAuthorizedToMakeChanges("parcreate")) {
        throw new UnauthorizedUserException(parsession.getFromURL(), parsession.getLocale());
    }

    Object [] args = { discovery.getComplex().getName() };
    MessageFormat format = new MessageFormat(parmgrResources.getString("complexName.fmt"));
    String complexName = format.format(args);

    SelectionManager selectedCheckboxes = parsession.getSelectedCheckboxes();

    // get the button values. Only one of these button values should be
    // present at any given time.
    String backButton = request.getParameter("back");
    String nextButton = request.getParameter("next");
    String cancelButton = request.getParameter("cancel");
    String finishButton = request.getParameter("finish");
    String okButton = request.getParameter("ok");
    String cellCompatibilityButton = request.getParameter("cellCompatibility");
    String powerOrWaitButton = request.getParameter("powerOrWait");
    String noPowerOrWaitButton = request.getParameter("noPowerOrWait");
    int currentPage = HWPartitionBean.SET_NAME;


    // get the stepNumber of the wizard page the user just came from.
    // JAGaf88550: guard against cross site scripting vulnerabilities,
    // by encoding parameters that may be output to the HTML stream:
    String stepNumber =
        StringFormatUtil.encodeHtmlEntities(request.getParameter("stepNumber"));

    if (null != stepNumber) {
        // set current page to previous page.
        currentPage = Integer.parseInt(stepNumber, 10);
    }

    if ((null == backButton) &&
        (null == nextButton) &&
        (null == cancelButton) &&
        (null == okButton) &&
        (stepNumber == null) &&
        (null == cellCompatibilityButton) &&
        (null == powerOrWaitButton) &&
        (null == noPowerOrWaitButton) &&
        (null == finishButton)) {

        // clear the Discovery cache, so data will be fresh
        discovery.clearCache();

        // First, check to see if a pending profile currently exists.
        // Raise the checkPending flag to ensure that Discovery is
        // accessed.
        parsession.setCheckPending(true);

        // In case we came in from the CLI, set the run ACH flag
        // to false so that when we leave create, we don't automatically
        // run ACH.
        parsession.setRunACH(false);
%>

<%@ include file="check_pending_profile.jsp" %>

<%
        // If the stepNumber variable is not present in the request header,
        // then we assume it is the first step.
        stepNumber = Integer.toString(HWPartitionBean.SET_NAME);

        // no buttons have been pressed, and the stepnumber is null,
        // we are at the start of the task.
        Log.summary(Log.EVENT_START, Log.RESULT_NONE,
            bundle.getString("createNpar.start.log"));

        // initialize createNpar object for holding state data and add bean to
        // response header.  The bean defaults field values will be used to put
        // initialize values in the form fields.
        parConfig.reset();
        parConfig.setDiscovery(discovery, selectedCheckboxes);
        parConfig.setFromURL(parsession.getFromURL());
        parConfig.setBundle(bundle);

        // make sure there are no error cells before entering.
        message = parConfig.checkForNewErrorCells();
        if (message.length() > 0) {
            // log the error and log create nPar failure.
            Log.error(bundle.getString("errorCells.error.log"));
            Log.summary(Log.EVENT_DONE, Log.RESULT_FAILURE,
                    bundle.getString("createNpar.end.failure.log"));
        } else {
            // make sure there is at least one viable core cell,
            // and at least one available IO chassis before entering.
            // (these are now separate checks, because with Arches,
            // core IO is attached to the cell, rather than to the chassis)
            message += parConfig.checkAtLeastOneFreeViableCore();
            message += parConfig.checkAtLeastOneFreeIOChassis();

            if (message.length() > 0){
                // there are no viable core cells to create a partition from,
                // exit the create task.
                exitTask = true;
                // log the error and log create nPar failure.
                Log.error(message);
                Log.summary(Log.EVENT_DONE, Log.RESULT_FAILURE,
                    bundle.getString("createNpar.end.failure.log"));
            }
        }
    } else if ((nextButton != null) || (cellCompatibilityButton != null)){
        if (nextButton != null){
            // Fill in createNpar object fields with posted data from the
            // request header and add bean to response header.
            // Do not update the state, however, if the user came here after
            // cells were powered on or completed powering on.
            parConfig.updateState(currentPage, request);
        } else {
            // we must have just gotten back from waiting on the cells to
            // power on.
            parConfig.refreshCells();
        }

        if (currentPage == HWPartitionBean.SELECT_CELLS){
            // validate cell selection
            message = parConfig.checkForNewErrorCells();
            if (message.length() > 0) {
                errorCells = true;
            } else {
                message = parConfig.validateCellSelection();
                if (parConfig.isPoweredOffCells() ||
                    parConfig.isSelfTestCells() ||
                    parConfig.isPoweredOffChassis()) {
                    showPowerOrWaitDialog = true;
                }
            }
        }

        if (message.length() == 0){
            // there is no error.

            // the user pressed next button or had powered on cells or waited
            // for cells to complete self test, so we should go forward by one
            // page.
            currentPage++;
        } else {
            Log.error(message);
        }
    } else if (backButton != null){
        // Maintain user selections when come back to this page
        parConfig.updateState(currentPage, request);
        // the user pressed back button, so we should go back by one page.
        currentPage--;
    } else if (cancelButton != null){
        // log that the user canceled out of create nPar.

        // return to fromURL.
        taskCancel = true;
    } else if (powerOrWaitButton != null){
        if (parConfig.isPoweredOffCells()){
            // if there are powered off cells, power on the cells and then wait.
            try {
                parConfig.powerOnCells(parsession.getLoginCredentials());
                // Log success powering on cells.

                // set up the wait for dialog.
                parConfig.setUpWait(parsession, true);
                message = bundle.getString("powerOnCells.success.str");
                displaySuccess = true;
                goToWait = true;
            } catch (CommandIOException ioe) {
                Object [] ioeArgs = {ioe.getMessage()};
                MessageFormat ioeFormat =
                    new MessageFormat(parmgrResources.getString("error.ioError.format"));
                message = ioeFormat.format(ioeArgs);
                hasErr = true;
            } catch (CommandFailedException ce) {
                message = ce.getMessage();
                hasErr = true;
            }

            currentPage = HWPartitionBean.SELECT_CELLS;

        } else if (parConfig.isSelfTestCells()){
            // if there are cells are in selftest, wait for these cells to
            // complete the power-on sequence.
            parConfig.setUpWait(parsession, true);
            goToWait = true;
        } else if (parConfig.isPoweredOffChassis()){
            // if there are powered off chassis, power on the chassis and
            // continue.
            try {
                parConfig.powerOnChassis(parsession.getLoginCredentials());
                // Log success powering on chassis.
                displaySuccess = true;
                message = bundle.getString("powerOnChassis.success.str");
            } catch (CommandIOException ioe) {
                Object [] ioeArgs = {ioe.getMessage()};
                MessageFormat ioeFormat =
                    new MessageFormat(parmgrResources.getString("error.ioError.format"));
                message = ioeFormat.format(ioeArgs);
                hasErr = true;
            } catch (CommandFailedException ce) {
                message = ce.getMessage();
                hasErr = true;
            }

            // doesn't matter if we succeeded at powering on the chassis or not,
            // we are going on to the next page.
            currentPage = HWPartitionBean.CELL_OPTS;
        }
    } else if (noPowerOrWaitButton != null){
        // the user has decided not to power on cells/chassis, or wait for
        // cells to finish self test.

        if (parConfig.isPoweredOffCells() || parConfig.isSelfTestCells()){
            // if it's cells, then put the user back into the select cells page
            // so they can deselect the cells.
            currentPage = HWPartitionBean.SELECT_CELLS;
        } else if (parConfig.isPoweredOffChassis()){
            // if it's chassis, then continue to next page.
            currentPage = HWPartitionBean.CELL_OPTS;
        }

    } else if (finishButton != null){
        // user has finished all the steps, and we are ready to create the
        // partition.
        // Execute parcreate with options.
        // put up pop up msg to show parcreate results.
        // return to where the user invoked the task, or to new partition.
        HWPartitionCreateTask parCreate = parConfig.getParcreateCmd();
        try {
            parCreate.run();

            // parse out the partition ID from stdout.
            message = parCreate.getStdout();

            /* the parcreate message is in the form of
                    Partition created, partition number: 2
            */
            Pattern p = Pattern.compile("\\d+$");
            Matcher m = p.matcher(message);

            // we should always succeed with a match, unless the parcreate folks
            // changed their message.
            m.find();
            String parIDStr = m.group();

            selectedCheckboxes.deselectAllCheckboxes();
            discovery.clearCache();

            // Give the service processor a chance to push out the
            // pending profile.
            WaitForProfile.waitFixedTime(discovery);

            // Set the check pending flag so that if the service
            // processor did not complete pushing out the pending
            // profile, we warn the user that it is still out there.
            parsession.setCheckPending(true);

            // forward the user to the partition page displaying the partition
            // that was just created.
            toURL = "partition.jsp?partition="+parIDStr;
            taskDone = true;

        } catch (CommandIOException ioe) {
            Object [] ioeArgs = {ioe.getMessage()};
            MessageFormat ioeFormat =
                new MessageFormat(parmgrResources.getString("error.ioError.format"));
            message = ioeFormat.format(ioeArgs);
        } catch (CommandFailedException ce) {
            message = ce.getMessage();
        }

        if (taskDone){
            Log.summary(Log.EVENT_DONE, Log.RESULT_SUCCESS,
                 bundle.getString("createNpar.end.success.log"));
        } else {
            hasErr = true;
            currentPage = HWPartitionBean.FINISH;

            // log the failure.
            Log.summary(Log.EVENT_DONE, Log.RESULT_FAILURE,
                 bundle.getString("createNpar.end.failure.log"));
        }

    }
%>

<% if (taskDone) { %>

<BODY onLoad="window.location.replace('<%=toURL%>');">
</BODY>
</HTML>

<% } else if (displaySuccess) { %>
<BODY>

    <p>
    <%=message%>
    </p>

    <form action='create_npar.jsp' method='post'>

    <input type='hidden' name='stepNumber' value='<%=currentPage%>' />

<%      if (goToWait) { %>
    <input type='button' class='button' name='ok'
           value='<%=bundle.getString("button.ok.str")%>'
           onClick='window.location.replace("wait.jsp")'
    />
<%      } else { %>
    <input type='submit' class='button' name='cellCompatibility'
           value='<%=bundle.getString("button.ok.str")%>'
    />

<%      } %>

    </form>

</BODY>
</HTML>

<% } else if (goToWait) { %>
<BODY onLoad='window.location.replace("wait.jsp")' >
</BODY>
</HTML>

<% } else if (taskCancel) {

    String gotoURL = parConfig.getFromURL();
    if (gotoURL == null) {
        // The user came from the CLI
        gotoURL = "complex.jsp?selection=HARDWARE";
    }
%>

<BODY onLoad="window.location.replace('<%=gotoURL%>');">
</BODY>
</HTML>

<% } else if (hasErr || errorCells) { %>
<body>
<%     if (hasErr) { %>
    <%TaskUtil.displayError(message, parConfig.getErrBundle(), out);%>
<%     } else { %>
    <p><%=message%></p>
<%     } %>

    <form action='create_npar.jsp' method='post'>

    <input type='hidden' name='stepNumber' value='<%=currentPage%>' />

    <input type='submit' class='button' name='ok'
           value='<%=bundle.getString("button.ok.str")%>'
    />

    </form>
</body>
</html>

<% }else if (showPowerOrWaitDialog){
    // print confirmation for powering on cells/chassis or wait for cells in
    // self test.
%>
<BODY>

    <p>
    <%=message%>
    </p>

    <form action='create_npar.jsp' method='post'>

    <input type='submit' class='button' name='powerOrWait'
           value='<%=bundle.getString("button.ok.str")%>'
    />

    <input type='submit' class='button' name='noPowerOrWait'
           value='<%=bundle.getString("button.cancel.str")%>'
    />

    </form>

</BODY>
</HTML>

<% } else {

    String gotoURL = parConfig.getFromURL();
    if (gotoURL == null) {
        // The user came from the CLI
        gotoURL = "complex.jsp";
    }
%>

<BODY onLoad="displayErr(<%=exitTask%>, '<%=gotoURL%>')">

    <TABLE border="0" cellpadding="0" cellspacing="5" width="100%">
        <TR>
            <TD width="180" valign="top">
            <%@ include file="create_npar_steps.jsp" %>
            </TD>

            <TD width="100%" valign="top">
            <% String pageID = "";
               if (HWPartitionBean.SET_NAME == currentPage) {
                  pageID = "createNParSetName"; %>
                  <%@ include file="create_npar_set_name.jsp" %>
            <% } else if (HWPartitionBean.SELECT_CELLS == currentPage) {
                  pageID = "createNParSelectCells"; %>
                  <%@ include file="create_npar_select_cells.jsp" %>
            <% } else if (HWPartitionBean.CELL_OPTS == currentPage) {
                  pageID = "createNParCellOpts"; %>
                  <%@ include file="create_npar_cell_opts.jsp" %>
            <% } else if (HWPartitionBean.CONFIG_MEM == currentPage) {
                  pageID = "createNParConfigMem"; %>
                  <%@ include file="create_npar_config_mem.jsp" %>
            <% } else if (HWPartitionBean.BOOT_OPTS == currentPage) {
                  pageID = "createNParBootOpts"; %>
                  <%@ include file="create_npar_boot_opts.jsp" %>
            <% } else if (HWPartitionBean.SUMMARY == currentPage) {
                  pageID = "createNParSummary"; %>
                  <%@ include file="create_npar_summary.jsp" %>
            <% } else if (HWPartitionBean.FINISH == currentPage) {
                  pageID = "createNParFinish"; %>
                  <%@ include file="create_npar_finish.jsp" %>
            <% } else { %>

            <% }%>
            </TD>
        </TR>

        <TR>
            <TD width="100%" colspan="2">
            <HR class="separator">
            <TABLE border="0">
                <TR>
                    <TD width="100%">&nbsp;</TD>

                    <%-- Determine if the back button should be present. --%>
                    <% if (HWPartitionBean.SET_NAME != currentPage ) { %>
                    <TD>
                    <INPUT class="button" type="submit"
                           value='<%=bundle.getString("button.back.str")%>'
                           onClick="setDoNotValidate();"
                           name="back"/>
                    </TD>
                    <TD>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
                    <% } %>

                    <TD>
                    <%--
                    Determine if the finish button should be present.
                    --%>
                    <% if (HWPartitionBean.FINISH == currentPage) { %>
                    <INPUT class="button" type="submit"
                           value='<%=bundle.getString("button.finish.str")%>'
                           name="finish" />
                    <% } else { %>
                    <INPUT class="button" type="submit"
                           value='<%=bundle.getString("button.next.str")%>'
                           name="next" />
                    <% } %>
                    </TD>
                    <TD>&nbsp;&nbsp;&nbsp;&nbsp;</TD>

                    <TD>
                    <INPUT class="button" type="submit"
                           value='<%=bundle.getString("button.cancel.str")%>'
                           onClick="setDoNotValidate();"
                           name="cancel"
                    />
                    </TD>
                    <TD>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
                    <TD>
                    <INPUT class="button" type="button"
                           value='<%=bundle.getString("button.help.str")%>'
                           name="help"
                           onclick="showHelp(
                                    '<%=parsession.getHelpURL(pageID)%>')"
                    />
                </TR>
            </TABLE>

            </TD>
        </TR>

    </TABLE>

<input type="hidden" id="errorMsg" value="<%=message%>">

</FORM>

</BODY>
</HTML>
<% } %>
