<%--
/**
 * The main JSP page for the "View Summary".
 * <p>
 * This page contains the main structure of the "View Summary"
 * of the create nPar interface.
 * <p>
 * Depending on which tab is selected, this JSP includes the
 * appropriate JSP for the body of the view.
 *
 * @version $Header: /usr/local/vse/parmgr/src/web/jsp/create_npar_summary.jsp,v 1.18 2006/03/23 18:06:37 scheetz Exp $
 * @risk Medium
 */
--%>

<%@ page import="com.hp.parmgr.util.StringFormatUtil" %>

<%
    // only create the task when we have all the partition information.
    HWPartitionCreateTask parCreate = new HWPartitionCreateTask(parConfig,
            parsession.getLoginCredentials());
    parConfig.setParcreateCmd(parCreate);

    // JAGaf88550: guard against cross site scripting vulnerabilities,
    // by encoding parameters that may be output to the HTML stream:
    String szSelected =
        StringFormatUtil.encodeHtmlEntities(request.getParameter("selection"));
    if (szSelected == null)
        szSelected = "GENERAL";

    /* disovery object from create_npar.jsp, 2nd param is the resource bundle */
    HaChecks checks = new HaChecks(discovery, parsession.getLocale());

    List haCheckResults = new ArrayList();

    Cell[] cellsArray = parConfig.getCells();

    haCheckResults = checks.getHaChecks(cellsArray);
    // this call must come after the call to getHaChecks to get the correct
    // value.
    boolean hasWarnings = checks.hasWarnings();

%>

<%-- The method is post so that the parameters does not show up on the URL --%>
<FORM action="create_npar.jsp" method="post">

<%-- hidden value used to keep track of which step we are on --%>
<input type="hidden" name="stepNumber" value="<%=HWPartitionBean.SUMMARY%>">

<table border=0 cellpadding=0 cellspacing=0 width="100%">
<tr><td height=18 class=parmgr_tab_cell>
    <font class="wizard-page-heading">
    <i18n:message key="summary.header.str" bundle="<%=bundle%>"/>
    </font>
</td></tr>
<tr><td class=parmgr_tab_cell>
    <font class=parmgr-regular-text>
    <%=complexName%><br>
    &nbsp;
    </font>
</td></tr>
<tr><td class=smc-filler>
<tabs:MxTabs selection="<%=szSelected%>" style="boris" urlBase="<%=Util.URL_BASE%>">
    <selectors>
        <selector id="GENERAL">
            <name>GENERAL</name>
            <label>
                <i18n:message key="tab.General.label" bundle="<%=bundle%>"/>
            </label>
            <url>
                <%=request.getRequestURI()%>?stepNumber=6&amp;selection=GENERAL
            </url>
        </selector>

        <selector id="CELLS">
            <name>CELLS</name>
            <label>
                <i18n:message key="tab.Cells.label" bundle="<%=bundle%>"/>
            </label>
            <url>
                <%=request.getRequestURI()%>?stepNumber=6&amp;selection=CELLS
            </url>
        </selector>

        <selector id="CPUMEM">
            <name>CPUMEM</name>
            <label>
                <i18n:message key="tab.CPUMemory.label" bundle="<%=bundle%>"/>
            </label>
            <url>
                <%=request.getRequestURI()%>?stepNumber=6&amp;selection=CPUMEM
            </url>
        </selector>

        <selector id="IO">
            <name>IO</name>
            <label>
                <i18n:message key="tab.IO.label" bundle="<%=bundle%>"/>
            </label>
            <url>
                <%=request.getRequestURI()%>?stepNumber=6&amp;selection=IO
            </url>
        </selector>

        <selector id="HACHECKS">
            <name>HACHECKS</name>
            <label>
                <i18n:message key="tab.HAChecks.label" bundle="<%=bundle%>"/>
            </label>
            <url>
                <%=request.getRequestURI()%>?stepNumber=6&amp;selection=HACHECKS
            </url>
        </selector>
    </selectors>
</tabs:MxTabs>
</td></tr>

<tr><td bgcolor=white>

<%  if (szSelected.equals("GENERAL")) {
        Log.detail(Log.EVENT_INTERMEDIATE, Log.RESULT_NONE,
            "Summary: General");
%>

<%@ include file="create_npar_summary_general.jsp" %>

<%  } else if (szSelected.equals("CELLS")) {
        Log.detail(Log.EVENT_INTERMEDIATE, Log.RESULT_NONE,
            "Summary: Cells");
%>

<%@ include file="create_npar_summary_cells.jsp" %>

<%  } else if (szSelected.equals("CPUMEM")) {
        Log.detail(Log.EVENT_INTERMEDIATE, Log.RESULT_NONE,
            "Summary: CPU and Memory");
%>

<%@ include file="create_npar_summary_cpu_mem.jsp" %>

<%  } else if (szSelected.equals("IO")) {
        Log.detail(Log.EVENT_INTERMEDIATE, Log.RESULT_NONE,
            "Summary: I/O");
%>

<%@ include file="create_npar_summary_iochassis.jsp" %>

<%  } else if (szSelected.equals("HACHECKS")) {
        Log.detail(Log.EVENT_INTERMEDIATE, Log.RESULT_NONE,
            "Summary: HA Checks");
%>

<%@ include file="create_npar_summary_hachecks.jsp" %>

<%  } %>

</td></tr>

</table>
