<%--
/**
 * The JSP page which allows menus to be created in the proper
 * iframe.
 * <P>
 *
 * @task name = Provide menu functionality
 * cycle = 2
 * owner = Paul
 * phase = TEST
 * status = Done
 * description = Using MxMenuTag taglib, in conjunction with data
 *               stored via SelectionManager, cause menus to draw
 *               themselves in the proper iframe.
 *
 * @task name = Provide print link
 * cycle = 9
 * owner = Paul
 * phase = DESIGN
 * status = Done
 * description = Add "Print" action to menu.jsp
 *
 * @task name = Enforce single-select on all I/O actions
 * cycle = 3
 * owner = Paul
 * phase = TEST
 * status = Done
 * description = Prepare for CAT integration
 *
 * @task name = Provide "Deselect all checkboxes" menu item
 * cycle = 3
 * owner = Paul
 * phase = TEST
 * status = Done
 * description = Clear all on SelectionManager and refresh
 *
 * @task name = Retain cascade state across views
 * cycle = 3
 * owner = Paul
 * phase = TEST
 * status = Done
 * description = Depends on menu context
 *
 * @task name = Implement visible/invisible checks
 * cycle = 3
 * owner = Paul
 * phase = TEST
 * status = Done
 * description = Depends on menu context
 *
 * @task name = Implement menu context updates in parmgrsession
 * cycle = 3
 * owner = Paul
 * phase = TEST
 * status = Done
 * description = Depends on menu context
 *
 * @task name = Implement implicit selection
 * cycle = 3
 * owner = Paul
 * phase = TEST
 * status = Done
 * description = Depends on menu context
 *
 * @task name = Redefine action menu frame sizing
 * cycle = 3
 * owner = Paul
 * phase = TEST
 * status = Done
 * description =
 *
 * @task name = Include Help link
 * cycle = 3
 * owner = Paul
 * phase = TEST
 * status = Done
 * description = Also entails adding hidden frames to all other JSPs
 *
 * @task name = Integrate CAT tasks
 * cycle = 5
 * owner = Paul
 * phase = TEST
 * status = Done
 * description =
 *
 */
--%>

<%@ taglib uri="/com/hp/mx/taglibs/MxMenuTag" prefix="menu" %>
<%@ taglib uri="/com/hp/parmgr/ui/tags/parmgr" prefix="parmgr" %>
<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>

<%@ page import="com.hp.parmgr.ui.SelectionManager" %>
<%@ page import="com.hp.parmgr.util.Menu" %>
<%@ page import="com.hp.parmgr.ui.tags.Util" %>
<%@ page import="java.util.HashMap" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="java.util.List" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="java.util.StringTokenizer" %>
<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page pageEncoding="UTF-8"%>

<jsp:useBean id="parsession" scope="session" class="com.hp.parmgr.ui.ParmgrSession" />

<i18n:bundle baseName="com.hp.parmgr.ui.menu" id="parmgrMenuResources"/>

<%
    com.hp.parmgr.model.Discovery discovery;
    discovery = parsession.getDiscovery();

    com.hp.parmgr.ui.SelectionManager selectedCheckboxes;
    selectedCheckboxes = parsession.getSelectedCheckboxes();

    String modifiedCheckboxName = request.getParameter("name");
    String modifiedCheckboxState = request.getParameter("state");

    if (modifiedCheckboxName != null) {
        if (modifiedCheckboxName.equals("deselectAllCheckboxes")) {
           selectedCheckboxes.deselectAllCheckboxes();
        } else if (modifiedCheckboxState != null) {
              if (modifiedCheckboxState.equalsIgnoreCase("true")) {
                selectedCheckboxes.addSelection(modifiedCheckboxName);
              } else {
                selectedCheckboxes.removeSelection(modifiedCheckboxName);
              }
        }
    }

    String currentMenuCascadeState = parsession.getMenuCascadeState();
    HashMap openMenuCascades = new HashMap();

    StringTokenizer cascadeStates = new StringTokenizer(currentMenuCascadeState, ",");
    while (cascadeStates.hasMoreTokens()) {
        openMenuCascades.put(cascadeStates.nextToken(), "true");
    }

%>

<HTML>
<HEAD>
<%@ include file="session_keep_alive.jsp" %>
<menu:MxMenu dumpHeadContent="true" urlBase="<%=Util.URL_BASE%>"/>
<script type='text/javascript' language='JavaScript' src='<%=Util.URL_PARMGR_JS%>'>
</script>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_PARMGR_CSS%>'>

<META HTTP-EQUIV="expires" CONTENT="0">
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<TITLE></TITLE>
</HEAD>

<BODY onClick="setMenuState('<%=Util.URL_BASE_JSP%>')">

<table>
<tr><td>

<menu:MxMenu id="MENU_PARMGR_ACTIONS" urlBase="<%=Util.URL_BASE%>">
   <menuitems>
<%

   String pageID = parsession.getPageID();
   String visibleMenuitems = parmgrMenuResources.getString(pageID);
   int implicitPartitionID = parsession.getImplicitPartitionID();
   int implicitCellID = parsession.getImplicitCellID();
   int implicitChassisID = parsession.getImplicitChassisID();
   Menu currentMenu = new Menu(selectedCheckboxes, pageID, implicitPartitionID,
                               implicitCellID, implicitChassisID, discovery);
   int [] menuitemCategoryStates = currentMenu.getMenuitemCategoryStates();

   String currentCascade = "";
   String currentMenuitem = "";
   String menuCascadeLabel = "";
   String menuitemLabel = "";
   String menuitemTitle = "";
   String targetUrlLocation = "";
   boolean openMenuCascade;
   boolean disableMenuitem;
   int menuitemCategory;
   int menuitemCategoryState;

   StringTokenizer menuitemList = new StringTokenizer(visibleMenuitems, ",");
   while (menuitemList.hasMoreTokens()) {
      currentMenuitem = menuitemList.nextToken();
      if (currentMenuitem.endsWith("ACTIONS")) {
         /* The current item in the list is a menu cascade. */
         if (!currentCascade.equals("")) {
            /* This is not the first menu cascade so close the
             * previous cascade.
             */
%>

   </cascade>

<%
         }

         currentCascade = currentMenuitem;
         openMenuCascade = openMenuCascades.containsKey(currentCascade);
         menuCascadeLabel = parmgrMenuResources.getString("cascade.label." + currentCascade);
%>

   <cascade id="<%=currentCascade%>" open="<%=openMenuCascade%>" >
      <label><%=menuCascadeLabel%></label>

<%
      } /* end menu cascade handling */ else {
         /* The current item in the list is a menu item, not a cascade. */
         menuitemCategory = Integer.parseInt(parmgrMenuResources.getString("menuitem.category." + currentMenuitem));
         menuitemCategoryState = menuitemCategoryStates[menuitemCategory];
         menuitemLabel = parmgrMenuResources.getString("menuitem.label." + currentMenuitem);
         String menuitemUrl = parmgrMenuResources.getString("menuitem.url." + currentMenuitem);
         disableMenuitem = (menuitemCategoryState > 0);
         menuitemTitle = parmgrMenuResources.getString("menuitem.title." + menuitemCategoryState + "." + currentMenuitem);
         targetUrlLocation = parmgrMenuResources.getString("menuitem.target." + currentMenuitem);

%>

      <menuitem disabled="<%=disableMenuitem%>" target="<%=targetUrlLocation%>" >
         <label><%=menuitemLabel%></label>
         <url><%=menuitemUrl%></url>
         <title><%=menuitemTitle%></title>
      </menuitem>
<%
      } /* end menu item handling */
   } /* end menuitemList while-loop */

   boolean openHelpMenuCascade = openMenuCascades.containsKey("HELP_ACTIONS");
   String helpURL = parsession.getHelpURL();
   String helpOverviewURL = parsession.getHelpURL("overview");
   String helpAboutURL = parsession.getHelpURL("about");
%>

   </cascade>
   <cascade id="HELP_ACTIONS" open="<%=openHelpMenuCascade%>">
      <label><i18n:message key="cascade.label.HELP_ACTIONS" bundle="<%=parmgrMenuResources%>" /></label>
      <menuitem target="helpWindow">
         <label><i18n:message key="menuitem.label.helpCurrentView" bundle="<%=parmgrMenuResources%>" /></label>
         <url><%=helpURL%></url>
         <title><i18n:message key="menuitem.title.0.helpCurrentView" bundle="<%=parmgrMenuResources%>" /></title>
      </menuitem>
      <menuitem target="helpWindow">
         <label><i18n:message key="menuitem.label.helpOverview" bundle="<%=parmgrMenuResources%>" /></label>
         <url><%=helpOverviewURL%></url>
         <title><i18n:message key="menuitem.title.0.helpOverview" bundle="<%=parmgrMenuResources%>" /></title>
      </menuitem>
      <menuitem target="helpWindow">
         <label><i18n:message key="menuitem.label.helpAbout" bundle="<%=parmgrMenuResources%>" /></label>
         <url><%=helpAboutURL%></url>
         <title><i18n:message key="menuitem.title.0.helpAbout" bundle="<%=parmgrMenuResources%>" /></title>
      </menuitem>
   </cascade>
   </menuitems>
</menu:MxMenu>

</td>
</tr>

<tr><td><hr class="separator"></td></tr>

<tr><td>
<table border=0 cellpadding=0 cellspacing=0>
<tr>
<td class="prop-table-caption" colspan=2>
<% if (selectedCheckboxes.getNumSelectedObjects() > 0) { %>

    <font size=-2>
    <a href="selected_objects.jsp" class="link" target="_parent"><i18n:message key="selectedItemsTable.caption" bundle="<%=parmgrMenuResources%>" /></a>
    </font>
<% } else { %>
    <i18n:message key="selectedItemsTable.caption" bundle="<%=parmgrMenuResources%>" />
<% } %>
</td>
</tr>
<tr>
<td class="prop-table-header"><i18n:message key="selectedItemsTable.partitions.label" bundle="<%=parmgrMenuResources%>" /></td>
<td class="prop-table-data"><%=selectedCheckboxes.getNumSelectedPartitions()%></td>
</tr>
<tr>
<td class="prop-table-header"><i18n:message key="selectedItemsTable.cells.label" bundle="<%=parmgrMenuResources%>" /></td>
<td class="prop-table-data"><%=selectedCheckboxes.getNumSelectedCells()%></td>
</tr>
<tr>
<td class="prop-table-header"><i18n:message key="selectedItemsTable.chassis.label" bundle="<%=parmgrMenuResources%>" /></td>
<td class="prop-table-data">
<%=selectedCheckboxes.getNumSelectedChassis()%>
</td>
</tr>
<tr>
<td class="prop-table-header"><i18n:message key="selectedItemsTable.ioslots.label" bundle="<%=parmgrMenuResources%>" /></td>
<td class="prop-table-data"><%=selectedCheckboxes.getNumSelectedIOSlots()%></td>
</tr>
</table>
</td>
</tr>

<%
        String deselectCheckboxesLabel = parmgrMenuResources.getString("button.label.deselectCheckboxes");
%>

<tr>
<td><input class="button" type="button" value="<%=deselectCheckboxesLabel%>"
    onClick="deselectAllCheckboxes('<%=Util.URL_BASE_IMAGES%>','<%=Util.URL_BASE_JSP%>')" /></td>
</tr>

<tr><td><hr class="separator"></td></tr>

<tr><td>
    <%@ include file="legend.jsp" %>
</td></tr>

</table>

<%-- Hidden iframe to preserve the state of the menu cascades. --%>

<iframe name="FRAME_PARMGR_MENU_STATE" id="FRAME_PARMGR_MENU_STATE"
    frameborder="0" height="0" width="0"
    src="menu_state.jsp?state=<%=parsession.getMenuCascadeState()%>">
</iframe>

</BODY>
</HTML>
