<%--
/**
 * The JSP page for the modify npar task.
 *
 * @version $Header: /usr/local/vse/parmgr/src/web/jsp/modify_npar.jsp,v 1.57 2008/03/05 12:55:58 sridharav Exp $
 * @risk Medium
 *
 * @task name = modify npar
 *       cycle = 4
 *       phase = Test
 *       owner = Ming
 *       status = done
 *       description = modify a hardware partition.
 */
--%>

<%@ page errorPage="exception.jsp" %>
<%@ page import="com.hp.parmgr.util.*,
                 com.hp.parmgr.model.*,
                 com.hp.parmgr.ui.*,
                 java.util.*,
                 java.text.MessageFormat" %>
<%@ page import="com.hp.parmgr.ui.tags.Util" %>
<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page pageEncoding="UTF-8"%>

<%@ taglib uri="/com/hp/parmgr/ui/tags/parmgr" prefix="parmgr" %>
<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>
<%@ taglib uri="/com/hp/mx/taglibs/MxTabsTag" prefix="tabs" %>

<i18n:bundle baseName="com.hp.parmgr.ui.tags.tags" id="parmgrTagResources" />
<i18n:bundle baseName="com.hp.parmgr.ui.CellView" id="cellResources" />
<i18n:bundle baseName="com.hp.parmgr.ui.CreateModifyNpar" id="bundle"/>
<i18n:bundle baseName="com.hp.parmgr.ui.Parmgr" id="parmgrResources"/>

<%@ include file="session_init.jsp" %>
<jsp:useBean id="parConfig" scope="session" class="com.hp.parmgr.util.HWPartitionBean" />
<jsp:useBean id="oldPar" scope="session" class="com.hp.parmgr.util.HWPartitionBean" />

<HTML>
<HEAD>
   <META http-equiv="Content-Type" content="text/html;charset=UTF-8">
   <%@ include file="session_keep_alive.jsp" %>
    <link type="text/css" rel="stylesheet" href="<%=Util.URL_PARMGR_CSS%>">
    <link type="text/css" rel="stylesheet" href="<%=Util.URL_BASE_CSS + "/create_npar.css"%>">
    <link type="text/css" rel="stylesheet" href="<%=Util.URL_MXTABLE_CSS%>">
    <link type="text/css" rel="stylesheet" href="<%=Util.URL_HARDWARE_CSS%>">
    <tabs:MxTabs dumpHeadContent="true" urlBase="<%=Util.URL_BASE%>"/>
    <script type='text/javascript' language='JavaScript'
            src='<%=Util.URL_PARMGR_JS%>'></script>
<%=SessionTimeOut.javascript(session, bundle.getLocale())%>
    <%@ include file="cm_npar_scripts.jsp" %>

    <title>
        <i18n:message bundle="<%=bundle%>" key="modify.npar.title"/>
    </title>
</HEAD>

<%
    boolean exitTask = false;

    // This value is the toggle for create npar task or modify npar task.
    String formAction="modify_npar.jsp";

    int currentForm = HWPartitionBean.SET_NAME;

    int parID = -1;

    boolean taskCancel = false;
    boolean taskDone = false;
    boolean hasErr = false;
    boolean showPowerOrWaitDialog = false;
    boolean goToWait = false;
    boolean displaySuccess = false;
    boolean errorCells = false;

    HWPartitionModifyTask parModify = null;
    String confirmMessage = new String();
    String message = new String();
    String changeSummary;
    HWPartition oldPartition = null;

    // used to hold the selected cells if the user came from assign/unassign.
    SelectionManager selectedCells = null;

    Discovery discovery = parsession.getDiscovery();

    // Do this after getting discovery
    if (!parsession.userAuthorizedToMakeChanges("parmodify")) {
        throw new UnauthorizedUserException(parsession.getFromURL(), parsession.getLocale());
    }

    Object [] args = { discovery.getComplex().getName() };
    MessageFormat format = new MessageFormat(parmgrResources.getString("complexName.fmt"));
    String complexName = format.format(args);

    // used to get the Partition ID.
    SelectionManager selectedCheckboxes = parsession.getSelectedCheckboxes();

    // get the button values. Only one of these button vaules should be
    // present at any given time.
    String cancelButton = request.getParameter("cancel");
    String cancelFinishButton = request.getParameter("cancelFinish");
    String okButton = request.getParameter("okModify");
    String finishButton = request.getParameter("finish");
    String cellCompatibilityButton = request.getParameter("cellCompatibility");
    String powerOrWaitButton = request.getParameter("powerOrWait");
    String noPowerOrWaitButton = request.getParameter("noPowerOrWait");
    // JAGaf88550: guard against cross site scripting vulnerabilities,
    // by encoding parameters that may be output to the HTML stream:
    String okErrorCells =
        StringFormatUtil.encodeHtmlEntities(request.getParameter("okErrorCells"));
    String stepNumber =
        StringFormatUtil.encodeHtmlEntities(request.getParameter("stepNumber"));

    if (stepNumber != null){
        // We came from another tab
        currentForm = Integer.parseInt(stepNumber);
        parID = parConfig.getPartition().getID();
        oldPartition = discovery.getPartition(parID);
    } else {
        // We are just coming into modify partition and haven't done
        // anything yet - get everything initialized.

        // First, check to see if a pending profile currently exists.
        // Raise the checkPending flag to ensure that Discovery is
        // accessed.
        parsession.setCheckPending(true);

        // In case we came in from the CLI, set the run ACH flag
        // to false so that when we leave modify, we don't automatically
        // run ACH.
        parsession.setRunACH(false);
%>

<%@ include file="check_pending_profile.jsp" %>

<%
        // get the user selected cells from assign/unassign if there are any.
        selectedCells = (SelectionManager) session.getAttribute("selectedCells");
        session.removeAttribute("selectedCells");

        // Get the partition ID.  Try in order:
        // 1. nparID parameter on the request.
        //    This should override any selection, since it could be
        //    directly invoked by the user or SCM putting
        //    the parameter on the URL line.
        // 2. Implicit parID (if already in a partition scope)
        // 3. Selection manager for explicitly selected npar
        String parIDStr = (String) request.getParameter("nparID");
        if( parIDStr != null ) {
            // use the value on the request
            parID = Integer.parseInt(parIDStr);
        } else {
            // nothing on the request, try the implicit par ID
            parID = parsession.getImplicitPartitionID();
            if (parID < 0) {
                // Nothing implicit, try an explicitly selected npar
                TreeSet parIDs =  selectedCheckboxes.getSelectedPartitions();
                if (!parIDs.isEmpty()){
                    if (parIDs.size() > 1) {
                        message = bundle.getString("modify.tooManyPartitionsSelected.err");
                        Log.error("Select only one nPartition to modify.");
                    } else {
                        parID = ((Integer) parIDs.first()).intValue();
                    }
                } else {
                    // nothing selected anywhere, look for a local partition
                    List allPartitions = discovery.getPartitions();
                    for (Iterator iter = allPartitions.iterator(); iter.hasNext();) {
                        HWPartition somePartition = (HWPartition) iter.next();
                        if (somePartition.isLocalPartition()) {
                            parID = somePartition.getID();
                            break;
                        }
                    }
                    if (parID < 0) {
                        // no specified partition, no selected partition, no local partition....error
                        message = bundle.getString("modify.noPartitionSelected.err");
                        Log.error("Select an nPartition to modify.");
                    }
                }
            }
        }

        // Ensure the nparID is valid.  If it came in on the request,
        // it could've been mistyped by the user.  If not, it could
        // be based on old data.
        if (!discovery.partitionExists(parID)) {
            // Partition does not exist.
            message = bundle.getString("modify.noSuchPartition.err");
            Log.error("The selected partition does not exist.");
            exitTask = true;
        } else {
            discovery.clearCachedPartition(parID);
            oldPartition = discovery.getPartition(parID);

            if (oldPartition.isErrorObject()) {
                // there was an error reading the profile
                message = bundle.getString("modify.errReadingPartition.err");
                Log.error("Cannot read the Partition Configuration Data (PCD) for the selected nPartition.");
            }
        } /* end else for stmt  if (!discovery.partitionExists(parID)) */
    } /* end else for stmt  if( stepnumber != null ) */

    String partitionName = "";
    if (message.length() == 0) {
        Object [] parArgs = { oldPartition.getLongLabel() };
        MessageFormat parFormat = new MessageFormat(parmgrResources.getString("partitionName.fmt"));
        partitionName = parFormat.format(parArgs);
    }

    if ((okButton                   == null) &&
        (cancelButton               == null) &&
        (cancelFinishButton         == null) &&
        (cellCompatibilityButton    == null) &&
        (powerOrWaitButton          == null) &&
        (noPowerOrWaitButton        == null) &&
        (finishButton               == null) &&
        (message.length()           == 0))
    {
        if (stepNumber == null){
            // If the stepNumber variable is not present in the request header,
            // then we assume it is the first step.

            // get the most up to date complex profile.
            discovery.clearComplexProfileCache();
            Complex complex = discovery.getComplex();

            if (complex.isErrorObject()){
                message = bundle.getString("modify.errReadingComplex.err");
            } else {

                Object [] msgArgs = { oldPartition.getLongLabel() };
                MessageFormat myFormat = new MessageFormat(bundle.getString("modifyNpar.start.log"));
                Log.summary(Log.EVENT_START, Log.RESULT_NONE,
                        myFormat.format(msgArgs));

                // set the initial page the user will see.  If the user has not
                // made any cell selections before comming into modify npar,
                // then the general page is show.  Otherwise the select cells
                // page is shown.
                if (selectedCells != null){
                    stepNumber = Integer.toString(HWPartitionBean.SELECT_CELLS);
                } else {
                    stepNumber = Integer.toString(HWPartitionBean.SET_NAME);
                }
                currentForm = Integer.parseInt(stepNumber);

                // initialize parConfig object for holding state data and add
                // bean to response header.  The current partition values will
                // be used to put initial values into the form fields.
                parConfig.reset();
                parConfig.setDiscovery(discovery, selectedCells);
                parConfig.setPartition(parID);
                parConfig.setBundle(bundle);

                // Get the URL from which the user invoked parmgr.
                parConfig.setFromURL(parsession.getFromURL());

                // make a HWPartitionBean to hold the non-changed partition data.
                oldPar.reset();
                oldPar.setDiscovery(discovery, null);
                oldPar.setPartition(parID);
            }
        } else {
            // the user clicked on a tab.  The current form and step number
            // are for the tab the user is *leaving*.
            parConfig.updateState(currentForm, request);

            // Make sure the user hasn't selected any error cells to add to the
            // partition (they can delete them and modify them, but not add
            // them).

            if (currentForm == HWPartitionBean.SELECT_CELLS) {

                // If okErrorCells is not null, we are coming back from the
                // dialog that tells the user that there are error cells.  In
                // that case, we are sending the user back to the cell
                // selection form and we don't want to check for new error
                // cells again.
                if (okErrorCells == null) {
                    message = parConfig.checkForNewErrorCells();
                    if (message.length() > 0) {
                        // log the error
                        Log.error(bundle.getString("errorCells.error.log"));
                        errorCells = true;
                    }
                }

                // validate cell selection since we are storing the user
                // selections.
                if (!errorCells) {
                    message = parConfig.validateCellSelection();
                    if (parConfig.isPoweredOffCells() ||
                        parConfig.isSelfTestCells() ||
                        parConfig.isPoweredOffChassis()) {
                        showPowerOrWaitDialog = true;
                    }
                }
            }
        }
    } else if (okButton != null) {
        parConfig.updateState(currentForm, request);

        message = parConfig.checkForNewErrorCells();
        if (message.length() > 0) {
            // log the error
            Log.error(bundle.getString("errorCells.error.log"));
            errorCells = true;
        }

        // validate cell selection since we are storing the user selections.
        if (!errorCells && currentForm == HWPartitionBean.SELECT_CELLS){
            message = parConfig.validateCellSelection();
            if (parConfig.isPoweredOffCells() ||
                parConfig.isSelfTestCells() ||
                parConfig.isPoweredOffChassis()) {
                showPowerOrWaitDialog = true;
            }
        }

        if (message.length() == 0) {
            // No errors yet, so do one last check.  We do this only when the
            // user tries to finish the modify task.  If they are on the
            // cell options page and try to change tabs or finish with the core
            // cell choices in a weird state, a java script function catches that.
            // Here, we catch the case where they have done something like
            // delete a cell that was a core cell choice, but they have not
            // gone to the cell options page before trying to finalize their
            // changes to the partition.
            message = parConfig.validateCoreCellChoices();
        }

        // when the user clicked ok, only move on if there is no error message
        // from validation scripts.
        if (message.length() == 0){
            parModify = new HWPartitionModifyTask(oldPar, parConfig,
                                            parsession.getLoginCredentials());
            changeSummary = parModify.getChanges();
            if (changeSummary.length() == 0){
                // the user didn't make any changes.
                message = bundle.getString("modify.noChanges.error");
            } else {
                // no errors, let the user go on to the finish page.
                parConfig.setParmodifyCmd(parModify);
                currentForm = HWPartitionBean.FINISH_NOTES;
            }
        } else {
            // there is an error on the user input.  Don't let
            // them leave the screen unless they fix the problem.
        }
    } else if (cancelFinishButton != null) {
        // get the form the user last viewed when they were on the make changes
        // page.
        currentForm = parConfig.getPrevChangePage();
    } else if (cancelButton != null) {
        // log that the user canceled.

        // return to from URL.
        taskCancel = true;
    } else if (powerOrWaitButton != null){
        if (parConfig.isPoweredOffCells()){
            // if there are powered off cells, power on the cells and then wait.
            try {
                parConfig.powerOnCells(parsession.getLoginCredentials());

                // set up the wait for dialog.
                parConfig.setUpWait(parsession, false);
                message = bundle.getString("powerOnCells.success.str");
                displaySuccess = true;
                goToWait = true;
            } catch (CommandIOException ioe) {
                Object [] ioeArgs = {ioe.getMessage()};
                MessageFormat ioeFormat =
                    new MessageFormat(parmgrResources.getString("error.ioError.format"));
                message = ioeFormat.format(ioeArgs);
                hasErr = true;
            } catch (CommandFailedException ce) {
                message = ce.getMessage();
                hasErr = true;
            }

            currentForm = HWPartitionBean.SELECT_CELLS;

        } else if (parConfig.isSelfTestCells()){
            // if there are cells are in selftest, wait for these cells to
            // complete the power-on sequence.
            parConfig.setUpWait(parsession, false);
            goToWait = true;
        } else if (parConfig.isPoweredOffChassis()){
            // if there are powered off chassis, power on the chassis and continue.
            try {
                parConfig.powerOnChassis(parsession.getLoginCredentials());
                displaySuccess = true;
                message = bundle.getString("powerOnChassis.success.str");
            } catch (CommandIOException ioe) {
                Object [] ioeArgs = {ioe.getMessage()};
                MessageFormat ioeFormat =
                    new MessageFormat(parmgrResources.getString("error.ioError.format"));
                message = ioeFormat.format(ioeArgs);
                hasErr = true;
            } catch (CommandFailedException ce) {
                message = ce.getMessage();
                hasErr = true;
            }

            // doesn't matter if we succeeded at powering on the chassis or not,
            // we are going on to the finish page.
            currentForm = HWPartitionBean.FINISH_NOTES;
        }
    } else if (noPowerOrWaitButton != null){
        // the user has decided not to power on cells/chassis, or wait for
        // cells to finish self test.

        if (parConfig.isPoweredOffCells() || parConfig.isSelfTestCells()){
            // if it's cells, then put the user back into the select cells page
            // so they can deselect the cells.
            currentForm = HWPartitionBean.SELECT_CELLS;
        } else if (parConfig.isPoweredOffChassis()){
            // if it's chassis, then continue to next page.
            currentForm = HWPartitionBean.FINISH_NOTES;
        }
    } else if (cellCompatibilityButton != null) {
        // We just came back from the power on cells dialog
        parConfig.refreshCells();
    } else if (finishButton != null){

        parConfig.updateState(currentForm, request);

        // user has finished making changes, and we are ready to modify the
        // partition.
        // Execute parmodify with options.
        // put up pop up msg to show command results.
        // return to partition.
        parModify = parConfig.getParmodifyCmd();

        hasErr = true;
            try {
                parModify.run();
                hasErr = false;
                taskDone = true;

                selectedCheckboxes.deselectAllCheckboxes();
                discovery.clearCache();

                // Give the service processor a chance to push out the
                // pending profile.
                WaitForProfile.waitFixedTime(discovery);

                // Reset the check pending flag so that if the service
                // processor did not complete pushing out the pending
                // profile, we warn the user that it is still out there.
                parsession.setCheckPending(true);

                if (parModify.getUserRemovedActiveCells()){
                    confirmMessage = bundle.getString("modify.shutDown.confirm");
                    Log.detail("The nPartition will need to be shut down for reconfiguration in order for the changes to take effect. Until the shutdown for reconfiguration has completed, the Stable Complex Configuration Data (SCCD) will not be updated (the service processor waits until the nPartition has been shut down for reconfiguration).");
                    Log.summary(Log.EVENT_DONE, Log.RESULT_SUCCESS,
                            bundle.getString("modifyNpar.end.success.log"));
                } else {
                    Log.summary(Log.EVENT_DONE, Log.RESULT_SUCCESS,
                            bundle.getString("modifyNpar.end.success.log"));
                }
            } catch (CommandIOException ioe) {
                Object [] ioeArgs = {ioe.getMessage()};
                MessageFormat ioeFormat =
                    new MessageFormat(parmgrResources.getString("error.ioError.format"));
                message = ioeFormat.format(ioeArgs);
                currentForm = parConfig.getPrevFinishPage();
            } catch (CommandFailedException ce) {
                message = ce.getMessage();
                currentForm = parConfig.getPrevFinishPage();
            }

            if (hasErr){
                Log.summary(Log.EVENT_DONE, Log.RESULT_FAILURE,
                    bundle.getString("modifyNpar.end.failure.log"));
            }
        }

%>

<% if (taskCancel) {

    String gotoURL = parConfig.getFromURL();
    if (gotoURL == null) {
        // The user came from the CLI
        gotoURL = "complex.jsp?selection=HARDWARE";
    }
%>
<BODY onLoad="window.location.replace('<%=gotoURL%>');">
</BODY>
</HTML>

<% } else if (taskDone) { %>

<BODY onLoad="window.location.replace('<%=parConfig.getToURL()%>');">
</BODY>
</HTML>

<% } else if (displaySuccess) { %>
<BODY>

    <p>
    <%=message%>
    </p>

    <form action='modify_npar.jsp' method='post'>

    <input type='hidden' name='stepNumber' value='<%=currentForm%>' />

<%      if (goToWait) { %>
    <input type='button' class='button' name='ok'
           value='<%=bundle.getString("button.ok.str")%>'
           onClick='window.location.replace("wait.jsp")'
    />
<%      } else { %>
    <input type='submit' class='button' name='cellCompatibility'
           value='<%=bundle.getString("button.ok.str")%>'
    />

<%      } %>

    </form>

</BODY>
</HTML>

<% } else if (goToWait) { %>

<BODY onLoad='window.location.replace("wait.jsp")' >
</BODY>
</HTML>


<% } else if (hasErr) { %>
    <BODY>
    <form action='modify_npar.jsp' method='post'>

    <%TaskUtil.displayError(message, parConfig.getErrBundle(), out); %>

    <input type='submit' class='button' name='okErr'
           value='<%=bundle.getString("button.ok.str")%>'
    />
    <input type='hidden' name='stepNumber'
           value='<%=currentForm%>'
    />

    </form>
    </BODY>
    </HTML>

<% } else if (errorCells) { %>
    <BODY>
    <form action='modify_npar.jsp' method='post'>

    <p>
    <%=message%>
    </p>

    <input type='submit' class='button' name='okErrorCells'
           value='<%=bundle.getString("button.ok.str")%>'
    />
    <input type='hidden' name='stepNumber'
           value='<%=currentForm%>'
    />
    <input type="hidden" name="selectedCells"
           value="<%=parConfig.getSelectedCellsList()%>"
    />

    </form>
    </BODY>
    </HTML>
<% } else if (showPowerOrWaitDialog){
    // print confirmation for powering on cells/chassis or wait for cells in
    // self test.
%>
<BODY>

    <p>
    <%=message%>
    </p>

    <form action='modify_npar.jsp' method='post'>

    <input type='submit' class='button' name='powerOrWait'
           value='<%=bundle.getString("button.ok.str")%>'
    />

    <input type='submit' class='button' name='noPowerOrWait'
           value='<%=bundle.getString("button.cancel.str")%>'
    />

    </form>

</BODY>
</HTML>

<% } else {
    String gotoURL = parConfig.getFromURL();
    if (gotoURL == null) {
        // The user came from the CLI
        gotoURL = "complex.jsp";
    }
%>

<BODY onload="displayErr(<%=exitTask%>, '<%=gotoURL%>');" >


    <TABLE border="0" cellpadding="0" cellspacing=5 width="100%">
        <TR>
            <TD width="100%" valign="top">
            <% String pageID = "";
               String okButtonName;
               String okButtonValue;
               if (HWPartitionBean.FINISH > currentForm) {
                  pageID = "modifyNParChange";
                  okButtonName = "okModify";
                  okButtonValue = bundle.getString("button.ok.str");
            %>
                  <%@ include file="modify_npar_make_changes.jsp" %>
            <% } else {
                  pageID = "modifyNParFinish";
                  okButtonName = "finish";
                  okButtonValue = bundle.getString("button.finish.str");
            %>
                  <%@ include file="modify_npar_finish.jsp" %>
            <% } %>
            </TD>
        </TR>

        <TR>
            <TD width="100%" colspan="2">
            <HR class="separator">
            <TABLE border="0">
                <TR>
                    <TD>
                    <INPUT class="button" type="submit"
                           value='<%=okButtonValue%>'
                           name='<%=okButtonName%>'
                    />
                    </TD>

                    <TD>
<%
    if (currentForm >= HWPartitionBean.FINISH){
        // this cancel puts the user back at the make changes dialog.
%>
                    <INPUT class="button" type="submit"
                           name="cancelFinish"
                           value='<%=bundle.getString("button.cancel.str")%>'
                    />
<%
    } else {
        // this cancel will cancel out of the modify npar dialog.
%>
                    <INPUT class="button" type="submit"
                           value='<%=bundle.getString("button.cancel.str")%>'
                           onClick="setDoNotValidate();"
                           name="cancel"
                    />
<% } %>
                    </TD>
                    <TD>
                    <INPUT class="button" type="button"
                           value='<%=bundle.getString("button.help.str")%>'
                           name="help"
                           onclick="showHelp(
                                    '<%=parsession.getHelpURL(pageID)%>')"
                    />
                    </TD>
                </TR>
            </TABLE>
            <table class="item-list" width="100%">
                    <!--<td class="item-list-row-align-left-last-row">-->
                <tr>
                    <td>
<%
    if (currentForm >= HWPartitionBean.FINISH) {
        // Put the command below the buttons
        String buttonNameString = "["+bundle.getString("button.finish.str")+"]:";
%>

<%
        if (parModify.getUserAddedCells() ||
            parModify.getUserRemovedActiveCells())
        {
%>
<p class="parmgr-regular-text">
<br>
&nbsp;<b><%=bundle.getString("modify.seeInstructions.label")%></b>
</p>

<%
        }
%>
<p class="parmgr-regular-text">
&nbsp;<%=parmgrResources.getString("commandPreview")%><br>
    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
    <%=buttonNameString%>&nbsp;<code><%=parModify.getCommand()%></code>
</p>
<%
    }
%>
                    </td>
               </tr>
               </table>

            </TD>
        </TR>
    </TABLE>

<input type="hidden" id="errorMsg" value="<%=message%>">

</FORM>

</BODY>
</HTML>

<% } %>
