<%--
/**
 * The JSP page for displaying any notes and/or warnings in the finish page of
 * the modify npar wizard. This pages is included by modify_npar_finish.jsp.
 *
 * @version $Header: /usr/local/vse/parmgr/src/web/jsp/modify_npar_notes.jsp,v 1.17 2007/04/20 20:29:01 scheetz Exp $
 * @risk Medium
 *
 * @task name = modify npar: notes and warnings
 *	cycle = 4
 *	phase = TEST
 *	owner = Ming
 *	status = DONE
 *	description = none.
 */
--%>
<input type="hidden" name="stepNumber"
       value="<%=HWPartitionBean.FINISH_NOTES%>">

<%
parConfig.setPrevFinishPage(HWPartitionBean.FINISH_NOTES);
%>

<p class="parmgr-regular-text">

<% if (noNotesWarnings) {
    Log.note("There are no general notes or warnings about the changes made to the nPartition.");
%>
    <i18n:message key="modify.notes.none.string" bundle="<%=bundle%>"/>
<% } else { %>

<% if (parModify.getUserRemovedActiveCells()) {

Log.note("<b>The nPartition must be shut down for reconfiguration</b>. <br> One or more active cells have been selected for removal from the nPartition. The sequence of steps that must take place is:");
Log.note("1. Choose whether or not the nPartition should be automatically booted. Set the toggle below to have the nPartition automatically booted by the service processor after the changes have been made to the Complex Profile.");
Log.note("2. Click [Finish] on this screen.");
Log.note("3. A message will be displayed identifying the need to do a shutdown for reconfiguration of the local nPartition. <br><ul><li>If <strong>HP-UX</strong> is running on this nPartition, then be sure to use the <strong>'-R -H'</strong> options with the shutdown(1M) or reboot(1M) command.</li><li>If <strong>virtual partitions</strong> are running on this nPartition, then all vPars and the monitor itself must first be shut down using the procedure described in the vPar documentation.</li><li>If <strong>Windows</strong> is running on this nPartition, then do a normal shutdown. </li> <li> If <strong>Linux</strong> is running on this nPartition, then be sure to use the <strong>'-r'</strong> or <strong>'-h'</strong> option with the shutdown(8) command.</li></ul>");
Log.note("4. Wait for the cells in this nPartition to begin their power-on self-test (POST) process. Use the Virtual Front Panel (VFP) from the service processor&#39;s console to determine when this occurs. Once the cells have begun POST the service processor will update the Complex Profile to reflect the changes to this nPartition.");
Log.note("5. If the toggle below was not set then go to the service processor&#39;s Command Menu and use the \"BO\" command to boot the nPartition. (If the toggle below was set then the service processor automatically boots the nPartition.)");

%>
<table class="item-list" width="100%">
<th>
    <tr>
    <td class="item-list-header-row">
        <i18n:message key="modify.notes.nextSteps.header" bundle="<%=bundle%>"/>
    </td>
</tr> </th>
<tbody>

    <tr>
    <td class="item-list-row-align-left">
        <i18n:message key="modify.notes.removeActiveCell.warning" bundle="<%=bundle%>"/>
<br><br>
<i18n:message key="modify.notes.removeActiveCell.option1" bundle="<%=bundle%>"/>
<ol>
<li>
<i18n:message key="modify.notes.removeActiveCell.step1" bundle="<%=bundle%>"/>
</li>
<li>
<i18n:message key="modify.notes.removeActiveCell.step2" bundle="<%=bundle%>"/>
</li>
<li>
<i18n:message key="modify.notes.removeActiveCell.step3" bundle="<%=bundle%>"/>
</li>
<li>
<i18n:message key="modify.notes.removeActiveCell.step4" bundle="<%=bundle%>"/>
</li>
<li>
<i18n:message key="modify.notes.removeActiveCell.step5" bundle="<%=bundle%>"/>
</li>
</ol>
<i18n:message key="modify.notes.removeActiveCell.option2" bundle="<%=bundle%>"/>
<ol>
<li>
<i18n:message key="modify.notes.removeActiveCell.step1.option2" bundle="<%=bundle%>"/>
</li>
<li>
<i18n:message key="modify.notes.removeActiveCell.step2.option2" bundle="<%=bundle%>"/>
</li>
<li>
<i18n:message key="modify.notes.removeActiveCell.step3.option2" bundle="<%=bundle%>"/>
</li>
</ol>
    </td>
    </tr>

</tbody>
</table>
    <input type='checkbox'
           name='autoboot_on'
           value='true'
       onclick='this.form.submit()'
           <%=parConfig.getBootToBch() ? "checked" : "" %>
    />
    <i18n:message key="modify.AutomaticallyBoot.label" bundle="<%=bundle%>"/>
<% } /* end if user removed active cell */

  else {
    boolean activePartition =
       (discovery.getPartitionStatus(parID) == NParComponent.ACTIVE);
    if (!activePartition &&
        (parModify.getUserAddedCells() || parModify.getUserRemovedCells())) {
%>
<table class="item-list" width="100%">
<th>
    <tr>
        <td class="item-list-header-row">
            <i18n:message key="modify.notes.nextSteps.header" bundle="<%=bundle%>"/>
        </td>
</tr> </th>
<tbody>
    <tr>
        <td class="item-list-row-align-left">
            <i18n:message key="modify.notes.inactivePartitionAddRemoveCell.note" bundle="<%=bundle%>"/>
        </td>
    </tr>
</tbody>
</table>
    <input type='checkbox'
           name='autoboot_on'
           value='true'
           onclick='this.form.submit()'
           <%=parConfig.getBootToBch() ? "checked" : "" %>
    />
    <i18n:message key="modify.AutomaticallyBoot.label" bundle="<%=bundle%>"/>
<%  }

    else if (activePartition && !hasWarnings &&
             parModify.getUserRemovedCells()) {
        // For the case of removing inactive cell in active partition
        Log.note("There are no general notes or warnings about the changes made to the nPartition.");
%>
            <i18n:message key="modify.notes.none.string" bundle="<%=bundle%>"/>
<%  } %>
<%  } /* end else user did not remove active cell */ %>

<% if( hasWarnings
       || parModify.getUserChangedCLM()
       || (parModify.getUserAddedCells() && !parModify.getUserRemovedActiveCells()))
{
    int count = 0;

%>
<p>
<table class="item-list" width="100%">
<th>
    <tr>
    <td class="item-list-header-row">
        <i18n:message key="modify.notes.warnings.header" bundle="<%=bundle%>"/>
    </td>
</tr> </th>
<tbody>

<% if (hasWarnings) 
   {
    ++count;
    Log.note("The High Availability (HA) checks found potential opportunities for making the nPartition more highly available. Go to the 'HA Checks' tab to see the results of the HA checks.");
%>
    <tr><td class="item-list-row-align-left"></td></tr>
    <tr>
    <td class="item-list-row-align-left">
    <i18n:message key="modify.notes.HA.warning" bundle="<%=bundle%>"/>	</td>
    </tr>
<% } /* end if hasWarnings */ %>

<%  if (parModify.getUserChangedCLM()) 
    {
    if( count == 0 ) 
    {
%>
    <tr><td class="item-list-row-align-left"></td></tr>
<%  }
    ++count;
    Log.note("Changes have been made to the configuration of interleaved memory and Cell Local Memory (CLM) in the nPartition.  These changes will not go into effect until the nPartition is rebooted/restarted.");
%>
    <tr>
    <td class="item-list-row-align-left">
        <i18n:message key="modify.notes.changedCLM.warning" bundle="<%=bundle%>"/>
    </td>
    </tr>
<% } /* end if user changed clm */ %>

<% if (parModify.getUserAddedCells() && !parModify.getUserRemovedActiveCells()) 
   {
    if( count == 0 ) 
    {
%>
    <tr><td class="item-list-row-align-left"></td></tr>
<%  }
    ++count;
    Log.note("One or more cells have been selected for addition to the nPartition. These cells will not become active until a reboot for reconfiguration is performed.<br><ul><li>If <strong>HP-UX</strong> is running on the nPartition then be sure to use the <strong>'-R'</strong> option with the shutdown(1M) or reboot(1M) command.</li><li>If <strong>virtual partitions</strong> are configured on the nPartition, all vPars and the monitor itself must first be shut down using the procedure described in the vPar documentation.</li><li>If <strong>Windows</strong> is running on the nPartition then do a normal restart.</li><li> If <strong>Linux</strong> is running on this nPartition, then be sure to use the <strong>'-r'</strong> or <strong>'-h'</strong> option with the shutdown(8) command.</ul>The entire reboot for reconfiguration process can be completed whenever it is convenient.");
%>
    <tr>
    <td class="item-list-row-align-left">
    <i18n:message key="modify.notes.addCells.note" bundle="<%=bundle%>"/>
        <p>
        <i18n:message key="modify.notes.addCells.icap.note" bundle="<%=bundle%>"/>
    </td>
    </tr>
<% } /* end if user added cells */ %>

<% if (parModify.isHyperThreadingModified()) 
   {
       if( count == 0 ) 
       {  
%>
           <tr><td class="item-list-row-align-left"></td></tr>
<%     }
       ++count;
       Log.note("Hyper-Threading changes will not take affect until the nPartition is rebooted.");
%>
       <tr>
       <td class="item-list-row-align-left">
       <i18n:message key="modify.changes.hyperthreading.warning.reboot" bundle="<%=bundle%>"/>
       </td>
       </tr>
<%     if (parConfig.isHyperThreadingEnabled()) 
       {   
           Log.note("Ensure that the OS on this nPartition supports Hyper-Threading.  Problems can occur when running an OS that does not support Hyper-Threading on a nPartition that has Hyper-Threading enabled.");
%>
           <tr>
           <td class="item-list-row-align-left">
           <i18n:message key="modify.changes.hyperthreading.warning.os" bundle="<%=bundle%>"/>
           </td>
           </tr>
<%     } /* end if hyperthreading enabled */ %>
<% } /* end if hyperthreading modified */ %>

<% } /* end if haswarnings or user changed clm or added cells */ %>

</tbody>
</table>
</p>
<% } /* end else */ %>


