<%--
/**
 * This is the first jsp called in the change complex name task.
 *
 * @version $Header: /usr/local/vse/parmgr/src/web/jsp/name_complex.jsp,v 1.21 2008/03/05 12:55:58 sridharav Exp $
 * @risk Low
 *
 */
--%>

<%@ page errorPage="exception.jsp" %>
<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>
<%@ page import="com.hp.parmgr.ui.SessionTimeOut,
                 com.hp.parmgr.ui.NameComplex,
                 com.hp.parmgr.ui.UnauthorizedUserException,
                 com.hp.parmgr.ui.DialogException,
                 com.hp.parmgr.util.Log,
                 com.hp.parmgr.util.WaitForProfile,
                 com.hp.parmgr.util.StringFormatUtil,
                 com.hp.parmgr.model.Discovery,
                 java.text.MessageFormat,
                 java.util.ResourceBundle" %>
<%@ page import="com.hp.parmgr.ui.tags.Util" %>
<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page pageEncoding="UTF-8"%>

<jsp:useBean
    id="parsession"
    scope="session"
    class="com.hp.parmgr.ui.ParmgrSession" />

<i18n:bundle baseName="com.hp.parmgr.ui.tags.tags" id="tagsBundle" />
<i18n:bundle baseName="com.hp.parmgr.ui.PowerCell" id="taskBundle" />

<i18n:bundle baseName="com.hp.parmgr.ui.CreateModifyNpar" id="cmBundle" />

<%
    final String OK          = tagsBundle.getString( "Button.OK" );
    final String CANCEL      = tagsBundle.getString( "Button.Cancel" );
    final String HELP        = tagsBundle.getString( "Button.Help" );
    final String helpUrl     = parsession.getHelpURL("nameComplex");
    String returnToUrl = parsession.getFromURL();
    String title       = taskBundle.getString("complex.name.title");
    String message     = taskBundle.getString("complex.name.message");
    String inputLabel  = taskBundle.getString("complex.name.input.label");
    String complexName = parsession.getDiscovery().getComplex().getName();

    final String lengthMessage = cmBundle.getString("error.parNameMissing.message");
    final String contentMessage = cmBundle.getString("error.parName.message");

    if (complexName == null) complexName = "";

    Discovery discovery = parsession.getDiscovery();

    // Do this after getting discovery
    if (!parsession.userAuthorizedToMakeChanges("cplxmodify")) {
        throw new UnauthorizedUserException(parsession.getFromURL(), parsession.getLocale());
    }

    // JAGaf88550: guard against cross site scripting vulnerabilities,
    // by encoding parameters that may be output to the HTML stream:
    String newComplexName =
        StringFormatUtil.encodeHtmlEntities(request.getParameter("complexName"));
    if (newComplexName != null) {
        String okButton = request.getParameter("OK");

        if (okButton != null) {
            // JAGaf88550: guard against cross site scripting vulnerabilities,
            // by encoding parameters that may be output to the HTML stream:
            returnToUrl = StringFormatUtil.encodeHtmlEntities(
                request.getParameter("returnToUrl"));

            String successMsg = NameComplex.run(parsession, returnToUrl,
                                                newComplexName);

            Log.note(taskBundle.getString("complex.name.end.log"));
            parsession.getDiscovery().clearComplexProfileCache();

            // Give the service processor a chance to push out the
            // pending profile.
            WaitForProfile.waitFixedTime(discovery);

            // Reset the check pending flag so that if the service
            // processor did not complete pushing out the pending
            // profile, we warn the user that it is still out there.
            parsession.setCheckPending(true);

            DialogException de = new DialogException(successMsg, returnToUrl,
                                                "com.hp.parmgr.ui.PowerCell");
            de.setLocale(parsession.getLocale());
            de.setTitle("complex.name.success.title");
            de.setLogError(false);  // not an error, so don't log as an error
            throw de;
        }
    } else {
        discovery.clearComplexProfileCache();
        Log.note(taskBundle.getString("complex.name.start.log"));

        // First, check to see if a pending profile currently exists.
        // Raise the checkPending flag to ensure that Discovery is
        // accessed.
        parsession.setCheckPending(true);
%>

<%@ include file="check_pending_profile.jsp" %>

<html>
<head>
<META http-equiv="Content-Type" content="text/html;charset=UTF-8">
<%@ include file="session_keep_alive.jsp" %>
<link type="text/css" rel="stylesheet" href="<%=Util.URL_PARMGR_CSS%>" />
<script type='text/javascript'
        language='JavaScript'
        src='<%=Util.URL_PARMGR_JS%>' >
</script>

<%=SessionTimeOut.javascript(session, tagsBundle.getLocale())%>
<script>
var doNotValidate = false;  // for the scripts in cm_npar_set_name_scripts.jsp
</script>
<%@ include file="cm_npar_set_name_scripts.jsp" %>
<title>
<%=title%>
</title>
</head>
<body>
<p align="left" class="subwindow-heading">
<%=title%>
</p>
<p align="left">
<%=message%>
</p>

<form method="post" action="name_complex.jsp" name="nameComplexForm"
      onSubmit='return validateName(complexName.value, "<%=lengthMessage%>", "<%=contentMessage%>")' >
    <table border="0" cellpadding="10" class="parmgr-regular-text">
        <tr>
            <td>
                <font class="wizard-page-field-label">
                <%=title%>
                </font>
            </td>
            <td>
                <input type="text" size="20" maxlength="20"
                       name="complexName" value="<%=complexName%>" />
            </td>
        </tr>
    </table>

    <p align="left">
    <input class="button" type="submit" value="<%=OK%>" name="OK" />
    <input class="button" type="button" value="<%=CANCEL%>" name="CANCEL"
           onclick="window.location.replace('<%=returnToUrl%>')"/>
    <input class="button" type="button" value="<%=HELP%>" name="HELP"
           onclick="showHelp('<%=helpUrl%>')" />
    </p>
    <input type="hidden" name="returnToUrl" value="<%=returnToUrl%>" />
</form>
</body>
</html>
<% } %>


