<%@ taglib uri="/com/hp/mx/taglibs/MxTabsTag" prefix="tabs" %>
<%@ taglib uri="/com/hp/parmgr/ui/tags/parmgr" prefix="parmgr" %>
<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>

<%@ page errorPage="exception.jsp" %>
<%@ page import="com.hp.parmgr.util.Menu" %>
<%@ page import="com.hp.parmgr.util.StringFormatUtil" %>
<%@ page import="com.hp.parmgr.ui.SessionTimeOut" %>
<%@ page import="com.hp.parmgr.model.HWPartition" %>
<%@ page import="com.hp.parmgr.model.Discovery" %>
<%@ page import="com.hp.parmgr.ui.SelectionManager" %>
<%@ page import="com.hp.parmgr.ui.tags.Util" %>
<%@ page import="java.util.List" %>
<%@ page import="java.util.Iterator" %>
<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page pageEncoding="UTF-8"%>

<i18n:bundle baseName="com.hp.parmgr.ui.PartitionView" id="bundle" />
<%@ include file="session_init.jsp" %>

<HTML>
<HEAD>
<META http-equiv="Content-Type" content="text/html;charset=UTF-8">
<META HTTP-EQUIV="expires" CONTENT="0">
<meta http-equiv="Cache-Control" CONTENT="no-cache">
<meta http-equiv="Pragma" CONTENT="no-cache">
<%@ include file="session_keep_alive.jsp" %>
<tabs:MxTabs dumpHeadContent="true" urlBase="<%=Util.URL_BASE%>"/>
<i18n:bundle baseName="com.hp.parmgr.ui.tags.tags" id="parmgrTagResources" />

<%
    String AVAILABLE = "-1";

    // JAGaf88550: guard against cross site scripting vulnerabilities,
    // by encoding parameters that may be output to the HTML stream:
    String szSelected =
        StringFormatUtil.encodeHtmlEntities(request.getParameter("selection"));
    if (szSelected == null)
        szSelected = "HARDWARE";
    String fromURL="partition.jsp";

    // JAGaf88550: guard against cross site scripting vulnerabilities,
    // by encoding parameters that may be output to the HTML stream:
    String parID =
        StringFormatUtil.encodeHtmlEntities(request.getParameter("partition"));

    boolean isPartitionValid = true;


    Discovery discovery;
    HWPartition partition;
    SelectionManager selectedCheckboxes;
    discovery = parsession.getDiscovery();

    if (request.getParameter("refresh") != null) {
       /* Must clear cache before generating the HTML. */
       discovery.clearCache();
       parsession.setCheckPending(true);
    }
%>

<%@ include file="run_analyze_complex_health.jsp" %>
<%@ include file="check_pending_profile.jsp" %>

<%
    // If no parID is specified we show the local partition if there is one
    // or available resources otherwise
    if (parID == null) {
        List allPartitions = discovery.getPartitions();
        for (Iterator iter = allPartitions.iterator(); iter.hasNext();) {
            HWPartition somePartition = (HWPartition) iter.next();
            if (somePartition.isLocalPartition()) {
                parID = Integer.toString(somePartition.getID());
                break;
            }
        }
        if (parID == null) {
            parID = AVAILABLE;
        }
    }

    partition = discovery.getPartition(Integer.parseInt(parID));
    selectedCheckboxes = parsession.getSelectedCheckboxes();

    String partitionName;
    String partitionShortName = "";

    if (parID.equals(AVAILABLE)) {
        partitionName = parmgrTagResources.getString("Cell.status.available.label");
    }
    else {
      if (partition == null) {
          //Send user to an error page
          isPartitionValid = false;
          partitionName = " ";
      }
      else if (partition.isErrorObject()) {
          partitionName = partition.getLabel();
          partitionShortName = partition.getLabel();
      } else {
          partitionName = partition.getLongLabel();
          partitionShortName = partition.getName();
      }
    }

    /* The following variables indicate to the scope_header.jsp
     * that we are in the partition scope.
     */
    String currentURL = "partition.jsp";
    String cellLocation = null;
    String chassisName = null;
    boolean isCellIDPresent = false;
    boolean validChassisID = false;
%>

<script type='text/javascript' language='JavaScript' src='<%=Util.URL_PARMGR_JS%>'></script>
<%=SessionTimeOut.javascript(session, bundle.getLocale())%>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_PARMGR_CSS%>'>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_HARDWARE_CSS%>'>
<TITLE>Partition Manager - <%=partitionName%></TITLE>
</HEAD>

<BODY>

<table border=0 cellpadding=0 cellspacing=0 width="100%" height="100%">
<tr>
    <td>
        <%@ include file="scope_header.jsp" %>
    </td>
</tr>
<tr><td class=smc-filler>
<table border="0" cellpadding="0" cellspacing="0" width="100%">
<tr><td width="100%">
<tabs:MxTabs selection="<%=szSelected%>" style="boris" urlBase="<%=Util.URL_BASE%>">
    <selectors>
        <selector id="HARDWARE">
            <label><i18n:message key="tab.Hardware.label" bundle="<%=bundle%>" /></label>
            <url>
                <%=request.getRequestURI()%>?selection=HARDWARE&amp;partition=<%=parID%>
            </url>
        </selector>

<% if (! parID.equals(AVAILABLE)) { %>
        <selector id="PARTITIONS">
            <label><i18n:message key="tab.Partitions.label" bundle="<%=bundle%>" /></label>
            <url>
                <%=request.getRequestURI()%>?selection=PARTITIONS&amp;partition=<%=parID%>
            </url>
        </selector>
<% } %>

        <selector id="CELLS">
            <name>CELLS</name>
            <label><i18n:message key="tab.Cells.label" bundle="<%=bundle%>" /></label>
            <url>
                <%=request.getRequestURI()%>?selection=CELLS&amp;partition=<%=parID%>
            </url>
        </selector>

        <selector id="IO">
            <name>IO</name>
            <label><i18n:message key="tab.IO.label" bundle="<%=bundle%>" /></label>
            <url>
                <%=request.getRequestURI()%>?selection=IO&amp;partition=<%=parID%>
            </url>
        </selector>

<% if (! parID.equals(AVAILABLE)) { %>
        <selector id="GENERAL">
            <label><i18n:message key="tab.General.label" bundle="<%=bundle%>" /></label>
            <url>
                <%=request.getRequestURI()%>?selection=GENERAL&amp;partition=<%=parID%>
            </url>
        </selector>
<% } %>

    </selectors>
</tabs:MxTabs>
</td>
<%@ include file="logofflink.jsp"%>
</tr>
</table>
</td></tr>

<tr height="100%"><td bgcolor=white>

<table border=0 cellpadding=0 cellspacing=8 width="100%" height="100%">
<tr><td>
<%
  String pageID="";
  String srcJsp="";

  if (!isPartitionValid) {
    pageID = "error";
    srcJsp = "error.jsp?errorMsgID=ErrorMsg.BadPartitionNumber";
  } else if (szSelected.equals("HARDWARE")) {
    pageID = "partitionHardwareView";
    srcJsp = "partition_hardware.jsp?partition=" + parID;
  } else if (szSelected.equals("PARTITIONS")) {
    // When vPars return, we'll want to create another one of
    // these with the information below.
    // pageID = "partitionVParView";
    // srcJsp = "partition_vpars.jsp?partition=" + parID;
    pageID = "partitionPartitionView";
    srcJsp = "partition_partition.jsp?partition=" + parID;
  } else if (szSelected.equals("CELLS")) {
    pageID = "partitionCellView";
    srcJsp = "partition_cells.jsp?partition=" + parID;
  } else if (szSelected.equals("IO")) {
    pageID = "partitionIOView";
    srcJsp = "partition_io.jsp?partition=" + parID;
  } else if (szSelected.equals("GENERAL")) {
    pageID = "partitionGeneralView";
    srcJsp = "partition_general.jsp?partition=" + parID +
             "&partitionName=" + partitionShortName;
  }

  selectedCheckboxes.resetVisibleCheckboxes();
  parsession.setImplicitPartitionID(Integer.parseInt(parID));
  parsession.setImplicitCellID(Menu.INVALID_CELL_ID);
  parsession.setImplicitChassisID(Menu.INVALID_CHASSIS_ID);
  parsession.setPageID(pageID);
  parsession.setFromURL(fromURL + "?selection=" + szSelected +
                        "&partition=" + parID);

  if (!discovery.isCached()) {
      srcJsp = Util.URL_BASE_JSP + "/loading.jsp?src=" + java.net.URLEncoder.encode(srcJsp, "UTF-8");
  }

%>

  <iframe name="FRAME_PARMGR_WORKSPACE" id="FRAME_PARMGR_WORKSPACE"
        scrolling=auto frameborder=0 width="100%" height="100%"
        src="<%=srcJsp%>">
  </iframe>
  </td>

<%-- /* Note that no source is specified for the menu actions frame in
      * this JSP.  The menu src will be loaded by the workspace frame
      * when it is done loading to ensure that the workspace has
      * completed rendering before the actions menu is created.
      */
--%>

  <td width=220>
    <BR>
    <iframe name="FRAME_PARMGR_ACTIONS" id="FRAME_PARMGR_ACTIONS"
          scrolling=auto frameborder=0 width="100%" height="100%"
          src="dummy.jsp">
    </iframe>
  </td>
</tr>
</table>

</td></tr>
</table>

</BODY>
</HTML>
