<%--
/**
 * The content rendered for the partition cells page.
 *
 * @version $Header: /usr/local/vse/parmgr/src/web/jsp/partition_cells.jsp,v 1.17 2008/03/05 13:05:40 sridharav Exp $
 * @risk High
 *
 * @task name = partition cells tab
 * cycle = 4
 * phase = TEST
 * owner = Mike
 * status = Done
 * description = The cells tab in the partition scope
 */
--%>

<%@ taglib uri="/com/hp/mx/taglibs/MxTabsTag" prefix="tabs" %>
<%@ taglib uri="/com/hp/parmgr/ui/tags/parmgr" prefix="parmgr" %>
<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>

<%@ page import="java.util.List" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="java.util.ListIterator" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="com.hp.parmgr.model.Discovery" %>
<%@ page import="com.hp.parmgr.model.Complex" %>
<%@ page import="com.hp.parmgr.model.Cell" %>
<%@ page import="com.hp.parmgr.model.CellSlot" %>
<%@ page import="com.hp.parmgr.model.HWPartition" %>
<%@ page import="com.hp.parmgr.model.IOChassisSlot" %>
<%@ page import="com.hp.parmgr.ui.SelectionManager" %>
<%@ page import="com.hp.parmgr.ui.tags.PartitionBackgroundKey" %>
<%@ page import="com.hp.parmgr.ui.tags.Util" %>
<%@ page import="com.hp.npar.mof.HP_NParComplex" %>
<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page pageEncoding="UTF-8"%>

<%@ page errorPage="exception.jsp" %>

<jsp:useBean id="parsession" scope="session" class="com.hp.parmgr.ui.ParmgrSession" />

<%

    Discovery discovery = parsession.getDiscovery();
    Complex complex = discovery.getComplex();
    SelectionManager selectedCheckboxes = parsession.getSelectedCheckboxes();
    HWPartition partition = null;

    int AVAILABLE = -1;
    int parID = AVAILABLE;

    boolean isPartitionValid = true;

    // If no parID is specified we show available resources
    String parIDParam = request.getParameter("partition");
    if (parIDParam != null) {
        parID = Integer.parseInt(parIDParam);
        partition = discovery.getPartition(parID);
    }

           //
    // Fill the cache before getting into the html so that any Locked objects
    // are caught here.
    //
    discovery.getChassisSlots();
    discovery.getAllChassis();

    List cells = new ArrayList();
    List cellSlots;
    List currentPartition = new ArrayList();
    boolean showActualCLM = false;
    boolean showRequestedCLM = false;

    if (parID == AVAILABLE) {
        cellSlots = new ArrayList();
        List allSlots = discovery.getCellSlots();
        for (Iterator iter = allSlots.iterator(); iter.hasNext();)
        {
            CellSlot cellSlot = (CellSlot) iter.next();
            if (complex.getCellType(cellSlot.getGlobalID()) == Complex.FREE) {
                cellSlots.add(cellSlot);
            }
        }
    }
    else {
        if (partition == null) {
            //Send user to an error page
            isPartitionValid = false;
            cellSlots = new ArrayList();
        }
        else {
            cellSlots = discovery.getCellSlotsInPartition(parID);
            currentPartition.add(partition);
            showActualCLM = true;
            showRequestedCLM = true;
        }
    }

    double requestedClmAmount = 0; // GB

    for (Iterator iter = cellSlots.iterator(); iter.hasNext();)
    {
        CellSlot cellSlot = (CellSlot) iter.next();
        if (cellSlot.isPopulated())
        {
            int cellID = cellSlot.getGlobalID();
            Cell cell = discovery.getCell(cellID);
            if (cell != null) {
                // This could be an error cell
                cells.add(cell);

                if (showRequestedCLM) {
                    requestedClmAmount += discovery.getRequestedCLMForCellInGB(cellID);
                }
            }
        }
    }



%>

<HTML>
<HEAD>
<META http-equiv="Content-Type" content="text/html;charset=UTF-8">
<META HTTP-EQUIV="expires" CONTENT="0">
<%@ include file="session_keep_alive.jsp" %>
<i18n:bundle baseName="com.hp.parmgr.ui.ComplexView" id="bundle" />
<i18n:bundle baseName="com.hp.parmgr.ui.tags.tags" id="parmgrTagResources" />

<script type='text/javascript' language='JavaScript' src='<%=Util.URL_PARMGR_JS%>'>
</script>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_PARMGR_CSS%>'>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_HARDWARE_CSS%>'>
</HEAD>

<BODY onLoad="loadMenuFrame('<%=Util.URL_BASE_JSP%>')">

<%-- Begin overall table --%>
<table border=0 cellspacing=2 cellpadding=0>

  <%-- Begin first row in overall table --%>
  <tr>
    <td>

      <%-- Begin summary tables table --%>
      <table border="0" cellspacing="2" cellpadding="0">

        <tr>

          <%-- Cells table --%>
          <td valign="top">

             <parmgr:cellsummarytable cells="<%=cells%>"
                                      resources="<%=parmgrTagResources%>"
                                      numCellSlots="<%=cellSlots.size()%>" />

          </td>

          <%-- CPUs table --%>
          <td valign="top">
             <parmgr:cpusummarytable cells="<%=cells%>"
                                     resources="<%=parmgrTagResources%>" />
          </td>

          <%-- Memory table --%>
          <td valign="top">
           <parmgr:memorysummarytable cells="<%=cells%>"
                                      resources="<%=parmgrTagResources%>"
                                      showRequestedCLM="<%=showRequestedCLM%>"
                                      showActualCLM="<%=showActualCLM%>"
                                      requestedClmAmount=
                                                  "<%=requestedClmAmount%>"/>
          </td>
        </tr>

      </table>
      <%-- End summary tables table --%>

    </td>
  </tr>
  <%-- End second row in overall table --%>

  <tr>
    <td>
    <hr class="separator">
        <parmgr:partitionkey partitions="<%=currentPartition%>"
                             showCheckboxes="false"
                             resources="<%=parmgrTagResources%>"
                             selectedCheckboxes="<%=selectedCheckboxes%>" />
    </td>
  </tr>

  <%-- Begin third row in overall table --%>
  <tr>
    <td>

      <%-- Begin cells table --%>
      <table border=0 cellspacing="5" cellpadding="2">

<%
    int i = 0;
%>

      <tr>

<%
    for (Iterator iter = cellSlots.iterator(); iter.hasNext();)
    {

        CellSlot cellSlot = (CellSlot) iter.next();
        int cellID = cellSlot.getGlobalID();

    if (i % 4 == 0) {
           if (i > 0) {
%>

      </tr>
      <tr>

<%
           }
        }
%>

      <td valign="top">

        <%-- Begin an individual cell/chassis table --%>
        <table border=0 cellspacing="0" cellpadding="0">

    <%-- Begin cell row --%>
        <tr>
          <td align="center">
            <parmgr:cellinfo discovery="<%=discovery%>"
                             slot="<%=cellSlot%>"
                             resources="<%=parmgrTagResources%>"
                             showDimms="true"
                             showPartition="true"
                             showCPUs="true"
                             selectedCheckboxes="<%=selectedCheckboxes%>" />
          </td>
        </tr>
        <%-- End cell row --%>

<%
        if (cellSlot.isPopulated())
        {
            Cell cell = discovery.getCell(cellSlot.getGlobalID());
            if (!cell.isErrorObject() && cell.isConnectedToIOChassis())
            {
                IOChassisSlot chassisSlot = discovery.getChassisSlot(cell.getConnectedIOChassisID());

%>

            <%-- Begin cell/chassis connector row --%>
            <tr>
              <td align="center">
            <img height="20" width="12" border="0"
                 src="<%=Util.URL_BASE_IMAGES + "/cv.gif"%>" alt="connected to">
              </td>
            </tr>
            <%-- End cell/chassis connector row --%>

        <%-- Begin chassis row --%>
        <tr>
              <td align="center">

                  <parmgr:chassisinfo discovery="<%=discovery%>"
                                      slot="<%=chassisSlot%>"
                                      resources="<%=parmgrTagResources%>"
                                      showSlots="false"
                                      showPartition="true"
                                      selectedCheckboxes="<%=selectedCheckboxes%>" />

              </td>
            </tr>

<%
          }
        }
%>

    </table>
      </td>

<%
    i++;
    }
%>

    </tr>
  </table>
<%-- End cells table --%>

    </td>
  </tr>
  <%-- End second row in overall table --%>

<%-- End overall table --%>
</table>

</BODY>
</HTML>
