<%--
/**
 * The JSP page for the Hardware Big Picture View in the "Partition Scope".
 * <p>
 * This page contains the contents of the "hardware" tab in the "Partition
 * Scope".  It is nearly identical to the "hardware" tab in the "Complex
 * Scope" with the exception that all the hardware belonging to unselected
 * partitions are grayed out.
 *
 * @task name = partition hardware tab
 * cycle = 2
 * phase = code
 * owner = Chris
 * status = done
 * description = none
 *
 */
--%>

<%@ taglib uri="/com/hp/parmgr/ui/tags/parmgr" prefix="parmgr" %>
<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>

<%@ page errorPage="exception.jsp" %>

<jsp:useBean id="parsession" scope="session" class="com.hp.parmgr.ui.ParmgrSession" />

<%@ page import="java.util.List" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="com.hp.parmgr.ui.tags.Util" %>
<%@ page import="com.hp.parmgr.util.StringFormatUtil" %>
<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page pageEncoding="UTF-8"%>

<%--
 /*
  * The partitionkey taglib expects a list of partitions but in
  * this case we don't have a list.  So we'll build one and stick
  * our single partition in it.
  */
--%>

<%

    // JAGaf88550: guard against cross site scripting vulnerabilities,
    // by encoding parameters that may be output to the HTML stream:
    String parID =
        StringFormatUtil.encodeHtmlEntities(request.getParameter("partition"));

    com.hp.parmgr.model.Discovery discovery;
    com.hp.parmgr.model.HWPartition partition;
    com.hp.parmgr.ui.SelectionManager selectedCheckboxes;

    discovery = parsession.getDiscovery();


    //
    // Fill the cache before getting into the html so that any Locked objects
    // are caught here.
    //
    discovery.getCellSlots();
    discovery.getCells();
    discovery.getPartitions();
    discovery.getChassisSlots();
    discovery.getAllChassis();

    partition = discovery.getPartition(Integer.parseInt(parID));
    selectedCheckboxes = parsession.getSelectedCheckboxes();

    List currentPartition = new ArrayList();
    if (partition != null) {
       currentPartition.add(partition);
    }
%>

<HTML>
<HEAD>
<META http-equiv="Content-Type" content="text/html;charset=UTF-8"> 
<META HTTP-EQUIV="expires" CONTENT="0">
<%@ include file="session_keep_alive.jsp" %>
<script type='text/javascript' language='JavaScript' src='<%=Util.URL_PARMGR_JS%>'></script>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_PARMGR_CSS%>'>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_HARDWARE_CSS%>'>

<i18n:bundle baseName="com.hp.parmgr.ui.PartitionView" id="bundle" />
<i18n:bundle baseName="com.hp.parmgr.ui.tags.tags" id="parmgrTagResources" />
</HEAD>

<BODY onLoad="loadMenuFrame('<%=Util.URL_BASE_JSP%>')">
<table border="0" cellpadding="0" cellspacing="10">
  <tbody>
    <tr>
      <td>
        <parmgr:partitionkey partitions="<%=currentPartition%>"
                             showCheckboxes="false"
                             resources="<%=parmgrTagResources%>"
                             selectedCheckboxes="<%=selectedCheckboxes%>"/>
      </td>
    </tr>
    <tr>
      <td>
        <parmgr:cabinets discovery="<%=discovery%>"
                         resources="<%=parmgrTagResources%>"
                         parID="<%=parID%>"
                         selectedCheckboxes="<%=selectedCheckboxes%>"/>
      </td>
    </tr>
  </tbody>
</table>
</BODY>
</HTML>





