<%--
/**
 * The content rendered for the partition I/O tab.
 *
 * @task name = Implement I/O functionality for Partition Scope.
 * cycle = 4
 * owner = Paul
 * phase = TEST
 * status = Done
 * description = I/O for Partitions.
 *
 * @version $Header: /usr/local/vse/parmgr/src/web/jsp/partition_io.jsp,v 1.17 2008/03/05 13:05:40 sridharav Exp $
 * @risk: Low
 *
 */
--%>

<%@ taglib uri="/com/hp/parmgr/ui/tags/parmgr" prefix="parmgr" %>
<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>

<%@ page errorPage="exception.jsp" %>

<jsp:useBean id="parsession" scope="session" class="com.hp.parmgr.ui.ParmgrSession" />

<%@ page import="java.util.List" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="com.hp.parmgr.model.Discovery" %>
<%@ page import="com.hp.parmgr.model.HWPartition" %>
<%@ page import="com.hp.parmgr.model.IOChassisSlot" %>
<%@ page import="com.hp.parmgr.model.IOChassis" %>
<%@ page import="com.hp.parmgr.ui.SelectionManager" %>
<%@ page import="com.hp.parmgr.ui.tags.Util" %>
<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page pageEncoding="UTF-8"%>

<%--
 /*
  * The partitionkey taglib expects a list of partitions but in
  * this case we don't have a list.  So we'll build one and stick
  * our single partition in it.
  */
--%>

<%

    String parID = request.getParameter("partition");

    Discovery discovery;
    HWPartition partition;
    SelectionManager selectedCheckboxes;

    discovery = parsession.getDiscovery();
    partition = discovery.getPartition(Integer.parseInt(parID));
    selectedCheckboxes = parsession.getSelectedCheckboxes();

    /*
     * Partition is guaranteed to be valid because it's checked in
     * partition.jsp prior to loading the partition_io.jsp
     * workspace iframe.
     */
    List currentPartition = new ArrayList();
    if (partition != null) {
       currentPartition.add(partition);
    }

    List ioChassisList = new ArrayList();
    List ioChassisSlots = discovery.getChassisSlotsInPartition(Integer.parseInt(parID));
    Iterator iter = ioChassisSlots.iterator();

    while (iter.hasNext()) {
       IOChassisSlot currChassisSlot = (IOChassisSlot) iter.next();
       if (currChassisSlot.isPopulated()) {
               ioChassisList.add(discovery.getChassis(currChassisSlot));
       }
    }

%>

<HTML>
<HEAD>
<META http-equiv="Content-Type" content="text/html;charset=UTF-8">
<META HTTP-EQUIV="expires" CONTENT="0">
<%@ include file="session_keep_alive.jsp" %>
<script type='text/javascript' language='JavaScript' src='<%=Util.URL_PARMGR_JS%>'></script>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_PARMGR_CSS%>'>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_HARDWARE_CSS%>'>

<i18n:bundle baseName="com.hp.parmgr.ui.PartitionView" id="bundle" />
<i18n:bundle baseName="com.hp.parmgr.ui.Parmgr" id="parmgrProperties" />
<i18n:bundle baseName="com.hp.parmgr.ui.tags.tags" id="parmgrTagResources" />
</script>
</HEAD>

<BODY onLoad="loadMenuFrame('<%=Util.URL_BASE_JSP%>')">


<!-- begin overall table -->
<table border=0 cellpadding=0 cellspacing=10>
  <!-- begin first row in overall table -->
  <tr>
    <td class="subwindow-heading">
      <%=parmgrTagResources.getString("PartitionIOViewLabel")%>
    </td>
  </tr>
  <!-- end first row in overall table -->

  <!-- begin second row in overall table -->
  <tr>
    <td>
      <!-- begin I/O summary table -->
      <parmgr:iosummarytable ioChassisList="<%=ioChassisList%>"
                             numIOChassisSlots="<%=ioChassisSlots.size()%>"
                             resources="<%=parmgrTagResources%>"
                             showPresentAbsentChassis="false" />
      <!-- end I/O summary table -->
    </td>
  </tr>
  <!-- end second row in overall table -->

  <!-- begin third row in overall table -->
  <tr>
    <td>
      <HR class="separator">
    </td>
  </tr>
  <!-- end third row in overall table -->

  <!-- begin fourth row in overall table -->
  <tr>
    <td class="subwindow-heading">
      <%=parmgrTagResources.getString("DetailsLabel")%>
    </td>
  </tr>
  <!-- end fourth row in overall table -->

  <!-- begin fifth row in overall table -->
  <tr>
    <td>
      <!-- begin partition key -->
      <parmgr:partitionkey partitions="<%=currentPartition%>"
                           showCheckboxes="false"
                           resources="<%=parmgrTagResources%>"
                           selectedCheckboxes="<%=selectedCheckboxes%>"/>
      <!-- end partition key -->
    </td>
  </tr>
  <!-- end fifth row in overall table -->

  <!-- begin sixth row in overall table -->
  <tr>
    <td>
      <table border=0 cellspacing=0 cellpadding=5>
        <tr>

<%
  int i = 0;
  Iterator iter2 = ioChassisSlots.iterator();

  while (iter2.hasNext()) {
    IOChassisSlot currChassisSlot = (IOChassisSlot) iter2.next();

    if (i % 2 == 0) {
      if (i > 0) {
%>

        </tr>
        <tr>

<%
      }
    }
%>

    <td>
      <table border=0 cellpadding=0 cellspacing=0>
        <tr>
          <td>
            <parmgr:chassisinfo discovery="<%=discovery%>"
                                slot="<%=currChassisSlot%>"
                                resources="<%=parmgrTagResources%>"
                                showSlots="true"
                                showPartition="true"
                                selectedCheckboxes="<%=selectedCheckboxes%>" />

          </td>
          <td>

<%

    if (currChassisSlot.isPopulated()) {
        IOChassis currChassis = discovery.getChassis(currChassisSlot);
        boolean isChassisConnected;
        if (currChassis.isErrorObject()) {
            // We don't know if the chassis is connected, so don't display
            // anything
            isChassisConnected = false;
        } else {
            isChassisConnected = currChassis.isConnected();
        }

        if (isChassisConnected) {
%>

            <img height="12" width="28" src="<%=Util.URL_BASE_IMAGES + "/ch.gif"%>"
               alt='<i18n:message key="field.ChassisConnector.text" bundle="<%=parmgrProperties%>" />'>

<%      }
%>

          </td>
          <td>

<%
        if (isChassisConnected) {
%>

          <parmgr:cellinfo discovery="<%=discovery%>"
                           slot="<%=discovery.getCellSlot(currChassis.getConnectedCellID())%>"
                           resources="<%=parmgrTagResources%>"
                           showDimms="false"
                           showPartition="true"
                           showCPUs="false"
                           selectedCheckboxes="<%=selectedCheckboxes%>" />


<%      }
    }
%>

          </td>
        </tr>
      </table>
    </td>

<%
    i++;
  }
%>
  </tr>
  </table>
  </td>
  </tr>
  <!-- end sixth row in overall table -->

</table>
<!-- end overall table -->


</BODY>
</HTML>
