<%--
/**
 * This included JSP automatically runs analyze complex health, if
 * required.  The JSP forwards control to the analyze_complex_health.jsp
 * page, if we need to automatically run ACH, which will be when the
 * user first initiates a parmgr session.  This JSP determines whether
 * or not to forward control by checking the runACH flag in parsession.
 * This flag will be true if this is the first time this page has been
 * hit since the beginning of the session.  Since this page sets the
 * flag to false the first time it is hit, the flag will never be true
 * again, and ACH will never be automatically run again.
 *
 * Included by:
 *
 * cell.jsp, chassis.jsp, complex.jsp, and partition.jsp.
 *
 * With the exception of complex_details.jsp (which always displays
 * complex health), modify partition, and delete partition, these are
 * all the ways the user can get directly into parmgr (without typing
 * in a URL to somewhere else, in which case they won't automatically
 * get ACH until they go to one of the aforementioned pages).
 *
 * @version $Header: /usr/local/vse/parmgr/src/web/jsp/run_analyze_complex_health.jsp,v 1.7 2006/03/21 14:22:03 shunr Exp $
 * @risk: Low
 */
--%>

<%@ page import="com.hp.parmgr.util.StringFormatUtil" %>

<%
    if (parsession.getRunACH()) {

        // We only get here if we are starting a new parmgr session,
        // at which time we automatically run ACH.

        // We never want to automatically run ACH again.
        parsession.setRunACH(false);

        // There will never be a URL to return to, only one to go to.
        // That comes from the request.  So that ACH can determine
        // where to go to in that case, we set an attribute that it can
        // retrieve.
        //
        // It's simpler to do this here and put the URL in an attribute
        // rather than letting ACH determine and track where to go, since
        // ACH would have to handle the case of whether it was coming
        // back from a refresh (look at the attribute) or not (look at
        // the request).  We set the attribute here so that ACH can
        // always look at the attribute and ignore the request.

        String url = request.getRequestURL().toString();
        if (request.getQueryString() != null) {
            String joinQueryChar = "?";
            if (url.matches(".*[?].*")) joinQueryChar = "&";
            url = url + joinQueryChar + request.getQueryString();
        }
        // JAGaf88550: guard against cross site scripting vulnerabilities,
        // by encoding parameters that may be output to the HTML stream:
        url = StringFormatUtil.encodeHtmlEntities(url);
        session.setAttribute("achFromURL", url);

        pageContext.forward("analyze_complex_health.jsp?refresh=true&skipIfOK=true");
    }
    // else do nothing
%>

