<%--
/**
 * A list of all the currently selected objects in parmgr, whether
 * they are displayed in the current view or not.
 *
 * @version $Header: /usr/local/vse/parmgr/src/web/jsp/selected_objects.jsp,v 1.7 2008/03/05 13:11:07 sridharav Exp $
 * @risk: Low
 *
 * @task name = object list
 * cycle = post 11.23
 * phase = Design
 * owner = Nancy
 * status = In Progress
 * description = Create a page listing all selected objects in parmgr.
 */
--%>

<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>
<%@ taglib uri="/com/hp/parmgr/ui/tags/parmgr" prefix="parmgr" %>

<%@ page errorPage="exception.jsp" %>

<%@ page import="com.hp.parmgr.model.Discovery" %>
<%@ page import="com.hp.parmgr.model.HWPartition" %>
<%@ page import="com.hp.parmgr.model.Cell" %>
<%@ page import="com.hp.parmgr.model.CellSlot" %>
<%@ page import="com.hp.parmgr.model.IOChassisSlot" %>
<%@ page import="com.hp.parmgr.ui.SelectionManager" %>
<%@ page import="com.hp.parmgr.ui.tags.Util" %>
<%@ page import="com.hp.parmgr.util.IOSlotUtil" %>
<%@ page import="java.util.Iterator" %>
<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page pageEncoding="UTF-8"%>

<i18n:bundle baseName="com.hp.parmgr.ui.tags.tags" id="tagResources" />
<i18n:bundle baseName="com.hp.parmgr.ui.Parmgr" id="parmgrResources" />
<%@ include file="session_init.jsp" %>

<%
    Discovery discovery = parsession.getDiscovery();
    SelectionManager selectedCheckboxes = parsession.getSelectedCheckboxes();
    String returnURL = parsession.getFromURL();
%>

<html>
<head>
<META http-equiv="Content-Type" content="text/html;charset=UTF-8">
<meta http-equiv="expires" content="0">
<script type='text/javascript' language='JavaScript' src='<%=Util.URL_PARMGR_JS%>'></script>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_PARMGR_CSS%>'>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_MXTABLE_CSS%>'>
<title><i18n:message key="selectedObjectList.pageTitle" bundle="<%=parmgrResources%>"/></title>
</head>

<body>
<p class="subwindow-heading">
    <i18n:message key="selectedObjectList.tableTitle" bundle="<%=parmgrResources%>"/>
</p>

<%
    // Do the partitions
    if (selectedCheckboxes.getNumSelectedPartitions() > 0) {
%>
<dl>
<dt><i18n:message key="selectedObjectList.partitions" bundle="<%=parmgrResources%>"/></dt>
<%
        for (Iterator iter = selectedCheckboxes.getSelectedPartitions().iterator();
             iter.hasNext();  )
        {
            Integer parID = (Integer) iter.next();
            HWPartition partition = discovery.getPartition(parID.intValue());
            String name;
            if (partition.isErrorObject()) {
                name = partition.getLabel();
            } else {
                name = partition.getLongLabel();
            }
            String link = "partition.jsp?partition="+parID.toString();
%>

    <dd class="prop-table-data-left">
        <a class="link" target="_self" href="<%=link%>">
            <%=name%>
        </a>
    </dd>

<%
        }
%>
</dl>
<%
    } // do partitions

    // Do the cells
    if (selectedCheckboxes.getNumSelectedCells() > 0) {
%>
<dl>
<dt><i18n:message key="selectedObjectList.cells" bundle="<%=parmgrResources%>"/></dt>
<%
        for (Iterator iter = selectedCheckboxes.getSelectedCells().iterator();
             iter.hasNext();  )
        {
            Integer cellID = (Integer) iter.next();
            CellSlot slot=discovery.getCellSlot(cellID.intValue());
            if (slot.isPopulated()) {
               String link = "cell.jsp?globalID="+cellID.toString();

%>
    <dd class="prop-table-data-left">
        <a class="link" target="_self" href="<%=link%>">
            <%=slot.getLongLabel()%>
        </a>
    </dd>

<%

            } else {
%>
    <dd class="parmgr-regular-text">
        <%=slot.getLongLabel()%>&nbsp;<i18n:message key="selectedObjectList.emptyTag" bundle="<%=parmgrResources%>"/>
    </dd>
<%

            }
        }
%>
</dl>
<%
    } // do cells

    // Do the chassis
    if (selectedCheckboxes.getNumSelectedChassis() > 0) {
%>
<dl>
<dt><i18n:message key="selectedObjectList.chassis" bundle="<%=parmgrResources%>"/></dt>
<%
        for (Iterator iter = selectedCheckboxes.getSelectedChassis().iterator();
             iter.hasNext();  )
        {
            Integer chassisID = (Integer) iter.next();
            IOChassisSlot slot = discovery.getChassisSlot(chassisID.intValue());
            if (slot.isPopulated()) {
               String link = "chassis.jsp?cab="+slot.getCabinetID()+
                                          "&bay="+slot.getIOBayNumber()+
                                          "&chassis="+slot.getSlotNumber();
%>
    <dd class="prop-table-data-left">
        <a class="link" target="_self" href="<%=link%>">
            <%=slot.getLongLabel()%>
        </a>
    </dd>
<%
            } else {

%>
    <dd class="parmgr-regular-text">
        <%=slot.getLongLabel()%>&nbsp;<i18n:message key="selectedObjectList.emptyTag" bundle="<%=parmgrResources%>"/>
    </dd>
<%

            }
        }
%>
</dl>
<%
    } // do chassis

    // Do the IO slots
    if (selectedCheckboxes.getNumSelectedIOSlots() > 0) {
%>
<dl>
<dt><i18n:message key="selectedObjectList.ioSlots" bundle="<%=parmgrResources%>"/></dt>
<%
        for (Iterator iter = selectedCheckboxes.getSelectedIOSlots().iterator();
             iter.hasNext();  )
        {
            String slotID = (String) iter.next();
            IOChassisSlot chassisSlot = IOSlotUtil.getChassisSlotForIOSlot(discovery, slotID);
            String link = "chassis.jsp?selection=IO"+
                                           "&cab="+chassisSlot.getCabinetID()+
                                           "&bay="+chassisSlot.getIOBayNumber()+
                                           "&chassis="+chassisSlot.getSlotNumber();
            String name = "io slot "+slotID;
%>
    <dd class="prop-table-data-left">
        <a class="link" target="_self" href="<%=link%>">
            <%=name%>
        </a>
    </dd>
<%
        }
%>
</dl>
<%
    } // do io slots
%>

<p>
<form method="post" action="<%=returnURL%>" name="object_list_form">
<p align="left">
<input class="button" type="submit"
       value="<%=tagResources.getString("Button.OK")%>"
       name="OK" />
<%--
<input class="button" type="button"
       value="<%=tagResources.getString("Button.Help")%>"
       name="help"
       onclick="showHelp('<%=parsession.getHelpURL(pageID)%>')" />
--%>
</p>
</form>
</p>

</body>
</html>
