<jsp:useBean id="parsession" scope="session" class="com.hp.parmgr.ui.ParmgrSession" />
<i18n:bundle baseName="com.hp.parmgr.ui.Parmgr" id="parmgrBundle" />
<i18n:bundle baseName="com.hp.parmgr.ui.tags.tags" id="parmgrTagResources" />

<%@ page import="java.net.InetAddress" %>
<%@ page import="java.net.UnknownHostException" %>
<%@ page import="java.net.URLDecoder" %>
<%@ page import="java.text.MessageFormat" %>
<%@ page import="com.hp.parmgr.model.DiscoveryError" %>
<%@ page import="com.hp.parmgr.ui.tags.Util" %>
<%@ page import="com.hp.parmgr.util.LoginCredentials" %>
<%@ page import="com.hp.parmgr.util.LocalSysInfo" %>
<%@ page import="com.hp.parmgr.util.Log" %>
<%@ page import="com.hp.parmgr.util.PlatformConfig" %>
<%@ page import="com.hp.parmgr.util.StringFormatUtil" %>
<%@ page import="com.hp.vse.ui.glib.PageG" %>
<%@ page import="com.hp.vse.ui.actions.ReturnAction" %>


<%

//
// Get the VSE return URL (will only be present if running under VSE).
//
String vseReturnUrl  = request.getParameter(PageG.RETURN_FIELD);
if (vseReturnUrl != null)
{
    // Verify that a cracker user hasn't mucked with the return URL,
    // attempting to re-direct the user to a different site, etc.:
    if (!vseReturnUrl.startsWith("/")) {
        throw new IllegalStateException(
            parmgrBundle.getString("error.badArgs.str"));
    }

    String rUrl = ReturnAction.popReturnUrl(vseReturnUrl);

    // Decode any special characters in the URL, before storing:
    String decodedUrl = URLDecoder.decode(rUrl, "utf-8");
    // JAGaf88550: guard against cross site scripting vulnerabilities:
    decodedUrl = StringFormatUtil.encodeHtmlEntities(decodedUrl);
    // Store as a session attribute, used to create the "Go Back" links:
    session.setAttribute("PARMGR_RETURNURL", decodedUrl);
    // Also set this in a parsession, in case an error occurs while loading:
    parsession.setFromURL(decodedUrl);
}

// this is used to determine where parmgr is installed (parmgr.home)
if (System.getProperty("parmgr.home") == null)
{
    // @issue This method of determining where parmgr is installed
    // may not be working consistently.
    // May need to find a better way of setting parmgr.home
    // (parmgr.home is currently not used, but there
    // may be a need for this in the future).
    ServletContext ctx = session.getServletContext();
    String parmgrHome = ctx.getRealPath("/");
    System.setProperty("parmgr.home", parmgrHome);
}

//
// Initialize/update the locale used by Parmgr.
//
parsession.setLocale(parmgrBundle.getLocale());

//
// Get any gryphon and login form parameters.
//
// JAGaf88550: guard against cross site scripting vulnerabilities:
// HTML encode all parameters.  Some of these may end up getting displayed,
// and some will never be displayed.  Just encoding them all here to be safe:
String nodename =
    StringFormatUtil.encodeHtmlEntities(request.getParameter("node"));
String ipAddr =
    StringFormatUtil.encodeHtmlEntities(request.getParameter("addr"));
String deviceType =
    StringFormatUtil.encodeHtmlEntities(request.getParameter("type"));
String deviceSubtype =
    StringFormatUtil.encodeHtmlEntities(request.getParameter("subtype"));
String partitionID =
    StringFormatUtil.encodeHtmlEntities(request.getParameter("partition"));

//
// The show Login page boolean is stored in the parmgr session.  However,
// if the session gets reset the value gets lost so check for it on the
// request too.  The need for this is largely because of the session reset
// that occurs below if the SMH UUID changes.  When parmgr is running in
// SIM the UUID changes everytime the user selects a new parmgr tool
//
boolean showForm = parsession.getShowLoginPage();
String  reqShowForm = request.getParameter("showform");
if(reqShowForm != null) {
  showForm = showForm || reqShowForm.equals("true");
}

//
// Cleansweep (HPSMH) parameters
// (presence of these indicates we are running under Cleansweep):
//
// NOTE: If the SMH session UUID changes (part of the smhCookie field),
// this means that the user has logged-off & back in from the same browser.
// In this case, we need to invalidate the session, which will unbind/destroy
// the parsession bean:
//
String smhCookie = null;
Cookie[] cookies = request.getCookies();
for (int i = 0; i < cookies.length; ++i) {
    if (cookies[i].getName().equals(parsession.SMH_COOKIE_NAME)) {
        smhCookie = cookies[i].getValue();
        break;
    }
}

String smhSessionDir = request.getHeader("HPSMH-SessionDir");
String smhAuthProps  = request.getHeader("parmgr-Prop");
String oldSMHSessionID = parsession.getSMHSessionID();
parsession.setSMHSessionInfo(smhSessionDir, smhAuthProps, smhCookie);
if (oldSMHSessionID != null && !oldSMHSessionID.equalsIgnoreCase(
    parsession.getSMHSessionID()))
{
    // The SMH session has changed/user has logged out of SMH
    // reset (log out of) the parmgr session
    Log.detail(parmgrBundle.getString("parmgrSession.endParmgr.log"));
    session.invalidate();

    // redirect to reset the session
    response.sendRedirect(request.getRequestURI().toString() + "?" + request.getQueryString());

    return;
}

String smhUser = request.getHeader("username");
parsession.setSmhUser(smhUser);
// @issue: how to use this property (Unix only?)
String smhAuth = request.getHeader("userlevel");
//
// End of Cleansweep (SMH) param's
//

boolean haveFormData = false;
// JAGaf88550: guard against cross site scripting vulnerabilities:
// HTML encode all parameters.  Some of these may end up getting displayed,
// and some will never be displayed.  Just encoding them all here to be safe:
String j_wbem_host =
    StringFormatUtil.encodeHtmlEntities(request.getParameter("j_wbem_host"));
String j_wbem_username =
    StringFormatUtil.encodeHtmlEntities(request.getParameter("j_wbem_username"));
String j_wbem_password =
    StringFormatUtil.encodeHtmlEntities(request.getParameter("j_wbem_password"));
String j_sp_ip_address =
    StringFormatUtil.encodeHtmlEntities(request.getParameter("j_sp_ip_address"));
String j_ipmi_password =
    StringFormatUtil.encodeHtmlEntities(request.getParameter("j_ipmi_password"));

String wbemHost = null;
String localHost;

String remoteUser = request.getRemoteUser();
if (remoteUser == null && smhUser != null) {
    // have an SMH user name -- use it
    remoteUser = smhUser;
}
if (remoteUser == null) {
    // set a default remote user:
    if (PlatformConfig.isWindows())
        remoteUser = "";
    else
        remoteUser = "bin";
}

parsession.setServerUser(remoteUser);

LoginCredentials cred = null;

try {
    localHost = InetAddress.getLocalHost().getHostName();
}
catch (UnknownHostException e)
{
    throw new DiscoveryError(parmgrBundle.getString("login.localhost.err"), e);
}

//
// First see if the user supplied logins via the WBEM/IPMI login forms
//
if ((j_wbem_host != null) && (j_wbem_username != null) && (j_wbem_password != null))
{
    if (! j_wbem_host.equals(parsession.getWBEMHost()) ||
        ! j_wbem_username.equals(parsession.getWBEMUsername()) ||
        ! j_wbem_password.equals(parsession.getWBEMPassword()))
    {
        //
        // User supplied new WBEM login info. Disconnect and set up another connection.
        //
        parsession.disconnect();
        parsession.setIPMICredentials(null, null, false);
        parsession.setWBEMCredentials(j_wbem_host, j_wbem_username,
                                      j_wbem_password, false);
    }

    haveFormData = true;
}

if ((j_sp_ip_address != null) && (j_ipmi_password != null))
{

    if (! j_sp_ip_address.equals(parsession.getIPMIHost()) ||
        ! j_ipmi_password.equals(parsession.getIPMIPassword()))
    {
        //
        // User supplied new IPMI login info. Disconnect and set up another connection.
        //
        parsession.disconnect();
        parsession.setWBEMCredentials(null, null, null, false);
        parsession.setIPMICredentials(j_sp_ip_address, j_ipmi_password, false);
    }

    haveFormData = true;
}

//
// Next see if any node/ip information was supplied on the URL from Gryphon
//
boolean needWBEMlogin = false;
boolean needIPMIlogin = false;
boolean needSPIP = false;
boolean needEither = false;
boolean tryLocal = false;

//
// See if we got "0.0.0.0" for an IP address. This can happen if Gryphon
// doesn't have an IP for the node.
//
if (ipAddr != null && ipAddr.equals("0.0.0.0")) {
    ipAddr = null;
}


//
// If no login information was supplied via the login form, check for
// Gryphon parameters or just try local.
//
if (! haveFormData)
{
    needWBEMlogin = true;

    if ((deviceType != null) && (deviceSubtype != null)) {
        if (("Complex".equals(deviceType) && "SD".equals(deviceSubtype)) ||
            ("Mgmt Dev".equals(deviceType) && "HP SP".equals(deviceSubtype)))
        {
            //
            // The device is a complex or service processor.
            // We'll need the IPMI password and WBEM username/password.
            //
            needIPMIlogin = true;
            wbemHost = localHost;
            tryLocal = true;

            if (ipAddr == null)
            {
                //
                // We have a Complex or Service Processor node but no IP or hostname
                // for the service processor. We'll need to ask for the service
                // processor IP address.
                //
                needSPIP = true;
            }
        }
        else if ("Partition".equals(deviceType) && "nPar".equals(deviceSubtype))
        {
            //
            // The device is an nPartition. We'll need WBEM username and password.
            //
            wbemHost = nodename;
        }
        // else unrecognized device or subtype

    } // if deviceType != null && deviceSubtype != null
    else if (nodename != null)
    {

        // Check if the node is the local system
        if (parsession.isHostLocal(nodename)) {
            if (LocalSysInfo.isNpartition(parsession.getEnvironment(), remoteUser)) {
                tryLocal = true;
          }
        }
        //
        // Node was specified without device type or subtype args.
        // Assume it's a hostname.
        //
        wbemHost = nodename;

    } // if nodename != null
    else {
        //
        // No parameters to tell us what host, etc to use.
        //
        if (showForm) {
            needEither = true;
        } else if (LocalSysInfo.isNpartition(parsession.getEnvironment(), remoteUser)) {
            tryLocal = true;
        } else {
            needEither = true;
        }

        // Try the local host
        wbemHost = localHost;
    }

    //
    // Try to look up the WBEM username and password for the WBEM host if needed.
    //

    if (wbemHost != null)
    {
        if (ipAddr == null) {
            ipAddr = wbemHost;
        }

        //
        // If we're connected and were asked to connect to a different host,
        // disconnect from WBEM so we get a new connection.
        //
        if (parsession.isConnected())
        {
            if ((nodename != null) &&
                ! wbemHost.equals(parsession.getWBEMHost())) {
                parsession.disconnect();
            }
        }

        if (!parsession.isConnected())
        {

            // See if we're running in SIM as part of VSE by attempting to get the
            // credentials from the SIM database.

            Object tryDB = session.getAttribute("parmgrTryingCredDB");
            if ((tryDB != null) && tryDB.equals(wbemHost))
            {
                // Apparently we tried the user/pw from the creds database and
                // it didn't work. Don't try it again.
                session.setAttribute("parmgrTryingCredDB", null);
            }
            else
            {
            	try
            	{
                	cred = parsession.getWBEMCredentialsFromSIM(wbemHost);
            	}
            	catch (Throwable e)
            	{
                    session.setAttribute("parmgrTryingCredDB", null);
            	}
            }

            if ((cred != null))
            {
                // Got good credentials from HP SIM VSE
                session.setAttribute("parmgrTryingCredDB", wbemHost);
                parsession.setWBEMCredentials(ipAddr,
                                              cred.getWBEMUsername(),
                                              cred.getWBEMPassword(),
                                              true);
                needWBEMlogin = false;

                // Before going any further, make sure the current user has
                // read-access (applies when running under SIM/VSE only):
                // The following throws an exception if not authorized:
                parsession.verifySIMReadAuthorization();
             }
             // No HP SIM VSE credentials, try local if needed
             else if (tryLocal) {
                parsession.setWBEMCredentialsLocal();
                needWBEMlogin = false;
                cred = parsession.getLoginCredentials();
             }

        } // if !parsession.isConnected()

    } // if ! wbemHost

} // if ! haveFormData

//
// If not connected to WBEM, figure out what information we have to connect
// and prompt for what is missing.
//
if (! parsession.isConnected())
{
    if (needWBEMlogin || needIPMIlogin || needEither)
    {

        //
        // Get the URL including query string that started this all.
        //
        String queryString = request.getQueryString();
        StringBuffer url = request.getRequestURL();
        if (queryString != null) {
            url.append("?");
            url.append(request.getQueryString());
        }



        //
        // Display the appropriate forms for the missing login information.
        //
%>
<HTML>
<HEAD>
<META http-equiv="Content-Type" content="text/html;charset=UTF-8">
<%@ include file="session_keep_alive.jsp" %>
    <script type='text/javascript' language='JavaScript' src='<%=Util.URL_PARMGR_JS%>'></script>
    <link type='text/css' rel='stylesheet' href='<%=Util.URL_PARMGR_CSS%>'>
    <TITLE>Parmgr</TITLE>
</HEAD>

<BODY class="body-flush-fit" onLoad="logon_onLoad()">

<%--
nodename=<%=nodename%><BR>
ipaddr=<%=ipAddr%><BR>
deviceType=<%=deviceType%><BR>
deviceSubtype=<%=deviceSubtype%><BR>
partitionID=<%=partitionID%><BR>
wbemHost=<%=wbemHost%><BR>
localHost=<%=localHost%><BR>
cred=<%=cred%>
<P>
--%>

<SCRIPT language="JavaScript" type="text/javascript">
function fieldEmpty(value)
{
    var re=/^[ \t\n\r]*$/i;
    if (value.match(re)) {
        return true;
    }
    return false;

}
function singleOnSubmit()
{
    var msg = "<%=parmgrBundle.getString("login.wbem.password.required.error")%>";
    if (fieldEmpty(document.nparProviderLoginForm.j_wbem_password.value)) {
        document.nparProviderLoginForm.j_wbem_password.focus();
        alert(msg);
        return false;
    }
    document.getElementById("ID_LOGON").disabled = true;
    return true;
}
function nparOnSubmit()
{
    var msg = "<%=parmgrBundle.getString("login.required.field.missing.error")%>";
    if (fieldEmpty(document.nparProviderLoginForm.j_wbem_host.value)) {
        document.nparProviderLoginForm.j_wbem_host.focus();
        alert(msg);
        return false;
    }
    if (fieldEmpty(document.nparProviderLoginForm.j_wbem_username.value)) {
        document.nparProviderLoginForm.j_wbem_username.focus();
        alert(msg);
        return false;
    }
    if (fieldEmpty(document.nparProviderLoginForm.j_wbem_password.value)) {
        document.nparProviderLoginForm.j_wbem_password.focus();
        alert(msg);
        return false;
    }
    document.getElementById("ID_NPARLOGON").disabled = true;
    document.getElementById("ID_SPLOGON").disabled = true;
    return true;
}
function ipmiOnSubmit()
{
    var msg = "<%=parmgrBundle.getString("login.required.field.missing.error")%>";
    if (fieldEmpty(document.nparProviderSPLoginForm.j_sp_ip_address.value)) {
        document.nparProviderSPLoginForm.j_sp_ip_address.focus();
        alert(msg);
        return false;
    }
    if (fieldEmpty(document.nparProviderSPLoginForm.j_ipmi_password.value)) {
        document.nparProviderSPLoginForm.j_ipmi_password.focus();
        alert(msg);
        return false;
    }
    document.getElementById("ID_NPARLOGON").disabled = true;
    document.getElementById("ID_SPLOGON").disabled = true;
    return true;
}
function logon_onLoad()
{
<% if (needEither) { %>
    document.nparProviderLoginForm.j_wbem_host.focus();
<% } else { %>
    document.nparProviderLoginForm.j_wbem_password.focus();
<% } %>
}

</SCRIPT>

    <CENTER>

<%
        if (needEither) {
%>

        <TABLE class="parmgr-regular-text" border="0" cellspacing="2" cellpadding="0">
          <TR>
             <TD class="subwindow-heading" COLSPAN="2">
                <FONT SIZE="+1">
                   <i18n:message key="login.choose.prompt" bundle="<%=parmgrBundle%>" />
                </FONT>
             </TD>
          </TR>
      <FORM name="nparProviderLoginForm" method="POST" action="<%=url%>" onSubmit="return nparOnSubmit()" >
          <TR>
             <TD class="subwindow-heading" COLSPAN="2">
              <HR CLASS="separator">
              <i18n:message key="login.remotenpar.heading.label" bundle="<%=parmgrBundle%>"/>
             </TD>
          </TR>
          <TR>
             <TD><i18n:message key="login.wbem.npar.ipaddress.label" bundle="<%=parmgrBundle%>"/></td>
             <TD><input type="text" name="j_wbem_host" style="width:200"></TD>
          </TR>

          <TR>
             <TD><i18n:message key="login.wbem.npar.username.label" bundle="<%=parmgrBundle%>"/></TD>
             <TD><input type="text" name="j_wbem_username"  value="<%=(remoteUser != null)?remoteUser:""%>"style="width:200"></TD>
          </TR>

          <TR>
             <TD><i18n:message key="login.wbem.npar.password.label" bundle="<%=parmgrBundle%>"/></TD>
             <TD><input type="password" name="j_wbem_password" style="width:200"/></TD>
          </TR>
          <TR>
             <TD colspan="2" align="right">
                <input id="ID_NPARLOGON" type="submit" class="button"
                       value='<%=parmgrBundle.getString("login.remotenpar.connect.label")%>' />
             </TD>
          </TR>
      </FORM>
      <FORM name="nparProviderSPLoginForm" method="POST" action="<%=url%>" onSubmit="return ipmiOnSubmit()" >
          <TR>
             <TD class="subwindow-heading" COLSPAN="2">
               <HR CLASS="separator">
               <i18n:message key="login.remotecomplex.heading.label" bundle="<%=parmgrBundle%>"/>
               <INPUT TYPE="hidden" NAME="j_wbem_host" VALUE="<%=localHost%>"/>
               <INPUT TYPE="hidden" NAME="j_wbem_username" VALUE="<%=(remoteUser != null)?remoteUser:""%>"/>
               <INPUT TYPE="hidden" NAME="j_wbem_password" VALUE=""/>
             </TD>
          </TR>
          <TR>
             <TD><%=parmgrBundle.getString("login.complex.ipaddress.label")%></TD>
             <TD><input type="text" name="j_sp_ip_address" style="width:200"/></TD>
          </TR>
          <TR>
             <TD><%=parmgrBundle.getString("login.complex.ipmi.password.label")%></TD>
             <TD><input type="password" name="j_ipmi_password" style="width:200"/></TD>
          </TR>
          <TR>
             <TD colspan="2" align="right">
                <input id="ID_SPLOGON" type="submit" class="button"
                       value='<%=parmgrBundle.getString("login.remotecomplex.connect.label")%>' />
             </TD>
          </TR>
          <TR>
             <TD align="center" colspan="2">
                <HR CLASS="separator">
                <INPUT class="button" type="button" value='<%=parmgrBundle.getString("button.help.str")%>'
                       name="help"
                       onClick="showHelp('<%=parsession.getHelpURL("wbem")%>')" />
             </TD>
          </TR>
      </FORM>
        </TABLE>
<%
            } else { // ! needEither
%>
    <FORM name="nparProviderLoginForm" method="POST" action="<%=url%>" onSubmit="return singleOnSubmit()" >
      <TABLE class="parmgr-regular-text" border="0" cellspacing="2" cellpadding="0">

          <TR>
              <TD class="subwindow-heading" COLSPAN="2">
<%
          if (needWBEMlogin) {
              MessageFormat format = new MessageFormat(parmgrBundle.getString("login.provider.prompt.format"));
              Object [] args = { remoteUser, wbemHost };
              String prompt = format.format(args);
%>
<%=prompt%>
<%
          } else {
%>
              <INPUT TYPE="hidden" NAME="j_wbem_username" VALUE="<%=cred.getWBEMUsername()%>"/>
              <INPUT TYPE="hidden" NAME="j_wbem_password" VALUE="<%=cred.getWBEMPassword()%>"/>
<%
          }
%>
              <INPUT TYPE="hidden" NAME="j_wbem_host" VALUE="<%=wbemHost%>"/>
              </TD>
          </TR>

<%
          if (needWBEMlogin) {
%>
          <TR>
             <TD><i18n:message key="login.wbem.username.label" bundle="<%=parmgrBundle%>"/></TD>
             <TD><input type="text" name="j_wbem_username" value="<%=(remoteUser != null)?remoteUser:""%>" style="width:200"/></TD>
          </TR>
          <TR>
             <TD><i18n:message key="login.wbem.password.label" bundle="<%=parmgrBundle%>"/></td>
             <TD><input type="password" name="j_wbem_password" style="width:200"/></TD>
          </TR>
<%
          } // needWBEMlogin
%>
          <TR>
             <TD COLSPAN="2">
                &nbsp;
             </TD>
          </TR>
<%
          String loginPrompt = null;
          if (needSPIP && needIPMIlogin) {
              loginPrompt = "login.prompt.SPandIPMI.format";
          } else if (needIPMIlogin) {
              loginPrompt = "login.prompt.IPMIonly.format";
          } else if (needSPIP) {
              loginPrompt = "login.prompt.IPonly.format";
          }

          if (loginPrompt != null) {
              MessageFormat loginPromptFormat = new MessageFormat(parmgrBundle.getString(loginPrompt));
              Object [] args = { nodename };
              String prompt = loginPromptFormat.format(args);
%>
          <TR>
             <TD class="subwindow-heading" COLSPAN="2"><%=prompt%></TD>
          </TR>
<%
          } // loginPrompt != null
%>


<%
          if (needIPMIlogin) {
              if (needSPIP) {
%>
          <TR>
             <TD><i18n:message key="login.sp.ipaddress.label" bundle="<%=parmgrBundle%>"/></TD>
             <TD><input type="text" name="j_sp_ip_address" style="width:200"/></TD>
          </TR>
<%
              } // needSPIP
              else {
%>
          <INPUT type="hidden" name="j_sp_ip_address" value="<%=ipAddr%>"/>
<%
              }
%>
          <TR>
             <TD><i18n:message key="login.ipmi.password.label" bundle="<%=parmgrBundle%>"/></TD>
             <TD><input type="password" name="j_ipmi_password" style="width:200"/></TD>
          </TR>
<%
          } // needIPMIlogin

%>
          <TR>
             <TD></TD>
             <TD align="left"><input id="ID_LOGON" type="submit" class="button" value='<%=parmgrBundle.getString("login.connect.label")%>' >
              <INPUT class="button" type="button" value='<%=parmgrBundle.getString("button.help.str")%>'
                           name="help"
                           onClick="showHelp('<%=parsession.getHelpURL("wbem")%>')" />
             </TD>
          </TR>

       </TABLE>
    </FORM>
<%
        } // else ( ! needEither)
%>

    </CENTER>
<%--
    <UL>
    URL is <%=url%>
<%
        for(java.util.Enumeration e = request.getParameterNames(); e.hasMoreElements();)
        {
            String param = (String) e.nextElement();
            String val = request.getParameter(param);
%>
        <LI><%=StringFormatUtil.encodeHtmlEntities(param)%> = <%=StringFormatUtil.encodeHtmlEntities(val)%>
<%
        }

%>
    </UL>
--%>
  </BODY>
</HTML>
<%
        return; // causes parent .jsp to stop at the point this .jsp was included.

    } // if needWBEMlogin || needIPMIlogin

} // if ! parsession.isConnected()
%>
