<%--
/**
 * The "wait for" page.
 *
 * @version $Header: /usr/local/vse/parmgr/src/web/jsp/wait.jsp,v 1.11 2008/03/05 13:11:07 sridharav Exp $
 *
 * @risk medium
 */
--%>

<%@ page errorPage="exception.jsp" %>

<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>
<i18n:bundle baseName="com.hp.parmgr.util.WaitMessages" id="bundle" />

<jsp:useBean id="parsession" scope="session" class="com.hp.parmgr.ui.ParmgrSession" />

<%@ page import="com.hp.parmgr.util.WaitBean" %>
<%@ page import="com.hp.parmgr.ui.tags.Util" %>
<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page pageEncoding="UTF-8"%>

<%

//Get the wait bean from the session, if there isn't one an error occured
//and will be handled by the error page.

    WaitBean wait = parsession.getWaitBean();

    //Get the status of the wait.
    boolean waitComplete = wait.isWaitComplete();
    boolean waitFailed   = wait.assumeFailure();

%>


<HTML>
<HEAD>
<META http-equiv="Content-Type" content="text/html;charset=UTF-8">
<%@ include file="session_keep_alive.jsp" %>
<% if( ! waitComplete && ! waitFailed ) { %>
  <meta http-equiv=refresh content='<%=wait.getRefreshTime()%>'>
<%}%>
<script type='text/javascript' language='JavaScript'>

  function waitComplete() {
        window.location.replace('<%=wait.getForwardURL()%>');
  }

  function confirmCancel(forwarding, url) {

    if (window.confirm('<%=wait.getCancelConfirmMesg()%>'))
    {
        if (forwarding) {
             window.location.replace( url );
           }
           else {
             window.close();
           }
    }
  }
 function cancel(forwarding, url) {

        if (forwarding) {
             window.location.replace( url );
           }
           else {
             window.close();
           }

  }

</script>
    <script type='text/javascript' language='JavaScript'
            src='<%=Util.URL_PARMGR_JS%>'></script>
<link type='text/css' rel='stylesheet' href='<%=Util.URL_PARMGR_CSS%>'>
</HEAD>

<BODY>

<%=wait.getMessage()%>

<BR>
<FORM>
<%
    if (waitComplete) {

        if(wait.isForwarding()) {
%>
       <INPUT class="button" type="button"
              value="<%=bundle.getString("Close.button.label")%>"
              name="close"
              onclick="waitComplete()"
       />
<%
        }
        else {
%>
       <INPUT class="button" type="button"
              value="<%=bundle.getString("Close.button.label")%>"
              name="close"
              onclick="window.close()"
       />
<%
       }
    }
    else if (waitFailed) {

        //Display a cancel button.  Should either close the
        //window or forward.  No need to verify.
        if(wait.isForwarding()) {
%>

        <INPUT class="button" type="button"
               value="<%=bundle.getString("Cancel.button.label")%>"
               name="cancel"
               onclick="waitComplete()"
        />
<%
        }
        else {
%>
        <INPUT class="button" type="button"
               value="<%=bundle.getString("Cancel.button.label")%>"
               name="cancel"
               onclick="window.close()"
        />

<%
        }
    }
    else
      if (wait.isInteractive()) {
         // Display a cancel or close button

            if(!wait.isOptional()) {
%>
               <INPUT class="button" type="button"
                      value="<%=bundle.getString("Cancel.button.label")%>"
                      name="cancel"
                      onclick="confirmCancel(<%=wait.isForwarding()%>,
                                            '<%=wait.getForwardURL()%>')"
        />
<%
           }
           else {
%>
               <INPUT class="button" type="button"
                      value="<%=bundle.getString("Close.button.label")%>"
                      name="close"
                      onclick="cancel(<%=wait.isForwarding()%>,
                               '<%=wait.getForwardURL()%>')"
               />
<%
          }
      }

%>

<INPUT class="button" type="button"
       value="<%=bundle.getString("Help.button.label")%>"
       name="help"
       onclick="showHelp(
                '<%=parsession.getHelpURL(wait.getPageID())%>')"
/>

</FORM>
</BODY>
</HEAD>
</HTML>
